#!/usr/bin/env python3

def find_by_hex(code):
    matches = [x for x in dcm_attribute_table if x[0] == code].pop()
    return matches

def find_by_name(name):
    matches = [x for x in dcm_attribute_table if x[2] == name].pop()
    return matches

dcm_attribute_table = [
    (0X00000000, "UL", "CommandGroupLength"),
    (0X00000001, "UL", "CommandLengthToEnd"),
    (0X00000002, "UI", "AffectedSOPClassUID"),
    (0X00000003, "UI", "RequestedSOPClassUID"),
    (0X00000010, "SH", "CommandRecognitionCode"),
    (0X00000100, "US", "CommandField"),
    (0X00000110, "US", "MessageID"),
    (0X00000120, "US", "MessageIDBeingRespondedTo"),
    (0X00000200, "AE", "Initiator"),
    (0X00000300, "AE", "Receiver"),
    (0X00000400, "AE", "FindLocation"),
    (0X00000600, "AE", "MoveDestination"),
    (0X00000700, "US", "Priority"),
    (0X00000800, "US", "CommandDataSetType"),
    (0X00000850, "US", "NumberOfMatches"),
    (0X00000860, "US", "ResponseSequenceNumber"),
    (0X00000900, "US", "Status"),
    (0X00000901, "AT", "OffendingElement"),
    (0X00000902, "LO", "ErrorComment"),
    (0X00000903, "US", "ErrorID"),
    (0X00001000, "UI", "AffectedSOPInstanceUID"),
    (0X00001001, "UI", "RequestedSOPInstanceUID"),
    (0X00001002, "US", "EventTypeID"),
    (0X00001005, "AT", "AttributeIdentifierList"),
    (0X00001008, "US", "ActionTypeID"),
    (0X00001020, "US", "NumberOfRemainingSuboperations"),
    (0X00001021, "US", "NumberOfCompletedSuboperations"),
    (0X00001022, "US", "NumberOfFailedSuboperations"),
    (0X00001023, "US", "NumberOfWarningSuboperations"),
    (0X00001030, "AE", "MoveOriginatorApplicationEntityTitle"),
    (0X00001031, "US", "MoveOriginatorMessageID"),
    (0X00004000, "LT", "DialogReceiver"),
    (0X00004010, "LT", "TerminalType"),
    (0X00005010, "SH", "MessageSetID"),
    (0X00005020, "SH", "EndMessageID"),
    (0X00005110, "LT", "DisplayFormat"),
    (0X00005120, "LT", "PagePositionID"),
    (0X00005130, "CS", "TextFormatID"),
    (0X00005140, "CS", "NormalReverse"),
    (0X00005150, "CS", "AddGrayScale"),
    (0X00005160, "CS", "Borders"),
    (0X00005170, "IS", "Copies"),
    (0X00005180, "CS", "CommandMagnificationType"),
    (0X00005190, "CS", "Erase"),
    (0X000051A0, "CS", "Print"),
    (0X000051B0, "US", "Overlays"),
    (0X00020000, "UL", "FileMetaInformationGroupLength"),
    (0X00020001, "OB", "FileMetaInformationVersion"),
    (0X00020002, "UI", "MediaStorageSOPClassUID"),
    (0X00020003, "UI", "MediaStorageSOPInstanceUID"),
    (0X00020010, "UI", "TransferSyntaxUID"),
    (0X00020012, "UI", "ImplementationClassUID"),
    (0X00020013, "SH", "ImplementationVersionName"),
    (0X00020016, "AE", "SourceApplicationEntityTitle"),
    (0X00020017, "AE", "SendingApplicationEntityTitle"),
    (0X00020018, "AE", "ReceivingApplicationEntityTitle"),
    (0X00020026, "UR", "SourcePresentationAddress"),
    (0X00020027, "UR", "SendingPresentationAddress"),
    (0X00020028, "UR", "ReceivingPresentationAddress"),
    (0X00020031, "OB", "RTVMetaInformationVersion"),
    (0X00020032, "UI", "RTVCommunicationSOPClassUID"),
    (0X00020033, "UI", "RTVCommunicationSOPInstanceUID"),
    (0X00020035, "OB", "RTVSourceIdentifier"),
    (0X00020036, "OB", "RTVFlowIdentifier"),
    (0X00020037, "UL", "RTVFlowRTPSamplingRate"),
    (0X00020038, "FD", "RTVFlowActualFrameDuration"),
    (0X00020100, "UI", "PrivateInformationCreatorUID"),
    (0X00020102, "OB", "PrivateInformation"),
    (0X00041130, "CS", "FileSetID"),
    (0X00041141, "CS", "FileSetDescriptorFileID"),
    (0X00041142, "CS", "SpecificCharacterSetOfFileSetDescriptorFile"),
    (0X00041200, "UL", "OffsetOfTheFirstDirectoryRecordOfTheRootDirectoryEntity"),
    (0X00041202, "UL", "OffsetOfTheLastDirectoryRecordOfTheRootDirectoryEntity"),
    (0X00041212, "US", "FileSetConsistencyFlag"),
    (0X00041220, "SQ", "DirectoryRecordSequence"),
    (0X00041400, "UL", "OffsetOfTheNextDirectoryRecord"),
    (0X00041410, "US", "RecordInUseFlag"),
    (0X00041420, "UL", "OffsetOfReferencedLowerLevelDirectoryEntity"),
    (0X00041430, "CS", "DirectoryRecordType"),
    (0X00041432, "UI", "PrivateRecordUID"),
    (0X00041500, "CS", "ReferencedFileID"),
    (0X00041504, "UL", "MRDRDirectoryRecordOffset"),
    (0X00041510, "UI", "ReferencedSOPClassUIDInFile"),
    (0X00041511, "UI", "ReferencedSOPInstanceUIDInFile"),
    (0X00041512, "UI", "ReferencedTransferSyntaxUIDInFile"),
    (0X0004151A, "UI", "ReferencedRelatedGeneralSOPClassUIDInFile"),
    (0X00041600, "UL", "NumberOfReferences"),
    (0X00080000, "UL", "GenericGroupLength"),
    (0X00080001, "UL", "LengthToEnd"),
    (0X00080005, "CS", "SpecificCharacterSet"),
    (0X00080006, "SQ", "LanguageCodeSequence"),
    (0X00080008, "CS", "ImageType"),
    (0X00080010, "SH", "RecognitionCode"),
    (0X00080012, "DA", "InstanceCreationDate"),
    (0X00080013, "TM", "InstanceCreationTime"),
    (0X00080014, "UI", "InstanceCreatorUID"),
    (0X00080015, "DT", "InstanceCoercionDateTime"),
    (0X00080016, "UI", "SOPClassUID"),
    (0X00080017, "UI", "AcquisitionUID"),
    (0X00080018, "UI", "SOPInstanceUID"),
    (0X00080019, "UI", "PyramidUID"),
    (0X0008001A, "UI", "RelatedGeneralSOPClassUID"),
    (0X0008001B, "UI", "OriginalSpecializedSOPClassUID"),
    (0X00080020, "DA", "StudyDate"),
    (0X00080021, "DA", "SeriesDate"),
    (0X00080022, "DA", "AcquisitionDate"),
    (0X00080023, "DA", "ContentDate"),
    (0X00080024, "DA", "OverlayDate"),
    (0X00080025, "DA", "CurveDate"),
    (0X0008002A, "DT", "AcquisitionDateTime"),
    (0X00080030, "TM", "StudyTime"),
    (0X00080031, "TM", "SeriesTime"),
    (0X00080032, "TM", "AcquisitionTime"),
    (0X00080033, "TM", "ContentTime"),
    (0X00080034, "TM", "OverlayTime"),
    (0X00080035, "TM", "CurveTime"),
    (0X00080040, "US", "DataSetType"),
    (0X00080041, "LO", "DataSetSubtype"),
    (0X00080042, "CS", "NuclearMedicineSeriesType"),
    (0X00080050, "SH", "AccessionNumber"),
    (0X00080051, "SQ", "IssuerOfAccessionNumberSequence"),
    (0X00080052, "CS", "QueryRetrieveLevel"),
    (0X00080053, "CS", "QueryRetrieveView"),
    (0X00080054, "AE", "RetrieveAETitle"),
    (0X00080055, "AE", "StationAETitle"),
    (0X00080056, "CS", "InstanceAvailability"),
    (0X00080058, "UI", "FailedSOPInstanceUIDList"),
    (0X00080060, "CS", "Modality"),
    (0X00080061, "CS", "ModalitiesInStudy"),
    (0X00080062, "UI", "SOPClassesInStudy"),
    (0X00080063, "SQ", "AnatomicRegionsInStudyCodeSequence"),
    (0X00080064, "CS", "ConversionType"),
    (0X00080068, "CS", "PresentationIntentType"),
    (0X00080070, "LO", "Manufacturer"),
    (0X00080080, "LO", "InstitutionName"),
    (0X00080081, "ST", "InstitutionAddress"),
    (0X00080082, "SQ", "InstitutionCodeSequence"),
    (0X00080090, "PN", "ReferringPhysicianName"),
    (0X00080092, "ST", "ReferringPhysicianAddress"),
    (0X00080094, "SH", "ReferringPhysicianTelephoneNumbers"),
    (0X00080096, "SQ", "ReferringPhysicianIdentificationSequence"),
    (0X0008009C, "PN", "ConsultingPhysicianName"),
    (0X0008009D, "SQ", "ConsultingPhysicianIdentificationSequence"),
    (0X00080100, "SH", "CodeValue"),
    (0X00080101, "LO", "ExtendedCodeValue"),
    (0X00080102, "SH", "CodingSchemeDesignator"),
    (0X00080103, "SH", "CodingSchemeVersion"),
    (0X00080104, "LO", "CodeMeaning"),
    (0X00080105, "CS", "MappingResource"),
    (0X00080106, "DT", "ContextGroupVersion"),
    (0X00080107, "DT", "ContextGroupLocalVersion"),
    (0X00080108, "LT", "ExtendedCodeMeaning"),
    (0X00080109, "SQ", "CodingSchemeResourcesSequence"),
    (0X0008010A, "CS", "CodingSchemeURLType"),
    (0X0008010B, "CS", "ContextGroupExtensionFlag"),
    (0X0008010C, "UI", "CodingSchemeUID"),
    (0X0008010D, "UI", "ContextGroupExtensionCreatorUID"),
    (0X0008010E, "UR", "CodingSchemeURL"),
    (0X0008010F, "CS", "ContextIdentifier"),
    (0X00080110, "SQ", "CodingSchemeIdentificationSequence"),
    (0X00080112, "LO", "CodingSchemeRegistry"),
    (0X00080114, "ST", "CodingSchemeExternalID"),
    (0X00080115, "ST", "CodingSchemeName"),
    (0X00080116, "ST", "CodingSchemeResponsibleOrganization"),
    (0X00080117, "UI", "ContextUID"),
    (0X00080118, "UI", "MappingResourceUID"),
    (0X00080119, "UC", "LongCodeValue"),
    (0X00080120, "UR", "URNCodeValue"),
    (0X00080121, "SQ", "EquivalentCodeSequence"),
    (0X00080122, "LO", "MappingResourceName"),
    (0X00080123, "SQ", "ContextGroupIdentificationSequence"),
    (0X00080124, "SQ", "MappingResourceIdentificationSequence"),
    (0X00080201, "SH", "TimezoneOffsetFromUTC"),
    (0X00080202, "OB", ""),
    (0X00080220, "SQ", "ResponsibleGroupCodeSequence"),
    (0X00080221, "CS", "EquipmentModality"),
    (0X00080222, "LO", "ManufacturerRelatedModelGroup"),
    (0X00080300, "SQ", "PrivateDataElementCharacteristicsSequence"),
    (0X00080301, "US", "PrivateGroupReference"),
    (0X00080302, "LO", "PrivateCreatorReference"),
    (0X00080303, "CS", "BlockIdentifyingInformationStatus"),
    (0X00080304, "US", "NonidentifyingPrivateElements"),
    (0X00080305, "SQ", "DeidentificationActionSequence"),
    (0X00080306, "US", "IdentifyingPrivateElements"),
    (0X00080307, "CS", "DeidentificationAction"),
    (0X00080308, "US", "PrivateDataElement"),
    (0X00080309, "UL", "PrivateDataElementValueMultiplicity"),
    (0X0008030A, "CS", "PrivateDataElementValueRepresentation"),
    (0X0008030B, "UL", "PrivateDataElementNumberOfItems"),
    (0X0008030C, "UC", "PrivateDataElementName"),
    (0X0008030D, "UC", "PrivateDataElementKeyword"),
    (0X0008030E, "UT", "PrivateDataElementDescription"),
    (0X0008030F, "UT", "PrivateDataElementEncoding"),
    (0X00080310, "SQ", "PrivateDataElementDefinitionSequence"),
    (0X00081000, "AE", "NetworkID"),
    (0X00081010, "SH", "StationName"),
    (0X00081030, "LO", "StudyDescription"),
    (0X00081032, "SQ", "ProcedureCodeSequence"),
    (0X0008103E, "LO", "SeriesDescription"),
    (0X0008103F, "SQ", "SeriesDescriptionCodeSequence"),
    (0X00081040, "LO", "InstitutionalDepartmentName"),
    (0X00081041, "SQ", "InstitutionalDepartmentTypeCodeSequence"),
    (0X00081048, "PN", "PhysiciansOfRecord"),
    (0X00081049, "SQ", "PhysiciansOfRecordIdentificationSequence"),
    (0X00081050, "PN", "PerformingPhysicianName"),
    (0X00081052, "SQ", "PerformingPhysicianIdentificationSequence"),
    (0X00081060, "PN", "NameOfPhysiciansReadingStudy"),
    (0X00081062, "SQ", "PhysiciansReadingStudyIdentificationSequence"),
    (0X00081070, "PN", "OperatorsName"),
    (0X00081072, "SQ", "OperatorIdentificationSequence"),
    (0X00081080, "LO", "AdmittingDiagnosesDescription"),
    (0X00081084, "SQ", "AdmittingDiagnosesCodeSequence"),
    (0X00081090, "LO", "ManufacturerModelName"),
    (0X00081100, "SQ", "ReferencedResultsSequence"),
    (0X00081110, "SQ", "ReferencedStudySequence"),
    (0X00081111, "SQ", "ReferencedPerformedProcedureStepSequence"),
    (0X00081115, "SQ", "ReferencedSeriesSequence"),
    (0X00081120, "SQ", "ReferencedPatientSequence"),
    (0X00081125, "SQ", "ReferencedVisitSequence"),
    (0X00081130, "SQ", "ReferencedOverlaySequence"),
    (0X00081134, "SQ", "ReferencedStereometricInstanceSequence"),
    (0X0008113A, "SQ", "ReferencedWaveformSequence"),
    (0X00081140, "SQ", "ReferencedImageSequence"),
    (0X00081145, "SQ", "ReferencedCurveSequence"),
    (0X0008114A, "SQ", "ReferencedInstanceSequence"),
    (0X0008114B, "SQ", "ReferencedRealWorldValueMappingInstanceSequence"),
    (0X00081150, "UI", "ReferencedSOPClassUID"),
    (0X00081155, "UI", "ReferencedSOPInstanceUID"),
    (0X00081156, "SQ", "DefinitionSourceSequence"),
    (0X0008115A, "UI", "SOPClassesSupported"),
    (0X00081160, "IS", "ReferencedFrameNumber"),
    (0X00081161, "UL", "SimpleFrameList"),
    (0X00081162, "UL", "CalculatedFrameList"),
    (0X00081163, "FD", "TimeRange"),
    (0X00081164, "SQ", "FrameExtractionSequence"),
    (0X00081167, "UI", "MultiFrameSourceSOPInstanceUID"),
    (0X00081190, "UR", "RetrieveURL"),
    (0X00081195, "UI", "TransactionUID"),
    (0X00081196, "US", "WarningReason"),
    (0X00081197, "US", "FailureReason"),
    (0X00081198, "SQ", "FailedSOPSequence"),
    (0X00081199, "SQ", "ReferencedSOPSequence"),
    (0X0008119A, "SQ", "OtherFailuresSequence"),
    (0X00081200, "SQ", "StudiesContainingOtherReferencedInstancesSequence"),
    (0X00081250, "SQ", "RelatedSeriesSequence"),
    (0X00082110, "CS", "LossyImageCompressionRetired"),
    (0X00082111, "ST", "DerivationDescription"),
    (0X00082112, "SQ", "SourceImageSequence"),
    (0X00082120, "SH", "StageName"),
    (0X00082122, "IS", "StageNumber"),
    (0X00082124, "IS", "NumberOfStages"),
    (0X00082127, "SH", "ViewName"),
    (0X00082128, "IS", "ViewNumber"),
    (0X00082129, "IS", "NumberOfEventTimers"),
    (0X0008212A, "IS", "NumberOfViewsInStage"),
    (0X00082130, "DS", "EventElapsedTimes"),
    (0X00082132, "LO", "EventTimerNames"),
    (0X00082133, "SQ", "EventTimerSequence"),
    (0X00082134, "FD", "EventTimeOffset"),
    (0X00082135, "SQ", "EventCodeSequence"),
    (0X00082142, "IS", "StartTrim"),
    (0X00082143, "IS", "StopTrim"),
    (0X00082144, "IS", "RecommendedDisplayFrameRate"),
    (0X00082200, "CS", "TransducerPosition"),
    (0X00082204, "CS", "TransducerOrientation"),
    (0X00082208, "CS", "AnatomicStructure"),
    (0X00082218, "SQ", "AnatomicRegionSequence"),
    (0X00082220, "SQ", "AnatomicRegionModifierSequence"),
    (0X00082228, "SQ", "PrimaryAnatomicStructureSequence"),
    (0X00082229, "SQ", "AnatomicStructureSpaceOrRegionSequence"),
    (0X00082230, "SQ", "PrimaryAnatomicStructureModifierSequence"),
    (0X00082240, "SQ", "TransducerPositionSequence"),
    (0X00082242, "SQ", "TransducerPositionModifierSequence"),
    (0X00082244, "SQ", "TransducerOrientationSequence"),
    (0X00082246, "SQ", "TransducerOrientationModifierSequence"),
    (0X00082251, "SQ", "AnatomicStructureSpaceOrRegionCodeSequenceTrial"),
    (0X00082253, "SQ", "AnatomicPortalOfEntranceCodeSequenceTrial"),
    (0X00082255, "SQ", "AnatomicApproachDirectionCodeSequenceTrial"),
    (0X00082256, "ST", "AnatomicPerspectiveDescriptionTrial"),
    (0X00082257, "SQ", "AnatomicPerspectiveCodeSequenceTrial"),
    (0X00082258, "ST", "AnatomicLocationOfExaminingInstrumentDescriptionTrial"),
    (0X00082259, "SQ", "AnatomicLocationOfExaminingInstrumentCodeSequenceTrial"),
    (0X0008225A, "SQ", "AnatomicStructureSpaceOrRegionModifierCodeSequenceTrial"),
    (0X0008225C, "SQ", "OnAxisBackgroundAnatomicStructureCodeSequenceTrial"),
    (0X00083001, "SQ", "AlternateRepresentationSequence"),
    (0X00083002, "UI", "AvailableTransferSyntaxUID"),
    (0X00083010, "UI", "IrradiationEventUID"),
    (0X00083011, "SQ", "SourceIrradiationEventSequence"),
    (0X00083012, "UI", "RadiopharmaceuticalAdministrationEventUID"),
    (0X00084000, "LT", "IdentifyingComments"),
    (0X00089007, "CS", "FrameType"),
    (0X00089092, "SQ", "ReferencedImageEvidenceSequence"),
    (0X00089121, "SQ", "ReferencedRawDataSequence"),
    (0X00089123, "UI", "CreatorVersionUID"),
    (0X00089124, "SQ", "DerivationImageSequence"),
    (0X00089154, "SQ", "SourceImageEvidenceSequence"),
    (0X00089205, "CS", "PixelPresentation"),
    (0X00089206, "CS", "VolumetricProperties"),
    (0X00089207, "CS", "VolumeBasedCalculationTechnique"),
    (0X00089208, "CS", "ComplexImageComponent"),
    (0X00089209, "CS", "AcquisitionContrast"),
    (0X00089215, "SQ", "DerivationCodeSequence"),
    (0X00089237, "SQ", "ReferencedPresentationStateSequence"),
    (0X00089410, "SQ", "ReferencedOtherPlaneSequence"),
    (0X00089458, "SQ", "FrameDisplaySequence"),
    (0X00089459, "FL", "RecommendedDisplayFrameRateInFloat"),
    (0X00089460, "CS", "SkipFrameRangeFlag"),
    (0X00090010, "LO", "PrivateCreator"),
    (0X00100010, "PN", "PatientName"),
    (0X00100020, "LO", "PatientID"),
    (0X00100021, "LO", "IssuerOfPatientID"),
    (0X00100022, "CS", "TypeOfPatientID"),
    (0X00100024, "SQ", "IssuerOfPatientIDQualifiersSequence"),
    (0X00100026, "SQ", "SourcePatientGroupIdentificationSequence"),
    (0X00100027, "SQ", "GroupOfPatientsIdentificationSequence"),
    (0X00100028, "US", "SubjectRelativePositionInImage"),
    (0X00100030, "DA", "PatientBirthDate"),
    (0X00100032, "TM", "PatientBirthTime"),
    (0X00100033, "LO", "PatientBirthDateInAlternativeCalendar"),
    (0X00100034, "LO", "PatientDeathDateInAlternativeCalendar"),
    (0X00100035, "CS", "PatientAlternativeCalendar"),
    (0X00100040, "CS", "PatientSex"),
    (0X00100050, "SQ", "PatientInsurancePlanCodeSequence"),
    (0X00100101, "SQ", "PatientPrimaryLanguageCodeSequence"),
    (0X00100102, "SQ", "PatientPrimaryLanguageModifierCodeSequence"),
    (0X00100200, "CS", "QualityControlSubject"),
    (0X00100201, "SQ", "QualityControlSubjectTypeCodeSequence"),
    (0X00100212, "UC", "StrainDescription"),
    (0X00100213, "LO", "StrainNomenclature"),
    (0X00100214, "LO", "StrainStockNumber"),
    (0X00100215, "SQ", "StrainSourceRegistryCodeSequence"),
    (0X00100216, "SQ", "StrainStockSequence"),
    (0X00100217, "LO", "StrainSource"),
    (0X00100218, "UT", "StrainAdditionalInformation"),
    (0X00100219, "SQ", "StrainCodeSequence"),
    (0X00100221, "SQ", "GeneticModificationsSequence"),
    (0X00100222, "UC", "GeneticModificationsDescription"),
    (0X00100223, "LO", "GeneticModificationsNomenclature"),
    (0X00100229, "SQ", "GeneticModificationsCodeSequence"),
    (0X00101000, "LO", "OtherPatientIDs"),
    (0X00101001, "PN", "OtherPatientNames"),
    (0X00101002, "SQ", "OtherPatientIDsSequence"),
    (0X00101005, "PN", "PatientBirthName"),
    (0X00101010, "AS", "PatientAge"),
    (0X00101020, "DS", "PatientSize"),
    (0X00101021, "SQ", "PatientSizeCodeSequence"),
    (0X00101022, "DS", "PatientBodyMassIndex"),
    (0X00101023, "DS", "MeasuredAPDimension"),
    (0X00101024, "DS", "MeasuredLateralDimension"),
    (0X00101030, "DS", "PatientWeight"),
    (0X00101040, "LO", "PatientAddress"),
    (0X00101050, "LO", "InsurancePlanIdentification"),
    (0X00101060, "PN", "PatientMotherBirthName"),
    (0X00101080, "LO", "MilitaryRank"),
    (0X00101081, "LO", "BranchOfService"),
    (0X00101090, "LO", "MedicalRecordLocator"),
    (0X00101100, "SQ", "ReferencedPatientPhotoSequence"),
    (0X00102000, "LO", "MedicalAlerts"),
    (0X00102110, "LO", "Allergies"),
    (0X00102150, "LO", "CountryOfResidence"),
    (0X00102152, "LO", "RegionOfResidence"),
    (0X00102154, "SH", "PatientTelephoneNumbers"),
    (0X00102155, "LT", "PatientTelecomInformation"),
    (0X00102160, "SH", "EthnicGroup"),
    (0X00102180, "SH", "Occupation"),
    (0X001021A0, "CS", "SmokingStatus"),
    (0X001021B0, "LT", "AdditionalPatientHistory"),
    (0X001021C0, "US", "PregnancyStatus"),
    (0X001021D0, "DA", "LastMenstrualDate"),
    (0X001021F0, "LO", "PatientReligiousPreference"),
    (0X00102201, "LO", "PatientSpeciesDescription"),
    (0X00102202, "SQ", "PatientSpeciesCodeSequence"),
    (0X00102203, "CS", "PatientSexNeutered"),
    (0X00102210, "CS", "AnatomicalOrientationType"),
    (0X00102292, "LO", "PatientBreedDescription"),
    (0X00102293, "SQ", "PatientBreedCodeSequence"),
    (0X00102294, "SQ", "BreedRegistrationSequence"),
    (0X00102295, "LO", "BreedRegistrationNumber"),
    (0X00102296, "SQ", "BreedRegistryCodeSequence"),
    (0X00102297, "PN", "ResponsiblePerson"),
    (0X00102298, "CS", "ResponsiblePersonRole"),
    (0X00102299, "LO", "ResponsibleOrganization"),
    (0X00104000, "LT", "PatientComments"),
    (0X00109431, "FL", "ExaminedBodyThickness"),
    (0X00120010, "LO", "ClinicalTrialSponsorName"),
    (0X00120020, "LO", "ClinicalTrialProtocolID"),
    (0X00120021, "LO", "ClinicalTrialProtocolName"),
    (0X00120030, "LO", "ClinicalTrialSiteID"),
    (0X00120031, "LO", "ClinicalTrialSiteName"),
    (0X00120040, "LO", "ClinicalTrialSubjectID"),
    (0X00120042, "LO", "ClinicalTrialSubjectReadingID"),
    (0X00120050, "LO", "ClinicalTrialTimePointID"),
    (0X00120051, "ST", "ClinicalTrialTimePointDescription"),
    (0X00120052, "FD", "LongitudinalTemporalOffsetFromEvent"),
    (0X00120053, "CS", "LongitudinalTemporalEventType"),
    (0X00120060, "LO", "ClinicalTrialCoordinatingCenterName"),
    (0X00120062, "CS", "PatientIdentityRemoved"),
    (0X00120063, "LO", "DeidentificationMethod"),
    (0X00120064, "SQ", "DeidentificationMethodCodeSequence"),
    (0X00120071, "LO", "ClinicalTrialSeriesID"),
    (0X00120072, "LO", "ClinicalTrialSeriesDescription"),
    (0X00120081, "LO", "ClinicalTrialProtocolEthicsCommitteeName"),
    (0X00120082, "LO", "ClinicalTrialProtocolEthicsCommitteeApprovalNumber"),
    (0X00120083, "SQ", "ConsentForClinicalTrialUseSequence"),
    (0X00120084, "CS", "DistributionType"),
    (0X00120085, "CS", "ConsentForDistributionFlag"),
    (0X00120086, "DA", "EthicsCommitteeApprovalEffectivenessStartDate"),
    (0X00120087, "DA", "EthicsCommitteeApprovalEffectivenessEndDate"),
    (0X00140023, "ST", "CADFileFormat"),
    (0X00140024, "ST", "ComponentReferenceSystem"),
    (0X00140025, "ST", "ComponentManufacturingProcedure"),
    (0X00140028, "ST", "ComponentManufacturer"),
    (0X00140030, "DS", "MaterialThickness"),
    (0X00140032, "DS", "MaterialPipeDiameter"),
    (0X00140034, "DS", "MaterialIsolationDiameter"),
    (0X00140042, "ST", "MaterialGrade"),
    (0X00140044, "ST", "MaterialPropertiesDescription"),
    (0X00140045, "ST", "MaterialPropertiesFileFormatRetired"),
    (0X00140046, "LT", "MaterialNotes"),
    (0X00140050, "CS", "ComponentShape"),
    (0X00140052, "CS", "CurvatureType"),
    (0X00140054, "DS", "OuterDiameter"),
    (0X00140056, "DS", "InnerDiameter"),
    (0X00140100, "LO", "ComponentWelderIDs"),
    (0X00140101, "CS", "SecondaryApprovalStatus"),
    (0X00140102, "DA", "SecondaryReviewDate"),
    (0X00140103, "TM", "SecondaryReviewTime"),
    (0X00140104, "PN", "SecondaryReviewerName"),
    (0X00140105, "ST", "RepairID"),
    (0X00140106, "SQ", "MultipleComponentApprovalSequence"),
    (0X00140107, "CS", "OtherApprovalStatus"),
    (0X00140108, "CS", "OtherSecondaryApprovalStatus"),
    (0X00141010, "ST", "ActualEnvironmentalConditions"),
    (0X00141020, "DA", "ExpiryDate"),
    (0X00141040, "ST", "EnvironmentalConditions"),
    (0X00142002, "SQ", "EvaluatorSequence"),
    (0X00142004, "IS", "EvaluatorNumber"),
    (0X00142006, "PN", "EvaluatorName"),
    (0X00142008, "IS", "EvaluationAttempt"),
    (0X00142012, "SQ", "IndicationSequence"),
    (0X00142014, "IS", "IndicationNumber"),
    (0X00142016, "SH", "IndicationLabel"),
    (0X00142018, "ST", "IndicationDescription"),
    (0X0014201A, "CS", "IndicationType"),
    (0X0014201C, "CS", "IndicationDisposition"),
    (0X0014201E, "SQ", "IndicationROISequence"),
    (0X00142030, "SQ", "IndicationPhysicalPropertySequence"),
    (0X00142032, "SH", "PropertyLabel"),
    (0X00142202, "IS", "CoordinateSystemNumberOfAxes"),
    (0X00142204, "SQ", "CoordinateSystemAxesSequence"),
    (0X00142206, "ST", "CoordinateSystemAxisDescription"),
    (0X00142208, "CS", "CoordinateSystemDataSetMapping"),
    (0X0014220A, "IS", "CoordinateSystemAxisNumber"),
    (0X0014220C, "CS", "CoordinateSystemAxisType"),
    (0X0014220E, "CS", "CoordinateSystemAxisUnits"),
    (0X00142210, "OB", "CoordinateSystemAxisValues"),
    (0X00142220, "SQ", "CoordinateSystemTransformSequence"),
    (0X00142222, "ST", "TransformDescription"),
    (0X00142224, "IS", "TransformNumberOfAxes"),
    (0X00142226, "IS", "TransformOrderOfAxes"),
    (0X00142228, "CS", "TransformedAxisUnits"),
    (0X0014222A, "DS", "CoordinateSystemTransformRotationAndScaleMatrix"),
    (0X0014222C, "DS", "CoordinateSystemTransformTranslationMatrix"),
    (0X00143011, "DS", "InternalDetectorFrameTime"),
    (0X00143012, "DS", "NumberOfFramesIntegrated"),
    (0X00143020, "SQ", "DetectorTemperatureSequence"),
    (0X00143022, "ST", "SensorName"),
    (0X00143024, "DS", "HorizontalOffsetOfSensor"),
    (0X00143026, "DS", "VerticalOffsetOfSensor"),
    (0X00143028, "DS", "SensorTemperature"),
    (0X00143040, "SQ", "DarkCurrentSequence"),
    (0X00143050, "OW", "DarkCurrentCounts"),
    (0X00143060, "SQ", "GainCorrectionReferenceSequence"),
    (0X00143070, "OW", "AirCounts"),
    (0X00143071, "DS", "KVUsedInGainCalibration"),
    (0X00143072, "DS", "MAUsedInGainCalibration"),
    (0X00143073, "DS", "NumberOfFramesUsedForIntegration"),
    (0X00143074, "LO", "FilterMaterialUsedInGainCalibration"),
    (0X00143075, "DS", "FilterThicknessUsedInGainCalibration"),
    (0X00143076, "DA", "DateOfGainCalibration"),
    (0X00143077, "TM", "TimeOfGainCalibration"),
    (0X00143080, "OB", "BadPixelImage"),
    (0X00143099, "LT", "CalibrationNotes"),
    (0X00143100, "LT", "LinearityCorrectionTechnique"),
    (0X00143101, "LT", "BeamHardeningCorrectionTechnique"),
    (0X00144002, "SQ", "PulserEquipmentSequence"),
    (0X00144004, "CS", "PulserType"),
    (0X00144006, "LT", "PulserNotes"),
    (0X00144008, "SQ", "ReceiverEquipmentSequence"),
    (0X0014400A, "CS", "AmplifierType"),
    (0X0014400C, "LT", "ReceiverNotes"),
    (0X0014400E, "SQ", "PreAmplifierEquipmentSequence"),
    (0X0014400F, "LT", "PreAmplifierNotes"),
    (0X00144010, "SQ", "TransmitTransducerSequence"),
    (0X00144011, "SQ", "ReceiveTransducerSequence"),
    (0X00144012, "US", "NumberOfElements"),
    (0X00144013, "CS", "ElementShape"),
    (0X00144014, "DS", "ElementDimensionA"),
    (0X00144015, "DS", "ElementDimensionB"),
    (0X00144016, "DS", "ElementPitchA"),
    (0X00144017, "DS", "MeasuredBeamDimensionA"),
    (0X00144018, "DS", "MeasuredBeamDimensionB"),
    (0X00144019, "DS", "LocationOfMeasuredBeamDiameter"),
    (0X0014401A, "DS", "NominalFrequency"),
    (0X0014401B, "DS", "MeasuredCenterFrequency"),
    (0X0014401C, "DS", "MeasuredBandwidth"),
    (0X0014401D, "DS", "ElementPitchB"),
    (0X00144020, "SQ", "PulserSettingsSequence"),
    (0X00144022, "DS", "PulseWidth"),
    (0X00144024, "DS", "ExcitationFrequency"),
    (0X00144026, "CS", "ModulationType"),
    (0X00144028, "DS", "Damping"),
    (0X00144030, "SQ", "ReceiverSettingsSequence"),
    (0X00144031, "DS", "AcquiredSoundpathLength"),
    (0X00144032, "CS", "AcquisitionCompressionType"),
    (0X00144033, "IS", "AcquisitionSampleSize"),
    (0X00144034, "DS", "RectifierSmoothing"),
    (0X00144035, "SQ", "DACSequence"),
    (0X00144036, "CS", "DACType"),
    (0X00144038, "DS", "DACGainPoints"),
    (0X0014403A, "DS", "DACTimePoints"),
    (0X0014403C, "DS", "DACAmplitude"),
    (0X00144040, "SQ", "PreAmplifierSettingsSequence"),
    (0X00144050, "SQ", "TransmitTransducerSettingsSequence"),
    (0X00144051, "SQ", "ReceiveTransducerSettingsSequence"),
    (0X00144052, "DS", "IncidentAngle"),
    (0X00144054, "ST", "CouplingTechnique"),
    (0X00144056, "ST", "CouplingMedium"),
    (0X00144057, "DS", "CouplingVelocity"),
    (0X00144058, "DS", "ProbeCenterLocationX"),
    (0X00144059, "DS", "ProbeCenterLocationZ"),
    (0X0014405A, "DS", "SoundPathLength"),
    (0X0014405C, "ST", "DelayLawIdentifier"),
    (0X00144060, "SQ", "GateSettingsSequence"),
    (0X00144062, "DS", "GateThreshold"),
    (0X00144064, "DS", "VelocityOfSound"),
    (0X00144070, "SQ", "CalibrationSettingsSequence"),
    (0X00144072, "ST", "CalibrationProcedure"),
    (0X00144074, "SH", "ProcedureVersion"),
    (0X00144076, "DA", "ProcedureCreationDate"),
    (0X00144078, "DA", "ProcedureExpirationDate"),
    (0X0014407A, "DA", "ProcedureLastModifiedDate"),
    (0X0014407C, "TM", "CalibrationTime"),
    (0X0014407E, "DA", "CalibrationDate"),
    (0X00144080, "SQ", "ProbeDriveEquipmentSequence"),
    (0X00144081, "CS", "DriveType"),
    (0X00144082, "LT", "ProbeDriveNotes"),
    (0X00144083, "SQ", "DriveProbeSequence"),
    (0X00144084, "DS", "ProbeInductance"),
    (0X00144085, "DS", "ProbeResistance"),
    (0X00144086, "SQ", "ReceiveProbeSequence"),
    (0X00144087, "SQ", "ProbeDriveSettingsSequence"),
    (0X00144088, "DS", "BridgeResistors"),
    (0X00144089, "DS", "ProbeOrientationAngle"),
    (0X0014408B, "DS", "UserSelectedGainY"),
    (0X0014408C, "DS", "UserSelectedPhase"),
    (0X0014408D, "DS", "UserSelectedOffsetX"),
    (0X0014408E, "DS", "UserSelectedOffsetY"),
    (0X00144091, "SQ", "ChannelSettingsSequence"),
    (0X00144092, "DS", "ChannelThreshold"),
    (0X0014409A, "SQ", "ScannerSettingsSequence"),
    (0X0014409B, "ST", "ScanProcedure"),
    (0X0014409C, "DS", "TranslationRateX"),
    (0X0014409D, "DS", "TranslationRateY"),
    (0X0014409F, "DS", "ChannelOverlap"),
    (0X001440A0, "LO", "ImageQualityIndicatorType"),
    (0X001440A1, "LO", "ImageQualityIndicatorMaterial"),
    (0X001440A2, "LO", "ImageQualityIndicatorSize"),
    (0X00145002, "IS", "LINACEnergy"),
    (0X00145004, "IS", "LINACOutput"),
    (0X00145100, "US", "ActiveAperture"),
    (0X00145101, "DS", "TotalAperture"),
    (0X00145102, "DS", "ApertureElevation"),
    (0X00145103, "DS", "MainLobeAngle"),
    (0X00145104, "DS", "MainRoofAngle"),
    (0X00145105, "CS", "ConnectorType"),
    (0X00145106, "SH", "WedgeModelNumber"),
    (0X00145107, "DS", "WedgeAngleFloat"),
    (0X00145108, "DS", "WedgeRoofAngle"),
    (0X00145109, "CS", "WedgeElement1Position"),
    (0X0014510A, "DS", "WedgeMaterialVelocity"),
    (0X0014510B, "SH", "WedgeMaterial"),
    (0X0014510C, "DS", "WedgeOffsetZ"),
    (0X0014510D, "DS", "WedgeOriginOffsetX"),
    (0X0014510E, "DS", "WedgeTimeDelay"),
    (0X0014510F, "SH", "WedgeName"),
    (0X00145110, "SH", "WedgeManufacturerName"),
    (0X00145111, "LO", "WedgeDescription"),
    (0X00145112, "DS", "NominalBeamAngle"),
    (0X00145113, "DS", "WedgeOffsetX"),
    (0X00145114, "DS", "WedgeOffsetY"),
    (0X00145115, "DS", "WedgeTotalLength"),
    (0X00145116, "DS", "WedgeInContactLength"),
    (0X00145117, "DS", "WedgeFrontGap"),
    (0X00145118, "DS", "WedgeTotalHeight"),
    (0X00145119, "DS", "WedgeFrontHeight"),
    (0X0014511A, "DS", "WedgeRearHeight"),
    (0X0014511B, "DS", "WedgeTotalWidth"),
    (0X0014511C, "DS", "WedgeInContactWidth"),
    (0X0014511D, "DS", "WedgeChamferHeight"),
    (0X0014511E, "CS", "WedgeCurve"),
    (0X0014511F, "DS", "RadiusAlongWedge"),
    (0X00160001, "DS", "WhitePoint"),
    (0X00160002, "DS", "PrimaryChromaticities"),
    (0X00160003, "UT", "BatteryLevel"),
    (0X00160004, "DS", "ExposureTimeInSeconds"),
    (0X00160005, "DS", "FNumber"),
    (0X00160006, "IS", "OECFRows"),
    (0X00160007, "IS", "OECFColumns"),
    (0X00160008, "UC", "OECFColumnNames"),
    (0X00160009, "DS", "OECFValues"),
    (0X0016000A, "IS", "SpatialFrequencyResponseRows"),
    (0X0016000B, "IS", "SpatialFrequencyResponseColumns"),
    (0X0016000C, "UC", "SpatialFrequencyResponseColumnNames"),
    (0X0016000D, "DS", "SpatialFrequencyResponseValues"),
    (0X0016000E, "IS", "ColorFilterArrayPatternRows"),
    (0X0016000F, "IS", "ColorFilterArrayPatternColumns"),
    (0X00160010, "DS", "ColorFilterArrayPatternValues"),
    (0X00160011, "US", "FlashFiringStatus"),
    (0X00160012, "US", "FlashReturnStatus"),
    (0X00160013, "US", "FlashMode"),
    (0X00160014, "US", "FlashFunctionPresent"),
    (0X00160015, "US", "FlashRedEyeMode"),
    (0X00160016, "US", "ExposureProgram"),
    (0X00160017, "UT", "SpectralSensitivity"),
    (0X00160018, "IS", "PhotographicSensitivity"),
    (0X00160019, "IS", "SelfTimerMode"),
    (0X0016001A, "US", "SensitivityType"),
    (0X0016001B, "IS", "StandardOutputSensitivity"),
    (0X0016001C, "IS", "RecommendedExposureIndex"),
    (0X0016001D, "IS", "ISOSpeed"),
    (0X0016001E, "IS", "ISOSpeedLatitudeyyy"),
    (0X0016001F, "IS", "ISOSpeedLatitudezzz"),
    (0X00160020, "UT", "EXIFVersion"),
    (0X00160021, "DS", "ShutterSpeedValue"),
    (0X00160022, "DS", "ApertureValue"),
    (0X00160023, "DS", "BrightnessValue"),
    (0X00160024, "DS", "ExposureBiasValue"),
    (0X00160025, "DS", "MaxApertureValue"),
    (0X00160026, "DS", "SubjectDistance"),
    (0X00160027, "US", "MeteringMode"),
    (0X00160028, "US", "LightSource"),
    (0X00160029, "DS", "FocalLength"),
    (0X0016002A, "IS", "SubjectArea"),
    (0X0016002B, "OB", "MakerNote"),
    (0X00160030, "DS", "Temperature"),
    (0X00160031, "DS", "Humidity"),
    (0X00160032, "DS", "Pressure"),
    (0X00160033, "DS", "WaterDepth"),
    (0X00160034, "DS", "Acceleration"),
    (0X00160035, "DS", "CameraElevationAngle"),
    (0X00160036, "DS", "FlashEnergy"),
    (0X00160037, "IS", "SubjectLocation"),
    (0X00160038, "DS", "PhotographicExposureIndex"),
    (0X00160039, "US", "SensingMethod"),
    (0X0016003A, "US", "FileSource"),
    (0X0016003B, "US", "SceneType"),
    (0X00160041, "US", "CustomRendered"),
    (0X00160042, "US", "ExposureMode"),
    (0X00160043, "US", "WhiteBalance"),
    (0X00160044, "DS", "DigitalZoomRatio"),
    (0X00160045, "IS", "FocalLengthIn35mmFilm"),
    (0X00160046, "US", "SceneCaptureType"),
    (0X00160047, "US", "GainControl"),
    (0X00160048, "US", "Contrast"),
    (0X00160049, "US", "Saturation"),
    (0X0016004A, "US", "Sharpness"),
    (0X0016004B, "OB", "DeviceSettingDescription"),
    (0X0016004C, "US", "SubjectDistanceRange"),
    (0X0016004D, "UT", "CameraOwnerName"),
    (0X0016004E, "DS", "LensSpecification"),
    (0X0016004F, "UT", "LensMake"),
    (0X00160050, "UT", "LensModel"),
    (0X00160051, "UT", "LensSerialNumber"),
    (0X00160061, "CS", "InteroperabilityIndex"),
    (0X00160062, "OB", "InteroperabilityVersion"),
    (0X00160070, "OB", "GPSVersionID"),
    (0X00160071, "CS", "GPSLatitudeRef"),
    (0X00160072, "DS", "GPSLatitude"),
    (0X00160073, "CS", "GPSLongitudeRef"),
    (0X00160074, "DS", "GPSLongitude"),
    (0X00160075, "US", "GPSAltitudeRef"),
    (0X00160076, "DS", "GPSAltitude"),
    (0X00160077, "DT", "GPSTimeStamp"),
    (0X00160078, "UT", "GPSSatellites"),
    (0X00160079, "CS", "GPSStatus"),
    (0X0016007A, "CS", "GPSMeasureMode"),
    (0X0016007B, "DS", "GPSDOP"),
    (0X0016007C, "CS", "GPSSpeedRef"),
    (0X0016007D, "DS", "GPSSpeed"),
    (0X0016007E, "CS", "GPSTrackRef"),
    (0X0016007F, "DS", "GPSTrack"),
    (0X00160080, "CS", "GPSImgDirectionRef"),
    (0X00160081, "DS", "GPSImgDirection"),
    (0X00160082, "UT", "GPSMapDatum"),
    (0X00160083, "CS", "GPSDestLatitudeRef"),
    (0X00160084, "DS", "GPSDestLatitude"),
    (0X00160085, "CS", "GPSDestLongitudeRef"),
    (0X00160086, "DS", "GPSDestLongitude"),
    (0X00160087, "CS", "GPSDestBearingRef"),
    (0X00160088, "DS", "GPSDestBearing"),
    (0X00160089, "CS", "GPSDestDistanceRef"),
    (0X0016008A, "DS", "GPSDestDistance"),
    (0X0016008B, "OB", "GPSProcessingMethod"),
    (0X0016008C, "OB", "GPSAreaInformation"),
    (0X0016008D, "DT", "GPSDateStamp"),
    (0X0016008E, "IS", "GPSDifferential"),
    (0X00161001, "CS", "LightSourcePolarization"),
    (0X00161002, "DS", "EmitterColorTemperature"),
    (0X00161003, "CS", "ContactMethod"),
    (0X00161004, "CS", "ImmersionMedia"),
    (0X00161005, "DS", "OpticalMagnificationFactor"),
    (0X00180010, "LO", "ContrastBolusAgent"),
    (0X00180012, "SQ", "ContrastBolusAgentSequence"),
    (0X00180013, "FL", "ContrastBolusT1Relaxivity"),
    (0X00180014, "SQ", "ContrastBolusAdministrationRouteSequence"),
    (0X00180015, "CS", "BodyPartExamined"),
    (0X00180020, "CS", "ScanningSequence"),
    (0X00180021, "CS", "SequenceVariant"),
    (0X00180022, "CS", "ScanOptions"),
    (0X00180023, "CS", "MRAcquisitionType"),
    (0X00180024, "SH", "SequenceName"),
    (0X00180025, "CS", "AngioFlag"),
    (0X00180026, "SQ", "InterventionDrugInformationSequence"),
    (0X00180027, "TM", "InterventionDrugStopTime"),
    (0X00180028, "DS", "InterventionDrugDose"),
    (0X00180029, "SQ", "InterventionDrugCodeSequence"),
    (0X0018002A, "SQ", "AdditionalDrugSequence"),
    (0X00180030, "LO", "Radionuclide"),
    (0X00180031, "LO", "Radiopharmaceutical"),
    (0X00180032, "DS", "EnergyWindowCenterline"),
    (0X00180033, "DS", "EnergyWindowTotalWidth"),
    (0X00180034, "LO", "InterventionDrugName"),
    (0X00180035, "TM", "InterventionDrugStartTime"),
    (0X00180036, "SQ", "InterventionSequence"),
    (0X00180037, "CS", "TherapyType"),
    (0X00180038, "CS", "InterventionStatus"),
    (0X00180039, "CS", "TherapyDescription"),
    (0X0018003A, "ST", "InterventionDescription"),
    (0X00180040, "IS", "CineRate"),
    (0X00180042, "CS", "InitialCineRunState"),
    (0X00180050, "DS", "SliceThickness"),
    (0X00180060, "DS", "KVP"),
    (0X00180061, "DS", ""),
    (0X00180070, "IS", "CountsAccumulated"),
    (0X00180071, "CS", "AcquisitionTerminationCondition"),
    (0X00180072, "DS", "EffectiveDuration"),
    (0X00180073, "CS", "AcquisitionStartCondition"),
    (0X00180074, "IS", "AcquisitionStartConditionData"),
    (0X00180075, "IS", "AcquisitionTerminationConditionData"),
    (0X00180080, "DS", "RepetitionTime"),
    (0X00180081, "DS", "EchoTime"),
    (0X00180082, "DS", "InversionTime"),
    (0X00180083, "DS", "NumberOfAverages"),
    (0X00180084, "DS", "ImagingFrequency"),
    (0X00180085, "SH", "ImagedNucleus"),
    (0X00180086, "IS", "EchoNumbers"),
    (0X00180087, "DS", "MagneticFieldStrength"),
    (0X00180088, "DS", "SpacingBetweenSlices"),
    (0X00180089, "IS", "NumberOfPhaseEncodingSteps"),
    (0X00180090, "DS", "DataCollectionDiameter"),
    (0X00180091, "IS", "EchoTrainLength"),
    (0X00180093, "DS", "PercentSampling"),
    (0X00180094, "DS", "PercentPhaseFieldOfView"),
    (0X00180095, "DS", "PixelBandwidth"),
    (0X00181000, "LO", "DeviceSerialNumber"),
    (0X00181002, "UI", "DeviceUID"),
    (0X00181003, "LO", "DeviceID"),
    (0X00181004, "LO", "PlateID"),
    (0X00181005, "LO", "GeneratorID"),
    (0X00181006, "LO", "GridID"),
    (0X00181007, "LO", "CassetteID"),
    (0X00181008, "LO", "GantryID"),
    (0X00181009, "UT", "UniqueDeviceIdentifier"),
    (0X0018100A, "SQ", "UDISequence"),
    (0X0018100B, "UI", "ManufacturerDeviceClassUID"),
    (0X00181010, "LO", "SecondaryCaptureDeviceID"),
    (0X00181011, "LO", "HardcopyCreationDeviceID"),
    (0X00181012, "DA", "DateOfSecondaryCapture"),
    (0X00181014, "TM", "TimeOfSecondaryCapture"),
    (0X00181016, "LO", "SecondaryCaptureDeviceManufacturer"),
    (0X00181017, "LO", "HardcopyDeviceManufacturer"),
    (0X00181018, "LO", "SecondaryCaptureDeviceManufacturerModelName"),
    (0X00181019, "LO", "SecondaryCaptureDeviceSoftwareVersions"),
    (0X0018101A, "LO", "HardcopyDeviceSoftwareVersion"),
    (0X0018101B, "LO", "HardcopyDeviceManufacturerModelName"),
    (0X00181020, "LO", "SoftwareVersions"),
    (0X00181022, "SH", "VideoImageFormatAcquired"),
    (0X00181023, "LO", "DigitalImageFormatAcquired"),
    (0X00181030, "LO", "ProtocolName"),
    (0X00181040, "LO", "ContrastBolusRoute"),
    (0X00181041, "DS", "ContrastBolusVolume"),
    (0X00181042, "TM", "ContrastBolusStartTime"),
    (0X00181043, "TM", "ContrastBolusStopTime"),
    (0X00181044, "DS", "ContrastBolusTotalDose"),
    (0X00181045, "IS", "SyringeCounts"),
    (0X00181046, "DS", "ContrastFlowRate"),
    (0X00181047, "DS", "ContrastFlowDuration"),
    (0X00181048, "CS", "ContrastBolusIngredient"),
    (0X00181049, "DS", "ContrastBolusIngredientConcentration"),
    (0X00181050, "DS", "SpatialResolution"),
    (0X00181060, "DS", "TriggerTime"),
    (0X00181061, "LO", "TriggerSourceOrType"),
    (0X00181062, "IS", "NominalInterval"),
    (0X00181063, "DS", "FrameTime"),
    (0X00181064, "LO", "CardiacFramingType"),
    (0X00181065, "DS", "FrameTimeVector"),
    (0X00181066, "DS", "FrameDelay"),
    (0X00181067, "DS", "ImageTriggerDelay"),
    (0X00181068, "DS", "MultiplexGroupTimeOffset"),
    (0X00181069, "DS", "TriggerTimeOffset"),
    (0X0018106A, "CS", "SynchronizationTrigger"),
    (0X0018106C, "US", "SynchronizationChannel"),
    (0X0018106E, "UL", "TriggerSamplePosition"),
    (0X00181070, "LO", "RadiopharmaceuticalRoute"),
    (0X00181071, "DS", "RadiopharmaceuticalVolume"),
    (0X00181072, "TM", "RadiopharmaceuticalStartTime"),
    (0X00181073, "TM", "RadiopharmaceuticalStopTime"),
    (0X00181074, "DS", "RadionuclideTotalDose"),
    (0X00181075, "DS", "RadionuclideHalfLife"),
    (0X00181076, "DS", "RadionuclidePositronFraction"),
    (0X00181077, "DS", "RadiopharmaceuticalSpecificActivity"),
    (0X00181078, "DT", "RadiopharmaceuticalStartDateTime"),
    (0X00181079, "DT", "RadiopharmaceuticalStopDateTime"),
    (0X00181080, "CS", "BeatRejectionFlag"),
    (0X00181081, "IS", "LowRRValue"),
    (0X00181082, "IS", "HighRRValue"),
    (0X00181083, "IS", "IntervalsAcquired"),
    (0X00181084, "IS", "IntervalsRejected"),
    (0X00181085, "LO", "PVCRejection"),
    (0X00181086, "IS", "SkipBeats"),
    (0X00181088, "IS", "HeartRate"),
    (0X00181090, "IS", "CardiacNumberOfImages"),
    (0X00181094, "IS", "TriggerWindow"),
    (0X00181100, "DS", "ReconstructionDiameter"),
    (0X00181110, "DS", "DistanceSourceToDetector"),
    (0X00181111, "DS", "DistanceSourceToPatient"),
    (0X00181114, "DS", "EstimatedRadiographicMagnificationFactor"),
    (0X00181120, "DS", "GantryDetectorTilt"),
    (0X00181121, "DS", "GantryDetectorSlew"),
    (0X00181130, "DS", "TableHeight"),
    (0X00181131, "DS", "TableTraverse"),
    (0X00181134, "CS", "TableMotion"),
    (0X00181135, "DS", "TableVerticalIncrement"),
    (0X00181136, "DS", "TableLateralIncrement"),
    (0X00181137, "DS", "TableLongitudinalIncrement"),
    (0X00181138, "DS", "TableAngle"),
    (0X0018113A, "CS", "TableType"),
    (0X00181140, "CS", "RotationDirection"),
    (0X00181141, "DS", "AngularPosition"),
    (0X00181142, "DS", "RadialPosition"),
    (0X00181143, "DS", "ScanArc"),
    (0X00181144, "DS", "AngularStep"),
    (0X00181145, "DS", "CenterOfRotationOffset"),
    (0X00181146, "DS", "RotationOffset"),
    (0X00181147, "CS", "FieldOfViewShape"),
    (0X00181149, "IS", "FieldOfViewDimensions"),
    (0X00181150, "IS", "ExposureTime"),
    (0X00181151, "IS", "XRayTubeCurrent"),
    (0X00181152, "IS", "Exposure"),
    (0X00181153, "IS", "ExposureInuAs"),
    (0X00181154, "DS", "AveragePulseWidth"),
    (0X00181155, "CS", "RadiationSetting"),
    (0X00181156, "CS", "RectificationType"),
    (0X0018115A, "CS", "RadiationMode"),
    (0X0018115E, "DS", "ImageAndFluoroscopyAreaDoseProduct"),
    (0X00181160, "SH", "FilterType"),
    (0X00181161, "LO", "TypeOfFilters"),
    (0X00181162, "DS", "IntensifierSize"),
    (0X00181164, "DS", "ImagerPixelSpacing"),
    (0X00181166, "CS", "Grid"),
    (0X00181170, "IS", "GeneratorPower"),
    (0X00181180, "SH", "CollimatorGridName"),
    (0X00181181, "CS", "CollimatorType"),
    (0X00181182, "IS", "FocalDistance"),
    (0X00181183, "DS", "XFocusCenter"),
    (0X00181184, "DS", "YFocusCenter"),
    (0X00181190, "DS", "FocalSpots"),
    (0X00181191, "CS", "AnodeTargetMaterial"),
    (0X001811A0, "DS", "BodyPartThickness"),
    (0X001811A2, "DS", "CompressionForce"),
    (0X001811A3, "DS", "CompressionPressure"),
    (0X001811A4, "LO", "PaddleDescription"),
    (0X001811A5, "DS", "CompressionContactArea"),
    (0X001811B0, "LO", "AcquisitionMode"),
    (0X001811B1, "LO", "DoseModeName"),
    (0X001811B2, "CS", "AcquiredSubtractionMaskFlag"),
    (0X001811B3, "CS", "FluoroscopyPersistenceFlag"),
    (0X001811B4, "CS", "FluoroscopyLastImageHoldPersistenceFlag"),
    (0X001811B5, "IS", "UpperLimitNumberOfPersistentFluoroscopyFrames"),
    (0X001811B6, "CS", "ContrastBolusAutoInjectionTriggerFlag"),
    (0X001811B7, "FD", "ContrastBolusInjectionDelay"),
    (0X001811B8, "SQ", "XAAcquisitionPhaseDetailsSequence"),
    (0X001811B9, "FD", "XAAcquisitionFrameRate"),
    (0X001811BA, "SQ", "XAPlaneDetailsSequence"),
    (0X001811BB, "LO", "AcquisitionFieldOfViewLabel"),
    (0X001811BC, "SQ", "XRayFilterDetailsSequence"),
    (0X001811BD, "FD", "XAAcquisitionDuration"),
    (0X001811BE, "CS", "ReconstructionPipelineType"),
    (0X001811BF, "SQ", "ImageFilterDetailsSequence"),
    (0X001811C0, "CS", "AppliedMaskSubtractionFlag"),
    (0X001811C1, "SQ", "RequestedSeriesDescriptionCodeSequence"),
    (0X00181200, "DA", "DateOfLastCalibration"),
    (0X00181201, "TM", "TimeOfLastCalibration"),
    (0X00181202, "DT", "DateTimeOfLastCalibration"),
    (0X00181210, "SH", "ConvolutionKernel"),
    (0X00181240, "IS", "UpperLowerPixelValues"),
    (0X00181242, "IS", "ActualFrameDuration"),
    (0X00181243, "IS", "CountRate"),
    (0X00181244, "US", "PreferredPlaybackSequencing"),
    (0X00181250, "SH", "ReceiveCoilName"),
    (0X00181251, "SH", "TransmitCoilName"),
    (0X00181260, "SH", "PlateType"),
    (0X00181261, "LO", "PhosphorType"),
    (0X00181271, "FD", "WaterEquivalentDiameter"),
    (0X00181272, "SQ", "WaterEquivalentDiameterCalculationMethodCodeSequence"),
    (0X00181300, "DS", "ScanVelocity"),
    (0X00181301, "CS", "WholeBodyTechnique"),
    (0X00181302, "IS", "ScanLength"),
    (0X00181310, "US", "AcquisitionMatrix"),
    (0X00181312, "CS", "InPlanePhaseEncodingDirection"),
    (0X00181314, "DS", "FlipAngle"),
    (0X00181315, "CS", "VariableFlipAngleFlag"),
    (0X00181316, "DS", "SAR"),
    (0X00181318, "DS", "dBdt"),
    (0X00181320, "FL", "B1rms"),
    (0X00181400, "LO", "AcquisitionDeviceProcessingDescription"),
    (0X00181401, "LO", "AcquisitionDeviceProcessingCode"),
    (0X00181402, "CS", "CassetteOrientation"),
    (0X00181403, "CS", "CassetteSize"),
    (0X00181404, "US", "ExposuresOnPlate"),
    (0X00181405, "IS", "RelativeXRayExposure"),
    (0X00181411, "DS", "ExposureIndex"),
    (0X00181412, "DS", "TargetExposureIndex"),
    (0X00181413, "DS", "DeviationIndex"),
    (0X00181450, "DS", "ColumnAngulation"),
    (0X00181460, "DS", "TomoLayerHeight"),
    (0X00181470, "DS", "TomoAngle"),
    (0X00181480, "DS", "TomoTime"),
    (0X00181490, "CS", "TomoType"),
    (0X00181491, "CS", "TomoClass"),
    (0X00181495, "IS", "NumberOfTomosynthesisSourceImages"),
    (0X00181500, "CS", "PositionerMotion"),
    (0X00181508, "CS", "PositionerType"),
    (0X00181510, "DS", "PositionerPrimaryAngle"),
    (0X00181511, "DS", "PositionerSecondaryAngle"),
    (0X00181520, "DS", "PositionerPrimaryAngleIncrement"),
    (0X00181521, "DS", "PositionerSecondaryAngleIncrement"),
    (0X00181530, "DS", "DetectorPrimaryAngle"),
    (0X00181531, "DS", "DetectorSecondaryAngle"),
    (0X00181600, "CS", "ShutterShape"),
    (0X00181602, "IS", "ShutterLeftVerticalEdge"),
    (0X00181604, "IS", "ShutterRightVerticalEdge"),
    (0X00181606, "IS", "ShutterUpperHorizontalEdge"),
    (0X00181608, "IS", "ShutterLowerHorizontalEdge"),
    (0X00181610, "IS", "CenterOfCircularShutter"),
    (0X00181612, "IS", "RadiusOfCircularShutter"),
    (0X00181620, "IS", "VerticesOfThePolygonalShutter"),
    (0X00181622, "US", "ShutterPresentationValue"),
    (0X00181623, "US", "ShutterOverlayGroup"),
    (0X00181624, "US", "ShutterPresentationColorCIELabValue"),
    (0X00181630, "CS", "OutlineShapeType"),
    (0X00181631, "FD", "OutlineLeftVerticalEdge"),
    (0X00181632, "FD", "OutlineRightVerticalEdge"),
    (0X00181633, "FD", "OutlineUpperHorizontalEdge"),
    (0X00181634, "FD", "OutlineLowerHorizontalEdge"),
    (0X00181635, "FD", "CenterOfCircularOutline"),
    (0X00181636, "FD", "DiameterOfCircularOutline"),
    (0X00181637, "UL", "NumberOfPolygonalVertices"),
    (0X00181638, "OF", "VerticesOfThePolygonalOutline"),
    (0X00181700, "CS", "CollimatorShape"),
    (0X00181702, "IS", "CollimatorLeftVerticalEdge"),
    (0X00181704, "IS", "CollimatorRightVerticalEdge"),
    (0X00181706, "IS", "CollimatorUpperHorizontalEdge"),
    (0X00181708, "IS", "CollimatorLowerHorizontalEdge"),
    (0X00181710, "IS", "CenterOfCircularCollimator"),
    (0X00181712, "IS", "RadiusOfCircularCollimator"),
    (0X00181720, "IS", "VerticesOfThePolygonalCollimator"),
    (0X00181800, "CS", "AcquisitionTimeSynchronized"),
    (0X00181801, "SH", "TimeSource"),
    (0X00181802, "CS", "TimeDistributionProtocol"),
    (0X00181803, "LO", "NTPSourceAddress"),
    (0X00182001, "IS", "PageNumberVector"),
    (0X00182002, "SH", "FrameLabelVector"),
    (0X00182003, "DS", "FramePrimaryAngleVector"),
    (0X00182004, "DS", "FrameSecondaryAngleVector"),
    (0X00182005, "DS", "SliceLocationVector"),
    (0X00182006, "SH", "DisplayWindowLabelVector"),
    (0X00182010, "DS", "NominalScannedPixelSpacing"),
    (0X00182020, "CS", "DigitizingDeviceTransportDirection"),
    (0X00182030, "DS", "RotationOfScannedFilm"),
    (0X00182041, "SQ", "BiopsyTargetSequence"),
    (0X00182042, "UI", "TargetUID"),
    (0X00182043, "FL", "LocalizingCursorPosition"),
    (0X00182044, "FL", "CalculatedTargetPosition"),
    (0X00182045, "SH", "TargetLabel"),
    (0X00182046, "FL", "DisplayedZValue"),
    (0X00183100, "CS", "IVUSAcquisition"),
    (0X00183101, "DS", "IVUSPullbackRate"),
    (0X00183102, "DS", "IVUSGatedRate"),
    (0X00183103, "IS", "IVUSPullbackStartFrameNumber"),
    (0X00183104, "IS", "IVUSPullbackStopFrameNumber"),
    (0X00183105, "IS", "LesionNumber"),
    (0X00184000, "LT", "AcquisitionComments"),
    (0X00185000, "SH", "OutputPower"),
    (0X00185010, "LO", "TransducerData"),
    (0X00185011, "SQ", "TransducerIdentificationSequence"),
    (0X00185012, "DS", "FocusDepth"),
    (0X00185020, "LO", "ProcessingFunction"),
    (0X00185021, "LO", "PostprocessingFunction"),
    (0X00185022, "DS", "MechanicalIndex"),
    (0X00185024, "DS", "BoneThermalIndex"),
    (0X00185026, "DS", "CranialThermalIndex"),
    (0X00185027, "DS", "SoftTissueThermalIndex"),
    (0X00185028, "DS", "SoftTissueFocusThermalIndex"),
    (0X00185029, "DS", "SoftTissueSurfaceThermalIndex"),
    (0X00185030, "DS", "DynamicRange"),
    (0X00185040, "DS", "TotalGain"),
    (0X00185050, "IS", "DepthOfScanField"),
    (0X00185100, "CS", "PatientPosition"),
    (0X00185101, "CS", "ViewPosition"),
    (0X00185104, "SQ", "ProjectionEponymousNameCodeSequence"),
    (0X00185210, "DS", "ImageTransformationMatrix"),
    (0X00185212, "DS", "ImageTranslationVector"),
    (0X00186000, "DS", "Sensitivity"),
    (0X00186011, "SQ", "SequenceOfUltrasoundRegions"),
    (0X00186012, "US", "RegionSpatialFormat"),
    (0X00186014, "US", "RegionDataType"),
    (0X00186016, "UL", "RegionFlags"),
    (0X00186018, "UL", "RegionLocationMinX0"),
    (0X0018601A, "UL", "RegionLocationMinY0"),
    (0X0018601C, "UL", "RegionLocationMaxX1"),
    (0X0018601E, "UL", "RegionLocationMaxY1"),
    (0X00186020, "SL", "ReferencePixelX0"),
    (0X00186022, "SL", "ReferencePixelY0"),
    (0X00186024, "US", "PhysicalUnitsXDirection"),
    (0X00186026, "US", "PhysicalUnitsYDirection"),
    (0X00186028, "FD", "ReferencePixelPhysicalValueX"),
    (0X0018602A, "FD", "ReferencePixelPhysicalValueY"),
    (0X0018602C, "FD", "PhysicalDeltaX"),
    (0X0018602E, "FD", "PhysicalDeltaY"),
    (0X00186030, "UL", "TransducerFrequency"),
    (0X00186031, "CS", "TransducerType"),
    (0X00186032, "UL", "PulseRepetitionFrequency"),
    (0X00186034, "FD", "DopplerCorrectionAngle"),
    (0X00186036, "FD", "SteeringAngle"),
    (0X00186038, "UL", "DopplerSampleVolumeXPositionRetired"),
    (0X00186039, "SL", "DopplerSampleVolumeXPosition"),
    (0X0018603A, "UL", "DopplerSampleVolumeYPositionRetired"),
    (0X0018603B, "SL", "DopplerSampleVolumeYPosition"),
    (0X0018603C, "UL", "TMLinePositionX0Retired"),
    (0X0018603D, "SL", "TMLinePositionX0"),
    (0X0018603E, "UL", "TMLinePositionY0Retired"),
    (0X0018603F, "SL", "TMLinePositionY0"),
    (0X00186040, "UL", "TMLinePositionX1Retired"),
    (0X00186041, "SL", "TMLinePositionX1"),
    (0X00186042, "UL", "TMLinePositionY1Retired"),
    (0X00186043, "SL", "TMLinePositionY1"),
    (0X00186044, "US", "PixelComponentOrganization"),
    (0X00186046, "UL", "PixelComponentMask"),
    (0X00186048, "UL", "PixelComponentRangeStart"),
    (0X0018604A, "UL", "PixelComponentRangeStop"),
    (0X0018604C, "US", "PixelComponentPhysicalUnits"),
    (0X0018604E, "US", "PixelComponentDataType"),
    (0X00186050, "UL", "NumberOfTableBreakPoints"),
    (0X00186052, "UL", "TableOfXBreakPoints"),
    (0X00186054, "FD", "TableOfYBreakPoints"),
    (0X00186056, "UL", "NumberOfTableEntries"),
    (0X00186058, "UL", "TableOfPixelValues"),
    (0X0018605A, "FL", "TableOfParameterValues"),
    (0X00186060, "FL", "RWaveTimeVector"),
    (0X00186070, "US", "ActiveImageAreaOverlayGroup"),
    (0X00187000, "CS", "DetectorConditionsNominalFlag"),
    (0X00187001, "DS", "DetectorTemperature"),
    (0X00187004, "CS", "DetectorType"),
    (0X00187005, "CS", "DetectorConfiguration"),
    (0X00187006, "LT", "DetectorDescription"),
    (0X00187008, "LT", "DetectorMode"),
    (0X0018700A, "SH", "DetectorID"),
    (0X0018700C, "DA", "DateOfLastDetectorCalibration"),
    (0X0018700E, "TM", "TimeOfLastDetectorCalibration"),
    (0X00187010, "IS", "ExposuresOnDetectorSinceLastCalibration"),
    (0X00187011, "IS", "ExposuresOnDetectorSinceManufactured"),
    (0X00187012, "DS", "DetectorTimeSinceLastExposure"),
    (0X00187014, "DS", "DetectorActiveTime"),
    (0X00187016, "DS", "DetectorActivationOffsetFromExposure"),
    (0X0018701A, "DS", "DetectorBinning"),
    (0X00187020, "DS", "DetectorElementPhysicalSize"),
    (0X00187022, "DS", "DetectorElementSpacing"),
    (0X00187024, "CS", "DetectorActiveShape"),
    (0X00187026, "DS", "DetectorActiveDimensions"),
    (0X00187028, "DS", "DetectorActiveOrigin"),
    (0X0018702A, "LO", "DetectorManufacturerName"),
    (0X0018702B, "LO", "DetectorManufacturerModelName"),
    (0X00187030, "DS", "FieldOfViewOrigin"),
    (0X00187032, "DS", "FieldOfViewRotation"),
    (0X00187034, "CS", "FieldOfViewHorizontalFlip"),
    (0X00187036, "FL", "PixelDataAreaOriginRelativeToFOV"),
    (0X00187038, "FL", "PixelDataAreaRotationAngleRelativeToFOV"),
    (0X00187040, "LT", "GridAbsorbingMaterial"),
    (0X00187041, "LT", "GridSpacingMaterial"),
    (0X00187042, "DS", "GridThickness"),
    (0X00187044, "DS", "GridPitch"),
    (0X00187046, "IS", "GridAspectRatio"),
    (0X00187048, "DS", "GridPeriod"),
    (0X0018704C, "DS", "GridFocalDistance"),
    (0X00187050, "CS", "FilterMaterial"),
    (0X00187052, "DS", "FilterThicknessMinimum"),
    (0X00187054, "DS", "FilterThicknessMaximum"),
    (0X00187056, "FL", "FilterBeamPathLengthMinimum"),
    (0X00187058, "FL", "FilterBeamPathLengthMaximum"),
    (0X00187060, "CS", "ExposureControlMode"),
    (0X00187062, "LT", "ExposureControlModeDescription"),
    (0X00187064, "CS", "ExposureStatus"),
    (0X00187065, "DS", "PhototimerSetting"),
    (0X00188150, "DS", "ExposureTimeInuS"),
    (0X00188151, "DS", "XRayTubeCurrentInuA"),
    (0X00189004, "CS", "ContentQualification"),
    (0X00189005, "SH", "PulseSequenceName"),
    (0X00189006, "SQ", "MRImagingModifierSequence"),
    (0X00189008, "CS", "EchoPulseSequence"),
    (0X00189009, "CS", "InversionRecovery"),
    (0X00189010, "CS", "FlowCompensation"),
    (0X00189011, "CS", "MultipleSpinEcho"),
    (0X00189012, "CS", "MultiPlanarExcitation"),
    (0X00189014, "CS", "PhaseContrast"),
    (0X00189015, "CS", "TimeOfFlightContrast"),
    (0X00189016, "CS", "Spoiling"),
    (0X00189017, "CS", "SteadyStatePulseSequence"),
    (0X00189018, "CS", "EchoPlanarPulseSequence"),
    (0X00189019, "FD", "TagAngleFirstAxis"),
    (0X00189020, "CS", "MagnetizationTransfer"),
    (0X00189021, "CS", "T2Preparation"),
    (0X00189022, "CS", "BloodSignalNulling"),
    (0X00189024, "CS", "SaturationRecovery"),
    (0X00189025, "CS", "SpectrallySelectedSuppression"),
    (0X00189026, "CS", "SpectrallySelectedExcitation"),
    (0X00189027, "CS", "SpatialPresaturation"),
    (0X00189028, "CS", "Tagging"),
    (0X00189029, "CS", "OversamplingPhase"),
    (0X00189030, "FD", "TagSpacingFirstDimension"),
    (0X00189032, "CS", "GeometryOfKSpaceTraversal"),
    (0X00189033, "CS", "SegmentedKSpaceTraversal"),
    (0X00189034, "CS", "RectilinearPhaseEncodeReordering"),
    (0X00189035, "FD", "TagThickness"),
    (0X00189036, "CS", "PartialFourierDirection"),
    (0X00189037, "CS", "CardiacSynchronizationTechnique"),
    (0X00189041, "LO", "ReceiveCoilManufacturerName"),
    (0X00189042, "SQ", "MRReceiveCoilSequence"),
    (0X00189043, "CS", "ReceiveCoilType"),
    (0X00189044, "CS", "QuadratureReceiveCoil"),
    (0X00189045, "SQ", "MultiCoilDefinitionSequence"),
    (0X00189046, "LO", "MultiCoilConfiguration"),
    (0X00189047, "SH", "MultiCoilElementName"),
    (0X00189048, "CS", "MultiCoilElementUsed"),
    (0X00189049, "SQ", "MRTransmitCoilSequence"),
    (0X00189050, "LO", "TransmitCoilManufacturerName"),
    (0X00189051, "CS", "TransmitCoilType"),
    (0X00189052, "FD", "SpectralWidth"),
    (0X00189053, "FD", "ChemicalShiftReference"),
    (0X00189054, "CS", "VolumeLocalizationTechnique"),
    (0X00189058, "US", "MRAcquisitionFrequencyEncodingSteps"),
    (0X00189059, "CS", "Decoupling"),
    (0X00189060, "CS", "DecoupledNucleus"),
    (0X00189061, "FD", "DecouplingFrequency"),
    (0X00189062, "CS", "DecouplingMethod"),
    (0X00189063, "FD", "DecouplingChemicalShiftReference"),
    (0X00189064, "CS", "KSpaceFiltering"),
    (0X00189065, "CS", "TimeDomainFiltering"),
    (0X00189066, "US", "NumberOfZeroFills"),
    (0X00189067, "CS", "BaselineCorrection"),
    (0X00189069, "FD", "ParallelReductionFactorInPlane"),
    (0X00189070, "FD", "CardiacRRIntervalSpecified"),
    (0X00189073, "FD", "AcquisitionDuration"),
    (0X00189074, "DT", "FrameAcquisitionDateTime"),
    (0X00189075, "CS", "DiffusionDirectionality"),
    (0X00189076, "SQ", "DiffusionGradientDirectionSequence"),
    (0X00189077, "CS", "ParallelAcquisition"),
    (0X00189078, "CS", "ParallelAcquisitionTechnique"),
    (0X00189079, "FD", "InversionTimes"),
    (0X00189080, "ST", "MetaboliteMapDescription"),
    (0X00189081, "CS", "PartialFourier"),
    (0X00189082, "FD", "EffectiveEchoTime"),
    (0X00189083, "SQ", "MetaboliteMapCodeSequence"),
    (0X00189084, "SQ", "ChemicalShiftSequence"),
    (0X00189085, "CS", "CardiacSignalSource"),
    (0X00189087, "FD", "DiffusionBValue"),
    (0X00189089, "FD", "DiffusionGradientOrientation"),
    (0X00189090, "FD", "VelocityEncodingDirection"),
    (0X00189091, "FD", "VelocityEncodingMinimumValue"),
    (0X00189092, "SQ", "VelocityEncodingAcquisitionSequence"),
    (0X00189093, "US", "NumberOfKSpaceTrajectories"),
    (0X00189094, "CS", "CoverageOfKSpace"),
    (0X00189095, "UL", "SpectroscopyAcquisitionPhaseRows"),
    (0X00189096, "FD", "ParallelReductionFactorInPlaneRetired"),
    (0X00189098, "FD", "TransmitterFrequency"),
    (0X00189100, "CS", "ResonantNucleus"),
    (0X00189101, "CS", "FrequencyCorrection"),
    (0X00189103, "SQ", "MRSpectroscopyFOVGeometrySequence"),
    (0X00189104, "FD", "SlabThickness"),
    (0X00189105, "FD", "SlabOrientation"),
    (0X00189106, "FD", "MidSlabPosition"),
    (0X00189107, "SQ", "MRSpatialSaturationSequence"),
    (0X00189112, "SQ", "MRTimingAndRelatedParametersSequence"),
    (0X00189114, "SQ", "MREchoSequence"),
    (0X00189115, "SQ", "MRModifierSequence"),
    (0X00189117, "SQ", "MRDiffusionSequence"),
    (0X00189118, "SQ", "CardiacSynchronizationSequence"),
    (0X00189119, "SQ", "MRAveragesSequence"),
    (0X00189125, "SQ", "MRFOVGeometrySequence"),
    (0X00189126, "SQ", "VolumeLocalizationSequence"),
    (0X00189127, "UL", "SpectroscopyAcquisitionDataColumns"),
    (0X00189147, "CS", "DiffusionAnisotropyType"),
    (0X00189151, "DT", "FrameReferenceDateTime"),
    (0X00189152, "SQ", "MRMetaboliteMapSequence"),
    (0X00189155, "FD", "ParallelReductionFactorOutOfPlane"),
    (0X00189159, "UL", "SpectroscopyAcquisitionOutOfPlanePhaseSteps"),
    (0X00189166, "CS", "BulkMotionStatus"),
    (0X00189168, "FD", "ParallelReductionFactorSecondInPlane"),
    (0X00189169, "CS", "CardiacBeatRejectionTechnique"),
    (0X00189170, "CS", "RespiratoryMotionCompensationTechnique"),
    (0X00189171, "CS", "RespiratorySignalSource"),
    (0X00189172, "CS", "BulkMotionCompensationTechnique"),
    (0X00189173, "CS", "BulkMotionSignalSource"),
    (0X00189174, "CS", "ApplicableSafetyStandardAgency"),
    (0X00189175, "LO", "ApplicableSafetyStandardDescription"),
    (0X00189176, "SQ", "OperatingModeSequence"),
    (0X00189177, "CS", "OperatingModeType"),
    (0X00189178, "CS", "OperatingMode"),
    (0X00189179, "CS", "SpecificAbsorptionRateDefinition"),
    (0X00189180, "CS", "GradientOutputType"),
    (0X00189181, "FD", "SpecificAbsorptionRateValue"),
    (0X00189182, "FD", "GradientOutput"),
    (0X00189183, "CS", "FlowCompensationDirection"),
    (0X00189184, "FD", "TaggingDelay"),
    (0X00189185, "ST", "RespiratoryMotionCompensationTechniqueDescription"),
    (0X00189186, "SH", "RespiratorySignalSourceID"),
    (0X00189195, "FD", "ChemicalShiftMinimumIntegrationLimitInHz"),
    (0X00189196, "FD", "ChemicalShiftMaximumIntegrationLimitInHz"),
    (0X00189197, "SQ", "MRVelocityEncodingSequence"),
    (0X00189198, "CS", "FirstOrderPhaseCorrection"),
    (0X00189199, "CS", "WaterReferencedPhaseCorrection"),
    (0X00189200, "CS", "MRSpectroscopyAcquisitionType"),
    (0X00189214, "CS", "RespiratoryCyclePosition"),
    (0X00189217, "FD", "VelocityEncodingMaximumValue"),
    (0X00189218, "FD", "TagSpacingSecondDimension"),
    (0X00189219, "SS", "TagAngleSecondAxis"),
    (0X00189220, "FD", "FrameAcquisitionDuration"),
    (0X00189226, "SQ", "MRImageFrameTypeSequence"),
    (0X00189227, "SQ", "MRSpectroscopyFrameTypeSequence"),
    (0X00189231, "US", "MRAcquisitionPhaseEncodingStepsInPlane"),
    (0X00189232, "US", "MRAcquisitionPhaseEncodingStepsOutOfPlane"),
    (0X00189234, "UL", "SpectroscopyAcquisitionPhaseColumns"),
    (0X00189236, "CS", "CardiacCyclePosition"),
    (0X00189239, "SQ", "SpecificAbsorptionRateSequence"),
    (0X00189240, "US", "RFEchoTrainLength"),
    (0X00189241, "US", "GradientEchoTrainLength"),
    (0X00189250, "CS", "ArterialSpinLabelingContrast"),
    (0X00189251, "SQ", "MRArterialSpinLabelingSequence"),
    (0X00189252, "LO", "ASLTechniqueDescription"),
    (0X00189253, "US", "ASLSlabNumber"),
    (0X00189254, "FD", "ASLSlabThickness"),
    (0X00189255, "FD", "ASLSlabOrientation"),
    (0X00189256, "FD", "ASLMidSlabPosition"),
    (0X00189257, "CS", "ASLContext"),
    (0X00189258, "UL", "ASLPulseTrainDuration"),
    (0X00189259, "CS", "ASLCrusherFlag"),
    (0X0018925A, "FD", "ASLCrusherFlowLimit"),
    (0X0018925B, "LO", "ASLCrusherDescription"),
    (0X0018925C, "CS", "ASLBolusCutoffFlag"),
    (0X0018925D, "SQ", "ASLBolusCutoffTimingSequence"),
    (0X0018925E, "LO", "ASLBolusCutoffTechnique"),
    (0X0018925F, "UL", "ASLBolusCutoffDelayTime"),
    (0X00189260, "SQ", "ASLSlabSequence"),
    (0X00189295, "FD", "ChemicalShiftMinimumIntegrationLimitInppm"),
    (0X00189296, "FD", "ChemicalShiftMaximumIntegrationLimitInppm"),
    (0X00189297, "CS", "WaterReferenceAcquisition"),
    (0X00189298, "IS", "EchoPeakPosition"),
    (0X00189301, "SQ", "CTAcquisitionTypeSequence"),
    (0X00189302, "CS", "AcquisitionType"),
    (0X00189303, "FD", "TubeAngle"),
    (0X00189304, "SQ", "CTAcquisitionDetailsSequence"),
    (0X00189305, "FD", "RevolutionTime"),
    (0X00189306, "FD", "SingleCollimationWidth"),
    (0X00189307, "FD", "TotalCollimationWidth"),
    (0X00189308, "SQ", "CTTableDynamicsSequence"),
    (0X00189309, "FD", "TableSpeed"),
    (0X00189310, "FD", "TableFeedPerRotation"),
    (0X00189311, "FD", "SpiralPitchFactor"),
    (0X00189312, "SQ", "CTGeometrySequence"),
    (0X00189313, "FD", "DataCollectionCenterPatient"),
    (0X00189314, "SQ", "CTReconstructionSequence"),
    (0X00189315, "CS", "ReconstructionAlgorithm"),
    (0X00189316, "CS", "ConvolutionKernelGroup"),
    (0X00189317, "FD", "ReconstructionFieldOfView"),
    (0X00189318, "FD", "ReconstructionTargetCenterPatient"),
    (0X00189319, "FD", "ReconstructionAngle"),
    (0X00189320, "SH", "ImageFilter"),
    (0X00189321, "SQ", "CTExposureSequence"),
    (0X00189322, "FD", "ReconstructionPixelSpacing"),
    (0X00189323, "CS", "ExposureModulationType"),
    (0X00189324, "FD", "EstimatedDoseSaving"),
    (0X00189325, "SQ", "CTXRayDetailsSequence"),
    (0X00189326, "SQ", "CTPositionSequence"),
    (0X00189327, "FD", "TablePosition"),
    (0X00189328, "FD", "ExposureTimeInms"),
    (0X00189329, "SQ", "CTImageFrameTypeSequence"),
    (0X00189330, "FD", "XRayTubeCurrentInmA"),
    (0X00189332, "FD", "ExposureInmAs"),
    (0X00189333, "CS", "ConstantVolumeFlag"),
    (0X00189334, "CS", "FluoroscopyFlag"),
    (0X00189335, "FD", "DistanceSourceToDataCollectionCenter"),
    (0X00189337, "US", "ContrastBolusAgentNumber"),
    (0X00189338, "SQ", "ContrastBolusIngredientCodeSequence"),
    (0X00189340, "SQ", "ContrastAdministrationProfileSequence"),
    (0X00189341, "SQ", "ContrastBolusUsageSequence"),
    (0X00189342, "CS", "ContrastBolusAgentAdministered"),
    (0X00189343, "CS", "ContrastBolusAgentDetected"),
    (0X00189344, "CS", "ContrastBolusAgentPhase"),
    (0X00189345, "FD", "CTDIvol"),
    (0X00189346, "SQ", "CTDIPhantomTypeCodeSequence"),
    (0X00189351, "FL", "CalciumScoringMassFactorPatient"),
    (0X00189352, "FL", "CalciumScoringMassFactorDevice"),
    (0X00189353, "FL", "EnergyWeightingFactor"),
    (0X00189360, "SQ", "CTAdditionalXRaySourceSequence"),
    (0X00189361, "CS", "MultienergyCTAcquisition"),
    (0X00189362, "SQ", "MultienergyCTAcquisitionSequence"),
    (0X00189363, "SQ", "MultienergyCTProcessingSequence"),
    (0X00189364, "SQ", "MultienergyCTCharacteristicsSequence"),
    (0X00189365, "SQ", "MultienergyCTXRaySourceSequence"),
    (0X00189366, "US", "XRaySourceIndex"),
    (0X00189367, "UC", "XRaySourceID"),
    (0X00189368, "CS", "MultienergySourceTechnique"),
    (0X00189369, "DT", "SourceStartDateTime"),
    (0X0018936A, "DT", "SourceEndDateTime"),
    (0X0018936B, "US", "SwitchingPhaseNumber"),
    (0X0018936C, "DS", "SwitchingPhaseNominalDuration"),
    (0X0018936D, "DS", "SwitchingPhaseTransitionDuration"),
    (0X0018936E, "DS", "EffectiveBinEnergy"),
    (0X0018936F, "SQ", "MultienergyCTXRayDetectorSequence"),
    (0X00189370, "US", "XRayDetectorIndex"),
    (0X00189371, "UC", "XRayDetectorID"),
    (0X00189372, "CS", "MultienergyDetectorType"),
    (0X00189373, "ST", "XRayDetectorLabel"),
    (0X00189374, "DS", "NominalMaxEnergy"),
    (0X00189375, "DS", "NominalMinEnergy"),
    (0X00189376, "US", "ReferencedXRayDetectorIndex"),
    (0X00189377, "US", "ReferencedXRaySourceIndex"),
    (0X00189378, "US", "ReferencedPathIndex"),
    (0X00189379, "SQ", "MultienergyCTPathSequence"),
    (0X0018937A, "US", "MultienergyCTPathIndex"),
    (0X0018937B, "UT", "MultienergyAcquisitionDescription"),
    (0X0018937C, "FD", "MonoenergeticEnergyEquivalent"),
    (0X0018937D, "SQ", "MaterialCodeSequence"),
    (0X0018937E, "CS", "DecompositionMethod"),
    (0X0018937F, "UT", "DecompositionDescription"),
    (0X00189380, "SQ", "DecompositionAlgorithmIdentificationSequence"),
    (0X00189381, "SQ", "DecompositionMaterialSequence"),
    (0X00189382, "SQ", "MaterialAttenuationSequence"),
    (0X00189383, "DS", "PhotonEnergy"),
    (0X00189384, "DS", "XRayMassAttenuationCoefficient"),
    (0X00189401, "SQ", "ProjectionPixelCalibrationSequence"),
    (0X00189402, "FL", "DistanceSourceToIsocenter"),
    (0X00189403, "FL", "DistanceObjectToTableTop"),
    (0X00189404, "FL", "ObjectPixelSpacingInCenterOfBeam"),
    (0X00189405, "SQ", "PositionerPositionSequence"),
    (0X00189406, "SQ", "TablePositionSequence"),
    (0X00189407, "SQ", "CollimatorShapeSequence"),
    (0X00189410, "CS", "PlanesInAcquisition"),
    (0X00189412, "SQ", "XAXRFFrameCharacteristicsSequence"),
    (0X00189417, "SQ", "FrameAcquisitionSequence"),
    (0X00189420, "CS", "XRayReceptorType"),
    (0X00189423, "LO", "AcquisitionProtocolName"),
    (0X00189424, "LT", "AcquisitionProtocolDescription"),
    (0X00189425, "CS", "ContrastBolusIngredientOpaque"),
    (0X00189426, "FL", "DistanceReceptorPlaneToDetectorHousing"),
    (0X00189427, "CS", "IntensifierActiveShape"),
    (0X00189428, "FL", "IntensifierActiveDimensions"),
    (0X00189429, "FL", "PhysicalDetectorSize"),
    (0X00189430, "FL", "PositionOfIsocenterProjection"),
    (0X00189432, "SQ", "FieldOfViewSequence"),
    (0X00189433, "LO", "FieldOfViewDescription"),
    (0X00189434, "SQ", "ExposureControlSensingRegionsSequence"),
    (0X00189435, "CS", "ExposureControlSensingRegionShape"),
    (0X00189436, "SS", "ExposureControlSensingRegionLeftVerticalEdge"),
    (0X00189437, "SS", "ExposureControlSensingRegionRightVerticalEdge"),
    (0X00189438, "SS", "ExposureControlSensingRegionUpperHorizontalEdge"),
    (0X00189439, "SS", "ExposureControlSensingRegionLowerHorizontalEdge"),
    (0X00189440, "SS", "CenterOfCircularExposureControlSensingRegion"),
    (0X00189441, "US", "RadiusOfCircularExposureControlSensingRegion"),
    (0X00189442, "SS", "VerticesOfThePolygonalExposureControlSensingRegion"),
    (0X00189445, "OB", ""),
    (0X00189447, "FL", "ColumnAngulationPatient"),
    (0X00189449, "FL", "BeamAngle"),
    (0X00189451, "SQ", "FrameDetectorParametersSequence"),
    (0X00189452, "FL", "CalculatedAnatomyThickness"),
    (0X00189455, "SQ", "CalibrationSequence"),
    (0X00189456, "SQ", "ObjectThicknessSequence"),
    (0X00189457, "CS", "PlaneIdentification"),
    (0X00189461, "FL", "FieldOfViewDimensionsInFloat"),
    (0X00189462, "SQ", "IsocenterReferenceSystemSequence"),
    (0X00189463, "FL", "PositionerIsocenterPrimaryAngle"),
    (0X00189464, "FL", "PositionerIsocenterSecondaryAngle"),
    (0X00189465, "FL", "PositionerIsocenterDetectorRotationAngle"),
    (0X00189466, "FL", "TableXPositionToIsocenter"),
    (0X00189467, "FL", "TableYPositionToIsocenter"),
    (0X00189468, "FL", "TableZPositionToIsocenter"),
    (0X00189469, "FL", "TableHorizontalRotationAngle"),
    (0X00189470, "FL", "TableHeadTiltAngle"),
    (0X00189471, "FL", "TableCradleTiltAngle"),
    (0X00189472, "SQ", "FrameDisplayShutterSequence"),
    (0X00189473, "FL", "AcquiredImageAreaDoseProduct"),
    (0X00189474, "CS", "CArmPositionerTabletopRelationship"),
    (0X00189476, "SQ", "XRayGeometrySequence"),
    (0X00189477, "SQ", "IrradiationEventIdentificationSequence"),
    (0X00189504, "SQ", "XRay3DFrameTypeSequence"),
    (0X00189506, "SQ", "ContributingSourcesSequence"),
    (0X00189507, "SQ", "XRay3DAcquisitionSequence"),
    (0X00189508, "FL", "PrimaryPositionerScanArc"),
    (0X00189509, "FL", "SecondaryPositionerScanArc"),
    (0X00189510, "FL", "PrimaryPositionerScanStartAngle"),
    (0X00189511, "FL", "SecondaryPositionerScanStartAngle"),
    (0X00189514, "FL", "PrimaryPositionerIncrement"),
    (0X00189515, "FL", "SecondaryPositionerIncrement"),
    (0X00189516, "DT", "StartAcquisitionDateTime"),
    (0X00189517, "DT", "EndAcquisitionDateTime"),
    (0X00189518, "SS", "PrimaryPositionerIncrementSign"),
    (0X00189519, "SS", "SecondaryPositionerIncrementSign"),
    (0X00189524, "LO", "ApplicationName"),
    (0X00189525, "LO", "ApplicationVersion"),
    (0X00189526, "LO", "ApplicationManufacturer"),
    (0X00189527, "CS", "AlgorithmType"),
    (0X00189528, "LO", "AlgorithmDescription"),
    (0X00189530, "SQ", "XRay3DReconstructionSequence"),
    (0X00189531, "LO", "ReconstructionDescription"),
    (0X00189538, "SQ", "PerProjectionAcquisitionSequence"),
    (0X00189541, "SQ", "DetectorPositionSequence"),
    (0X00189542, "SQ", "XRayAcquisitionDoseSequence"),
    (0X00189543, "FD", "XRaySourceIsocenterPrimaryAngle"),
    (0X00189544, "FD", "XRaySourceIsocenterSecondaryAngle"),
    (0X00189545, "FD", "BreastSupportIsocenterPrimaryAngle"),
    (0X00189546, "FD", "BreastSupportIsocenterSecondaryAngle"),
    (0X00189547, "FD", "BreastSupportXPositionToIsocenter"),
    (0X00189548, "FD", "BreastSupportYPositionToIsocenter"),
    (0X00189549, "FD", "BreastSupportZPositionToIsocenter"),
    (0X00189550, "FD", "DetectorIsocenterPrimaryAngle"),
    (0X00189551, "FD", "DetectorIsocenterSecondaryAngle"),
    (0X00189552, "FD", "DetectorXPositionToIsocenter"),
    (0X00189553, "FD", "DetectorYPositionToIsocenter"),
    (0X00189554, "FD", "DetectorZPositionToIsocenter"),
    (0X00189555, "SQ", "XRayGridSequence"),
    (0X00189556, "SQ", "XRayFilterSequence"),
    (0X00189557, "FD", "DetectorActiveAreaTLHCPosition"),
    (0X00189558, "FD", "DetectorActiveAreaOrientation"),
    (0X00189559, "CS", "PositionerPrimaryAngleDirection"),
    (0X00189601, "SQ", "DiffusionBMatrixSequence"),
    (0X00189602, "FD", "DiffusionBValueXX"),
    (0X00189603, "FD", "DiffusionBValueXY"),
    (0X00189604, "FD", "DiffusionBValueXZ"),
    (0X00189605, "FD", "DiffusionBValueYY"),
    (0X00189606, "FD", "DiffusionBValueYZ"),
    (0X00189607, "FD", "DiffusionBValueZZ"),
    (0X00189621, "SQ", "FunctionalMRSequence"),
    (0X00189622, "CS", "FunctionalSettlingPhaseFramesPresent"),
    (0X00189623, "DT", "FunctionalSyncPulse"),
    (0X00189624, "CS", "SettlingPhaseFrame"),
    (0X00189701, "DT", "DecayCorrectionDateTime"),
    (0X00189715, "FD", "StartDensityThreshold"),
    (0X00189716, "FD", "StartRelativeDensityDifferenceThreshold"),
    (0X00189717, "FD", "StartCardiacTriggerCountThreshold"),
    (0X00189718, "FD", "StartRespiratoryTriggerCountThreshold"),
    (0X00189719, "FD", "TerminationCountsThreshold"),
    (0X00189720, "FD", "TerminationDensityThreshold"),
    (0X00189721, "FD", "TerminationRelativeDensityThreshold"),
    (0X00189722, "FD", "TerminationTimeThreshold"),
    (0X00189723, "FD", "TerminationCardiacTriggerCountThreshold"),
    (0X00189724, "FD", "TerminationRespiratoryTriggerCountThreshold"),
    (0X00189725, "CS", "DetectorGeometry"),
    (0X00189726, "FD", "TransverseDetectorSeparation"),
    (0X00189727, "FD", "AxialDetectorDimension"),
    (0X00189729, "US", "RadiopharmaceuticalAgentNumber"),
    (0X00189732, "SQ", "PETFrameAcquisitionSequence"),
    (0X00189733, "SQ", "PETDetectorMotionDetailsSequence"),
    (0X00189734, "SQ", "PETTableDynamicsSequence"),
    (0X00189735, "SQ", "PETPositionSequence"),
    (0X00189736, "SQ", "PETFrameCorrectionFactorsSequence"),
    (0X00189737, "SQ", "RadiopharmaceuticalUsageSequence"),
    (0X00189738, "CS", "AttenuationCorrectionSource"),
    (0X00189739, "US", "NumberOfIterations"),
    (0X00189740, "US", "NumberOfSubsets"),
    (0X00189749, "SQ", "PETReconstructionSequence"),
    (0X00189751, "SQ", "PETFrameTypeSequence"),
    (0X00189755, "CS", "TimeOfFlightInformationUsed"),
    (0X00189756, "CS", "ReconstructionType"),
    (0X00189758, "CS", "DecayCorrected"),
    (0X00189759, "CS", "AttenuationCorrected"),
    (0X00189760, "CS", "ScatterCorrected"),
    (0X00189761, "CS", "DeadTimeCorrected"),
    (0X00189762, "CS", "GantryMotionCorrected"),
    (0X00189763, "CS", "PatientMotionCorrected"),
    (0X00189764, "CS", "CountLossNormalizationCorrected"),
    (0X00189765, "CS", "RandomsCorrected"),
    (0X00189766, "CS", "NonUniformRadialSamplingCorrected"),
    (0X00189767, "CS", "SensitivityCalibrated"),
    (0X00189768, "CS", "DetectorNormalizationCorrection"),
    (0X00189769, "CS", "IterativeReconstructionMethod"),
    (0X00189770, "CS", "AttenuationCorrectionTemporalRelationship"),
    (0X00189771, "SQ", "PatientPhysiologicalStateSequence"),
    (0X00189772, "SQ", "PatientPhysiologicalStateCodeSequence"),
    (0X00189801, "FD", "DepthsOfFocus"),
    (0X00189803, "SQ", "ExcludedIntervalsSequence"),
    (0X00189804, "DT", "ExclusionStartDateTime"),
    (0X00189805, "FD", "ExclusionDuration"),
    (0X00189806, "SQ", "USImageDescriptionSequence"),
    (0X00189807, "SQ", "ImageDataTypeSequence"),
    (0X00189808, "CS", "DataType"),
    (0X00189809, "SQ", "TransducerScanPatternCodeSequence"),
    (0X0018980B, "CS", "AliasedDataType"),
    (0X0018980C, "CS", "PositionMeasuringDeviceUsed"),
    (0X0018980D, "SQ", "TransducerGeometryCodeSequence"),
    (0X0018980E, "SQ", "TransducerBeamSteeringCodeSequence"),
    (0X0018980F, "SQ", "TransducerApplicationCodeSequence"),
    (0X00189810, "SS", "ZeroVelocityPixelValue"),
    (0X00189900, "LO", "ReferenceLocationLabel"),
    (0X00189901, "UT", "ReferenceLocationDescription"),
    (0X00189902, "SQ", "ReferenceBasisCodeSequence"),
    (0X00189903, "SQ", "ReferenceGeometryCodeSequence"),
    (0X00189904, "DS", "OffsetDistance"),
    (0X00189905, "CS", "OffsetDirection"),
    (0X00189906, "SQ", "PotentialScheduledProtocolCodeSequence"),
    (0X00189907, "SQ", "PotentialRequestedProcedureCodeSequence"),
    (0X00189908, "UC", "PotentialReasonsForProcedure"),
    (0X00189909, "SQ", "PotentialReasonsForProcedureCodeSequence"),
    (0X0018990A, "UC", "PotentialDiagnosticTasks"),
    (0X0018990B, "SQ", "ContraindicationsCodeSequence"),
    (0X0018990C, "SQ", "ReferencedDefinedProtocolSequence"),
    (0X0018990D, "SQ", "ReferencedPerformedProtocolSequence"),
    (0X0018990E, "SQ", "PredecessorProtocolSequence"),
    (0X0018990F, "UT", "ProtocolPlanningInformation"),
    (0X00189910, "UT", "ProtocolDesignRationale"),
    (0X00189911, "SQ", "PatientSpecificationSequence"),
    (0X00189912, "SQ", "ModelSpecificationSequence"),
    (0X00189913, "SQ", "ParametersSpecificationSequence"),
    (0X00189914, "SQ", "InstructionSequence"),
    (0X00189915, "US", "InstructionIndex"),
    (0X00189916, "LO", "InstructionText"),
    (0X00189917, "UT", "InstructionDescription"),
    (0X00189918, "CS", "InstructionPerformedFlag"),
    (0X00189919, "DT", "InstructionPerformedDateTime"),
    (0X0018991A, "UT", "InstructionPerformanceComment"),
    (0X0018991B, "SQ", "PatientPositioningInstructionSequence"),
    (0X0018991C, "SQ", "PositioningMethodCodeSequence"),
    (0X0018991D, "SQ", "PositioningLandmarkSequence"),
    (0X0018991E, "UI", "TargetFrameOfReferenceUID"),
    (0X0018991F, "SQ", "AcquisitionProtocolElementSpecificationSequence"),
    (0X00189920, "SQ", "AcquisitionProtocolElementSequence"),
    (0X00189921, "US", "ProtocolElementNumber"),
    (0X00189922, "LO", "ProtocolElementName"),
    (0X00189923, "UT", "ProtocolElementCharacteristicsSummary"),
    (0X00189924, "UT", "ProtocolElementPurpose"),
    (0X00189930, "CS", "AcquisitionMotion"),
    (0X00189931, "SQ", "AcquisitionStartLocationSequence"),
    (0X00189932, "SQ", "AcquisitionEndLocationSequence"),
    (0X00189933, "SQ", "ReconstructionProtocolElementSpecificationSequence"),
    (0X00189934, "SQ", "ReconstructionProtocolElementSequence"),
    (0X00189935, "SQ", "StorageProtocolElementSpecificationSequence"),
    (0X00189936, "SQ", "StorageProtocolElementSequence"),
    (0X00189937, "LO", "RequestedSeriesDescription"),
    (0X00189938, "US", "SourceAcquisitionProtocolElementNumber"),
    (0X00189939, "US", "SourceAcquisitionBeamNumber"),
    (0X0018993A, "US", "SourceReconstructionProtocolElementNumber"),
    (0X0018993B, "SQ", "ReconstructionStartLocationSequence"),
    (0X0018993C, "SQ", "ReconstructionEndLocationSequence"),
    (0X0018993D, "SQ", "ReconstructionAlgorithmSequence"),
    (0X0018993E, "SQ", "ReconstructionTargetCenterLocationSequence"),
    (0X00189941, "UT", "ImageFilterDescription"),
    (0X00189942, "FD", "CTDIvolNotificationTrigger"),
    (0X00189943, "FD", "DLPNotificationTrigger"),
    (0X00189944, "CS", "AutoKVPSelectionType"),
    (0X00189945, "FD", "AutoKVPUpperBound"),
    (0X00189946, "FD", "AutoKVPLowerBound"),
    (0X00189947, "CS", "ProtocolDefinedPatientPosition"),
    (0X0018A001, "SQ", "ContributingEquipmentSequence"),
    (0X0018A002, "DT", "ContributionDateTime"),
    (0X0018A003, "ST", "ContributionDescription"),
    (0X0020000D, "UI", "StudyInstanceUID"),
    (0X0020000E, "UI", "SeriesInstanceUID"),
    (0X00200010, "SH", "StudyID"),
    (0X00200011, "IS", "SeriesNumber"),
    (0X00200012, "IS", "AcquisitionNumber"),
    (0X00200013, "IS", "InstanceNumber"),
    (0X00200014, "IS", "IsotopeNumber"),
    (0X00200015, "IS", "PhaseNumber"),
    (0X00200016, "IS", "IntervalNumber"),
    (0X00200017, "IS", "TimeSlotNumber"),
    (0X00200018, "IS", "AngleNumber"),
    (0X00200019, "IS", "ItemNumber"),
    (0X00200020, "CS", "PatientOrientation"),
    (0X00200022, "IS", "OverlayNumber"),
    (0X00200024, "IS", "CurveNumber"),
    (0X00200026, "IS", "LUTNumber"),
    (0X00200030, "DS", "ImagePosition"),
    (0X00200032, "DS", "ImagePositionPatient"),
    (0X00200035, "DS", "ImageOrientation"),
    (0X00200037, "DS", "ImageOrientationPatient"),
    (0X00200050, "DS", "Location"),
    (0X00200052, "UI", "FrameOfReferenceUID"),
    (0X00200060, "CS", "Laterality"),
    (0X00200062, "CS", "ImageLaterality"),
    (0X00200070, "LO", "ImageGeometryType"),
    (0X00200080, "CS", "MaskingImage"),
    (0X002000AA, "IS", "ReportNumber"),
    (0X00200100, "IS", "TemporalPositionIdentifier"),
    (0X00200105, "IS", "NumberOfTemporalPositions"),
    (0X00200110, "DS", "TemporalResolution"),
    (0X00200200, "UI", "SynchronizationFrameOfReferenceUID"),
    (0X00200242, "UI", "SOPInstanceUIDOfConcatenationSource"),
    (0X00201000, "IS", "SeriesInStudy"),
    (0X00201001, "IS", "AcquisitionsInSeries"),
    (0X00201002, "IS", "ImagesInAcquisition"),
    (0X00201003, "IS", "ImagesInSeries"),
    (0X00201004, "IS", "AcquisitionsInStudy"),
    (0X00201005, "IS", "ImagesInStudy"),
    (0X00201020, "LO", "Reference"),
    (0X0020103F, "LO", "TargetPositionReferenceIndicator"),
    (0X00201040, "LO", "PositionReferenceIndicator"),
    (0X00201041, "DS", "SliceLocation"),
    (0X00201070, "IS", "OtherStudyNumbers"),
    (0X00201200, "IS", "NumberOfPatientRelatedStudies"),
    (0X00201202, "IS", "NumberOfPatientRelatedSeries"),
    (0X00201204, "IS", "NumberOfPatientRelatedInstances"),
    (0X00201206, "IS", "NumberOfStudyRelatedSeries"),
    (0X00201208, "IS", "NumberOfStudyRelatedInstances"),
    (0X00201209, "IS", "NumberOfSeriesRelatedInstances"),
    (0X00203401, "CS", "ModifyingDeviceID"),
    (0X00203402, "CS", "ModifiedImageID"),
    (0X00203403, "DA", "ModifiedImageDate"),
    (0X00203404, "LO", "ModifyingDeviceManufacturer"),
    (0X00203405, "TM", "ModifiedImageTime"),
    (0X00203406, "LO", "ModifiedImageDescription"),
    (0X00204000, "LT", "ImageComments"),
    (0X00205000, "AT", "OriginalImageIdentification"),
    (0X00205002, "LO", "OriginalImageIdentificationNomenclature"),
    (0X00209056, "SH", "StackID"),
    (0X00209057, "UL", "InStackPositionNumber"),
    (0X00209071, "SQ", "FrameAnatomySequence"),
    (0X00209072, "CS", "FrameLaterality"),
    (0X00209111, "SQ", "FrameContentSequence"),
    (0X00209113, "SQ", "PlanePositionSequence"),
    (0X00209116, "SQ", "PlaneOrientationSequence"),
    (0X00209128, "UL", "TemporalPositionIndex"),
    (0X00209153, "FD", "NominalCardiacTriggerDelayTime"),
    (0X00209154, "FL", "NominalCardiacTriggerTimePriorToRPeak"),
    (0X00209155, "FL", "ActualCardiacTriggerTimePriorToRPeak"),
    (0X00209156, "US", "FrameAcquisitionNumber"),
    (0X00209157, "UL", "DimensionIndexValues"),
    (0X00209158, "LT", "FrameComments"),
    (0X00209161, "UI", "ConcatenationUID"),
    (0X00209162, "US", "InConcatenationNumber"),
    (0X00209163, "US", "InConcatenationTotalNumber"),
    (0X00209164, "UI", "DimensionOrganizationUID"),
    (0X00209165, "AT", "DimensionIndexPointer"),
    (0X00209167, "AT", "FunctionalGroupPointer"),
    (0X00209170, "SQ", "UnassignedSharedConvertedAttributesSequence"),
    (0X00209171, "SQ", "UnassignedPerFrameConvertedAttributesSequence"),
    (0X00209172, "SQ", "ConversionSourceAttributesSequence"),
    (0X00209213, "LO", "DimensionIndexPrivateCreator"),
    (0X00209221, "SQ", "DimensionOrganizationSequence"),
    (0X00209222, "SQ", "DimensionIndexSequence"),
    (0X00209228, "UL", "ConcatenationFrameOffsetNumber"),
    (0X00209238, "LO", "FunctionalGroupPrivateCreator"),
    (0X00209241, "FL", "NominalPercentageOfCardiacPhase"),
    (0X00209245, "FL", "NominalPercentageOfRespiratoryPhase"),
    (0X00209246, "FL", "StartingRespiratoryAmplitude"),
    (0X00209247, "CS", "StartingRespiratoryPhase"),
    (0X00209248, "FL", "EndingRespiratoryAmplitude"),
    (0X00209249, "CS", "EndingRespiratoryPhase"),
    (0X00209250, "CS", "RespiratoryTriggerType"),
    (0X00209251, "FD", "RRIntervalTimeNominal"),
    (0X00209252, "FD", "ActualCardiacTriggerDelayTime"),
    (0X00209253, "SQ", "RespiratorySynchronizationSequence"),
    (0X00209254, "FD", "RespiratoryIntervalTime"),
    (0X00209255, "FD", "NominalRespiratoryTriggerDelayTime"),
    (0X00209256, "FD", "RespiratoryTriggerDelayThreshold"),
    (0X00209257, "FD", "ActualRespiratoryTriggerDelayTime"),
    (0X00209301, "FD", "ImagePositionVolume"),
    (0X00209302, "FD", "ImageOrientationVolume"),
    (0X00209307, "CS", "UltrasoundAcquisitionGeometry"),
    (0X00209308, "FD", "ApexPosition"),
    (0X00209309, "FD", "VolumeToTransducerMappingMatrix"),
    (0X0020930A, "FD", "VolumeToTableMappingMatrix"),
    (0X0020930B, "CS", "VolumeToTransducerRelationship"),
    (0X0020930C, "CS", "PatientFrameOfReferenceSource"),
    (0X0020930D, "FD", "TemporalPositionTimeOffset"),
    (0X0020930E, "SQ", "PlanePositionVolumeSequence"),
    (0X0020930F, "SQ", "PlaneOrientationVolumeSequence"),
    (0X00209310, "SQ", "TemporalPositionSequence"),
    (0X00209311, "CS", "DimensionOrganizationType"),
    (0X00209312, "UI", "VolumeFrameOfReferenceUID"),
    (0X00209313, "UI", "TableFrameOfReferenceUID"),
    (0X00209421, "LO", "DimensionDescriptionLabel"),
    (0X00209450, "SQ", "PatientOrientationInFrameSequence"),
    (0X00209453, "LO", "FrameLabel"),
    (0X00209518, "US", "AcquisitionIndex"),
    (0X00209529, "SQ", "ContributingSOPInstancesReferenceSequence"),
    (0X00209536, "US", "ReconstructionIndex"),
    (0X00220001, "US", "LightPathFilterPassThroughWavelength"),
    (0X00220002, "US", "LightPathFilterPassBand"),
    (0X00220003, "US", "ImagePathFilterPassThroughWavelength"),
    (0X00220004, "US", "ImagePathFilterPassBand"),
    (0X00220005, "CS", "PatientEyeMovementCommanded"),
    (0X00220006, "SQ", "PatientEyeMovementCommandCodeSequence"),
    (0X00220007, "FL", "SphericalLensPower"),
    (0X00220008, "FL", "CylinderLensPower"),
    (0X00220009, "FL", "CylinderAxis"),
    (0X0022000A, "FL", "EmmetropicMagnification"),
    (0X0022000B, "FL", "IntraOcularPressure"),
    (0X0022000C, "FL", "HorizontalFieldOfView"),
    (0X0022000D, "CS", "PupilDilated"),
    (0X0022000E, "FL", "DegreeOfDilation"),
    (0X00220010, "FL", "StereoBaselineAngle"),
    (0X00220011, "FL", "StereoBaselineDisplacement"),
    (0X00220012, "FL", "StereoHorizontalPixelOffset"),
    (0X00220013, "FL", "StereoVerticalPixelOffset"),
    (0X00220014, "FL", "StereoRotation"),
    (0X00220015, "SQ", "AcquisitionDeviceTypeCodeSequence"),
    (0X00220016, "SQ", "IlluminationTypeCodeSequence"),
    (0X00220017, "SQ", "LightPathFilterTypeStackCodeSequence"),
    (0X00220018, "SQ", "ImagePathFilterTypeStackCodeSequence"),
    (0X00220019, "SQ", "LensesCodeSequence"),
    (0X0022001A, "SQ", "ChannelDescriptionCodeSequence"),
    (0X0022001B, "SQ", "RefractiveStateSequence"),
    (0X0022001C, "SQ", "MydriaticAgentCodeSequence"),
    (0X0022001D, "SQ", "RelativeImagePositionCodeSequence"),
    (0X0022001E, "FL", "CameraAngleOfView"),
    (0X00220020, "SQ", "StereoPairsSequence"),
    (0X00220021, "SQ", "LeftImageSequence"),
    (0X00220022, "SQ", "RightImageSequence"),
    (0X00220028, "CS", "StereoPairsPresent"),
    (0X00220030, "FL", "AxialLengthOfTheEye"),
    (0X00220031, "SQ", "OphthalmicFrameLocationSequence"),
    (0X00220032, "FL", "ReferenceCoordinates"),
    (0X00220035, "FL", "DepthSpatialResolution"),
    (0X00220036, "FL", "MaximumDepthDistortion"),
    (0X00220037, "FL", "AlongScanSpatialResolution"),
    (0X00220038, "FL", "MaximumAlongScanDistortion"),
    (0X00220039, "CS", "OphthalmicImageOrientation"),
    (0X00220041, "FL", "DepthOfTransverseImage"),
    (0X00220042, "SQ", "MydriaticAgentConcentrationUnitsSequence"),
    (0X00220048, "FL", "AcrossScanSpatialResolution"),
    (0X00220049, "FL", "MaximumAcrossScanDistortion"),
    (0X0022004E, "DS", "MydriaticAgentConcentration"),
    (0X00220055, "FL", "IlluminationWaveLength"),
    (0X00220056, "FL", "IlluminationPower"),
    (0X00220057, "FL", "IlluminationBandwidth"),
    (0X00220058, "SQ", "MydriaticAgentSequence"),
    (0X00221007, "SQ", "OphthalmicAxialMeasurementsRightEyeSequence"),
    (0X00221008, "SQ", "OphthalmicAxialMeasurementsLeftEyeSequence"),
    (0X00221009, "CS", "OphthalmicAxialMeasurementsDeviceType"),
    (0X00221010, "CS", "OphthalmicAxialLengthMeasurementsType"),
    (0X00221012, "SQ", "OphthalmicAxialLengthSequence"),
    (0X00221019, "FL", "OphthalmicAxialLength"),
    (0X00221024, "SQ", "LensStatusCodeSequence"),
    (0X00221025, "SQ", "VitreousStatusCodeSequence"),
    (0X00221028, "SQ", "IOLFormulaCodeSequence"),
    (0X00221029, "LO", "IOLFormulaDetail"),
    (0X00221033, "FL", "KeratometerIndex"),
    (0X00221035, "SQ", "SourceOfOphthalmicAxialLengthCodeSequence"),
    (0X00221036, "SQ", "SourceOfCornealSizeDataCodeSequence"),
    (0X00221037, "FL", "TargetRefraction"),
    (0X00221039, "CS", "RefractiveProcedureOccurred"),
    (0X00221040, "SQ", "RefractiveSurgeryTypeCodeSequence"),
    (0X00221044, "SQ", "OphthalmicUltrasoundMethodCodeSequence"),
    (0X00221045, "SQ", "SurgicallyInducedAstigmatismSequence"),
    (0X00221046, "CS", "TypeOfOpticalCorrection"),
    (0X00221047, "SQ", "ToricIOLPowerSequence"),
    (0X00221048, "SQ", "PredictedToricErrorSequence"),
    (0X00221049, "CS", "PreSelectedForImplantation"),
    (0X0022104A, "SQ", "ToricIOLPowerForExactEmmetropiaSequence"),
    (0X0022104B, "SQ", "ToricIOLPowerForExactTargetRefractionSequence"),
    (0X00221050, "SQ", "OphthalmicAxialLengthMeasurementsSequence"),
    (0X00221053, "FL", "IOLPower"),
    (0X00221054, "FL", "PredictedRefractiveError"),
    (0X00221059, "FL", "OphthalmicAxialLengthVelocity"),
    (0X00221065, "LO", "LensStatusDescription"),
    (0X00221066, "LO", "VitreousStatusDescription"),
    (0X00221090, "SQ", "IOLPowerSequence"),
    (0X00221092, "SQ", "LensConstantSequence"),
    (0X00221093, "LO", "IOLManufacturer"),
    (0X00221094, "LO", "LensConstantDescription"),
    (0X00221095, "LO", "ImplantName"),
    (0X00221096, "SQ", "KeratometryMeasurementTypeCodeSequence"),
    (0X00221097, "LO", "ImplantPartNumber"),
    (0X00221100, "SQ", "ReferencedOphthalmicAxialMeasurementsSequence"),
    (0X00221101, "SQ", "OphthalmicAxialLengthMeasurementsSegmentNameCodeSequence"),
    (0X00221103, "SQ", "RefractiveErrorBeforeRefractiveSurgeryCodeSequence"),
    (0X00221121, "FL", "IOLPowerForExactEmmetropia"),
    (0X00221122, "FL", "IOLPowerForExactTargetRefraction"),
    (0X00221125, "SQ", "AnteriorChamberDepthDefinitionCodeSequence"),
    (0X00221127, "SQ", "LensThicknessSequence"),
    (0X00221128, "SQ", "AnteriorChamberDepthSequence"),
    (0X0022112A, "SQ", "CalculationCommentSequence"),
    (0X0022112B, "CS", "CalculationCommentType"),
    (0X0022112C, "LT", "CalculationComment"),
    (0X00221130, "FL", "LensThickness"),
    (0X00221131, "FL", "AnteriorChamberDepth"),
    (0X00221132, "SQ", "SourceOfLensThicknessDataCodeSequence"),
    (0X00221133, "SQ", "SourceOfAnteriorChamberDepthDataCodeSequence"),
    (0X00221134, "SQ", "SourceOfRefractiveMeasurementsSequence"),
    (0X00221135, "SQ", "SourceOfRefractiveMeasurementsCodeSequence"),
    (0X00221140, "CS", "OphthalmicAxialLengthMeasurementModified"),
    (0X00221150, "SQ", "OphthalmicAxialLengthDataSourceCodeSequence"),
    (0X00221153, "SQ", "OphthalmicAxialLengthAcquisitionMethodCodeSequence"),
    (0X00221155, "FL", "SignalToNoiseRatio"),
    (0X00221159, "LO", "OphthalmicAxialLengthDataSourceDescription"),
    (0X00221210, "SQ", "OphthalmicAxialLengthMeasurementsTotalLengthSequence"),
    (0X00221211, "SQ", "OphthalmicAxialLengthMeasurementsSegmentalLengthSequence"),
    (0X00221212, "SQ", "OphthalmicAxialLengthMeasurementsLengthSummationSequence"),
    (0X00221220, "SQ", "UltrasoundOphthalmicAxialLengthMeasurementsSequence"),
    (0X00221225, "SQ", "OpticalOphthalmicAxialLengthMeasurementsSequence"),
    (0X00221230, "SQ", "UltrasoundSelectedOphthalmicAxialLengthSequence"),
    (0X00221250, "SQ", "OphthalmicAxialLengthSelectionMethodCodeSequence"),
    (0X00221255, "SQ", "OpticalSelectedOphthalmicAxialLengthSequence"),
    (0X00221257, "SQ", "SelectedSegmentalOphthalmicAxialLengthSequence"),
    (0X00221260, "SQ", "SelectedTotalOphthalmicAxialLengthSequence"),
    (0X00221262, "SQ", "OphthalmicAxialLengthQualityMetricSequence"),
    (0X00221265, "SQ", "OphthalmicAxialLengthQualityMetricTypeCodeSequence"),
    (0X00221273, "LO", "OphthalmicAxialLengthQualityMetricTypeDescription"),
    (0X00221300, "SQ", "IntraocularLensCalculationsRightEyeSequence"),
    (0X00221310, "SQ", "IntraocularLensCalculationsLeftEyeSequence"),
    (0X00221330, "SQ", "ReferencedOphthalmicAxialLengthMeasurementQCImageSequence"),
    (0X00221415, "CS", "OphthalmicMappingDeviceType"),
    (0X00221420, "SQ", "AcquisitionMethodCodeSequence"),
    (0X00221423, "SQ", "AcquisitionMethodAlgorithmSequence"),
    (0X00221436, "SQ", "OphthalmicThicknessMapTypeCodeSequence"),
    (0X00221443, "SQ", "OphthalmicThicknessMappingNormalsSequence"),
    (0X00221445, "SQ", "RetinalThicknessDefinitionCodeSequence"),
    (0X00221450, "SQ", "PixelValueMappingToCodedConceptSequence"),
    (0X00221452, "SS", "MappedPixelValue"),
    (0X00221454, "LO", "PixelValueMappingExplanation"),
    (0X00221458, "SQ", "OphthalmicThicknessMapQualityThresholdSequence"),
    (0X00221460, "FL", "OphthalmicThicknessMapThresholdQualityRating"),
    (0X00221463, "FL", "AnatomicStructureReferencePoint"),
    (0X00221465, "SQ", "RegistrationToLocalizerSequence"),
    (0X00221466, "CS", "RegisteredLocalizerUnits"),
    (0X00221467, "FL", "RegisteredLocalizerTopLeftHandCorner"),
    (0X00221468, "FL", "RegisteredLocalizerBottomRightHandCorner"),
    (0X00221470, "SQ", "OphthalmicThicknessMapQualityRatingSequence"),
    (0X00221472, "SQ", "RelevantOPTAttributesSequence"),
    (0X00221512, "SQ", "TransformationMethodCodeSequence"),
    (0X00221513, "SQ", "TransformationAlgorithmSequence"),
    (0X00221515, "CS", "OphthalmicAxialLengthMethod"),
    (0X00221517, "FL", "OphthalmicFOV"),
    (0X00221518, "SQ", "TwoDimensionalToThreeDimensionalMapSequence"),
    (0X00221525, "SQ", "WideFieldOphthalmicPhotographyQualityRatingSequence"),
    (0X00221526, "SQ", "WideFieldOphthalmicPhotographyQualityThresholdSequence"),
    (0X00221527, "FL", "WideFieldOphthalmicPhotographyThresholdQualityRating"),
    (0X00221528, "FL", "XCoordinatesCenterPixelViewAngle"),
    (0X00221529, "FL", "YCoordinatesCenterPixelViewAngle"),
    (0X00221530, "UL", "NumberOfMapPoints"),
    (0X00221531, "OF", "TwoDimensionalToThreeDimensionalMapData"),
    (0X00221612, "SQ", "DerivationAlgorithmSequence"),
    (0X00221615, "SQ", "OphthalmicImageTypeCodeSequence"),
    (0X00221616, "LO", "OphthalmicImageTypeDescription"),
    (0X00221618, "SQ", "ScanPatternTypeCodeSequence"),
    (0X00221620, "SQ", "ReferencedSurfaceMeshIdentificationSequence"),
    (0X00221622, "CS", "OphthalmicVolumetricPropertiesFlag"),
    (0X00221624, "FL", "OphthalmicAnatomicReferencePointXCoordinate"),
    (0X00221626, "FL", "OphthalmicAnatomicReferencePointYCoordinate"),
    (0X00221628, "SQ", "OphthalmicEnFaceImageQualityRatingSequence"),
    (0X00221630, "DS", "QualityThreshold"),
    (0X00221640, "SQ", "OCTBscanAnalysisAcquisitionParametersSequence"),
    (0X00221642, "UL", "NumberOfBscansPerFrame"),
    (0X00221643, "FL", "BscanSlabThickness"),
    (0X00221644, "FL", "DistanceBetweenBscanSlabs"),
    (0X00221645, "FL", "BscanCycleTime"),
    (0X00221646, "FL", "BscanCycleTimeVector"),
    (0X00221649, "FL", "AscanRate"),
    (0X00221650, "FL", "BscanRate"),
    (0X00221658, "UL", "SurfaceMeshZPixelOffset"),
    (0X00240010, "FL", "VisualFieldHorizontalExtent"),
    (0X00240011, "FL", "VisualFieldVerticalExtent"),
    (0X00240012, "CS", "VisualFieldShape"),
    (0X00240016, "SQ", "ScreeningTestModeCodeSequence"),
    (0X00240018, "FL", "MaximumStimulusLuminance"),
    (0X00240020, "FL", "BackgroundLuminance"),
    (0X00240021, "SQ", "StimulusColorCodeSequence"),
    (0X00240024, "SQ", "BackgroundIlluminationColorCodeSequence"),
    (0X00240025, "FL", "StimulusArea"),
    (0X00240028, "FL", "StimulusPresentationTime"),
    (0X00240032, "SQ", "FixationSequence"),
    (0X00240033, "SQ", "FixationMonitoringCodeSequence"),
    (0X00240034, "SQ", "VisualFieldCatchTrialSequence"),
    (0X00240035, "US", "FixationCheckedQuantity"),
    (0X00240036, "US", "PatientNotProperlyFixatedQuantity"),
    (0X00240037, "CS", "PresentedVisualStimuliDataFlag"),
    (0X00240038, "US", "NumberOfVisualStimuli"),
    (0X00240039, "CS", "ExcessiveFixationLossesDataFlag"),
    (0X00240040, "CS", "ExcessiveFixationLosses"),
    (0X00240042, "US", "StimuliRetestingQuantity"),
    (0X00240044, "LT", "CommentsOnPatientPerformanceOfVisualField"),
    (0X00240045, "CS", "FalseNegativesEstimateFlag"),
    (0X00240046, "FL", "FalseNegativesEstimate"),
    (0X00240048, "US", "NegativeCatchTrialsQuantity"),
    (0X00240050, "US", "FalseNegativesQuantity"),
    (0X00240051, "CS", "ExcessiveFalseNegativesDataFlag"),
    (0X00240052, "CS", "ExcessiveFalseNegatives"),
    (0X00240053, "CS", "FalsePositivesEstimateFlag"),
    (0X00240054, "FL", "FalsePositivesEstimate"),
    (0X00240055, "CS", "CatchTrialsDataFlag"),
    (0X00240056, "US", "PositiveCatchTrialsQuantity"),
    (0X00240057, "CS", "TestPointNormalsDataFlag"),
    (0X00240058, "SQ", "TestPointNormalsSequence"),
    (0X00240059, "CS", "GlobalDeviationProbabilityNormalsFlag"),
    (0X00240060, "US", "FalsePositivesQuantity"),
    (0X00240061, "CS", "ExcessiveFalsePositivesDataFlag"),
    (0X00240062, "CS", "ExcessiveFalsePositives"),
    (0X00240063, "CS", "VisualFieldTestNormalsFlag"),
    (0X00240064, "SQ", "ResultsNormalsSequence"),
    (0X00240065, "SQ", "AgeCorrectedSensitivityDeviationAlgorithmSequence"),
    (0X00240066, "FL", "GlobalDeviationFromNormal"),
    (0X00240067, "SQ", "GeneralizedDefectSensitivityDeviationAlgorithmSequence"),
    (0X00240068, "FL", "LocalizedDeviationFromNormal"),
    (0X00240069, "LO", "PatientReliabilityIndicator"),
    (0X00240070, "FL", "VisualFieldMeanSensitivity"),
    (0X00240071, "FL", "GlobalDeviationProbability"),
    (0X00240072, "CS", "LocalDeviationProbabilityNormalsFlag"),
    (0X00240073, "FL", "LocalizedDeviationProbability"),
    (0X00240074, "CS", "ShortTermFluctuationCalculated"),
    (0X00240075, "FL", "ShortTermFluctuation"),
    (0X00240076, "CS", "ShortTermFluctuationProbabilityCalculated"),
    (0X00240077, "FL", "ShortTermFluctuationProbability"),
    (0X00240078, "CS", "CorrectedLocalizedDeviationFromNormalCalculated"),
    (0X00240079, "FL", "CorrectedLocalizedDeviationFromNormal"),
    (0X00240080, "CS", "CorrectedLocalizedDeviationFromNormalProbabilityCalculated"),
    (0X00240081, "FL", "CorrectedLocalizedDeviationFromNormalProbability"),
    (0X00240083, "SQ", "GlobalDeviationProbabilitySequence"),
    (0X00240085, "SQ", "LocalizedDeviationProbabilitySequence"),
    (0X00240086, "CS", "FovealSensitivityMeasured"),
    (0X00240087, "FL", "FovealSensitivity"),
    (0X00240088, "FL", "VisualFieldTestDuration"),
    (0X00240089, "SQ", "VisualFieldTestPointSequence"),
    (0X00240090, "FL", "VisualFieldTestPointXCoordinate"),
    (0X00240091, "FL", "VisualFieldTestPointYCoordinate"),
    (0X00240092, "FL", "AgeCorrectedSensitivityDeviationValue"),
    (0X00240093, "CS", "StimulusResults"),
    (0X00240094, "FL", "SensitivityValue"),
    (0X00240095, "CS", "RetestStimulusSeen"),
    (0X00240096, "FL", "RetestSensitivityValue"),
    (0X00240097, "SQ", "VisualFieldTestPointNormalsSequence"),
    (0X00240098, "FL", "QuantifiedDefect"),
    (0X00240100, "FL", "AgeCorrectedSensitivityDeviationProbabilityValue"),
    (0X00240102, "CS", "GeneralizedDefectCorrectedSensitivityDeviationFlag"),
    (0X00240103, "FL", "GeneralizedDefectCorrectedSensitivityDeviationValue"),
    (0X00240104, "FL", "GeneralizedDefectCorrectedSensitivityDeviationProbabilityValue"),
    (0X00240105, "FL", "MinimumSensitivityValue"),
    (0X00240106, "CS", "BlindSpotLocalized"),
    (0X00240107, "FL", "BlindSpotXCoordinate"),
    (0X00240108, "FL", "BlindSpotYCoordinate"),
    (0X00240110, "SQ", "VisualAcuityMeasurementSequence"),
    (0X00240112, "SQ", "RefractiveParametersUsedOnPatientSequence"),
    (0X00240113, "CS", "MeasurementLaterality"),
    (0X00240114, "SQ", "OphthalmicPatientClinicalInformationLeftEyeSequence"),
    (0X00240115, "SQ", "OphthalmicPatientClinicalInformationRightEyeSequence"),
    (0X00240117, "CS", "FovealPointNormativeDataFlag"),
    (0X00240118, "FL", "FovealPointProbabilityValue"),
    (0X00240120, "CS", "ScreeningBaselineMeasured"),
    (0X00240122, "SQ", "ScreeningBaselineMeasuredSequence"),
    (0X00240124, "CS", "ScreeningBaselineType"),
    (0X00240126, "FL", "ScreeningBaselineValue"),
    (0X00240202, "LO", "AlgorithmSource"),
    (0X00240306, "LO", "DataSetName"),
    (0X00240307, "LO", "DataSetVersion"),
    (0X00240308, "LO", "DataSetSource"),
    (0X00240309, "LO", "DataSetDescription"),
    (0X00240317, "SQ", "VisualFieldTestReliabilityGlobalIndexSequence"),
    (0X00240320, "SQ", "VisualFieldGlobalResultsIndexSequence"),
    (0X00240325, "SQ", "DataObservationSequence"),
    (0X00240338, "CS", "IndexNormalsFlag"),
    (0X00240341, "FL", "IndexProbability"),
    (0X00240344, "SQ", "IndexProbabilitySequence"),
    (0X00280002, "US", "SamplesPerPixel"),
    (0X00280003, "US", "SamplesPerPixelUsed"),
    (0X00280004, "CS", "PhotometricInterpretation"),
    (0X00280005, "US", "ImageDimensions"),
    (0X00280006, "US", "PlanarConfiguration"),
    (0X00280008, "IS", "NumberOfFrames"),
    (0X00280009, "AT", "FrameIncrementPointer"),
    (0X0028000A, "AT", "FrameDimensionPointer"),
    (0X00280010, "US", "Rows"),
    (0X00280011, "US", "Columns"),
    (0X00280012, "US", "Planes"),
    (0X00280014, "US", "UltrasoundColorDataPresent"),
    (0X00280020, "OB", ""),
    (0X00280030, "DS", "PixelSpacing"),
    (0X00280031, "DS", "ZoomFactor"),
    (0X00280032, "DS", "ZoomCenter"),
    (0X00280034, "IS", "PixelAspectRatio"),
    (0X00280040, "CS", "ImageFormat"),
    (0X00280050, "LO", "ManipulatedImage"),
    (0X00280051, "CS", "CorrectedImage"),
    (0X0028005F, "LO", "CompressionRecognitionCode"),
    (0X00280060, "CS", "CompressionCode"),
    (0X00280061, "SH", "CompressionOriginator"),
    (0X00280062, "LO", "CompressionLabel"),
    (0X00280063, "SH", "CompressionDescription"),
    (0X00280065, "CS", "CompressionSequence"),
    (0X00280066, "AT", "CompressionStepPointers"),
    (0X00280068, "US", "RepeatInterval"),
    (0X00280069, "US", "BitsGrouped"),
    (0X00280070, "US", "PerimeterTable"),
    (0X00280071, "SS", "PerimeterValue"),
    (0X00280080, "US", "PredictorRows"),
    (0X00280081, "US", "PredictorColumns"),
    (0X00280082, "US", "PredictorConstants"),
    (0X00280090, "CS", "BlockedPixels"),
    (0X00280091, "US", "BlockRows"),
    (0X00280092, "US", "BlockColumns"),
    (0X00280093, "US", "RowOverlap"),
    (0X00280094, "US", "ColumnOverlap"),
    (0X00280100, "US", "BitsAllocated"),
    (0X00280101, "US", "BitsStored"),
    (0X00280102, "US", "HighBit"),
    (0X00280103, "US", "PixelRepresentation"),
    (0X00280104, "SS", "SmallestValidPixelValue"),
    (0X00280105, "SS", "LargestValidPixelValue"),
    (0X00280106, "SS", "SmallestImagePixelValue"),
    (0X00280107, "SS", "LargestImagePixelValue"),
    (0X00280108, "SS", "SmallestPixelValueInSeries"),
    (0X00280109, "SS", "LargestPixelValueInSeries"),
    (0X00280110, "SS", "SmallestImagePixelValueInPlane"),
    (0X00280111, "SS", "LargestImagePixelValueInPlane"),
    (0X00280120, "SS", "PixelPaddingValue"),
    (0X00280121, "SS", "PixelPaddingRangeLimit"),
    (0X00280122, "FL", "FloatPixelPaddingValue"),
    (0X00280123, "FD", "DoubleFloatPixelPaddingValue"),
    (0X00280124, "FL", "FloatPixelPaddingRangeLimit"),
    (0X00280125, "FD", "DoubleFloatPixelPaddingRangeLimit"),
    (0X00280200, "US", "ImageLocation"),
    (0X00280300, "CS", "QualityControlImage"),
    (0X00280301, "CS", "BurnedInAnnotation"),
    (0X00280302, "CS", "RecognizableVisualFeatures"),
    (0X00280303, "CS", "LongitudinalTemporalInformationModified"),
    (0X00280304, "UI", "ReferencedColorPaletteInstanceUID"),
    (0X00280400, "LO", "TransformLabel"),
    (0X00280401, "LO", "TransformVersionNumber"),
    (0X00280402, "US", "NumberOfTransformSteps"),
    (0X00280403, "LO", "SequenceOfCompressedData"),
    (0X00280404, "AT", "DetailsOfCoefficients"),
    (0X00280700, "LO", "DCTLabel"),
    (0X00280701, "CS", "DataBlockDescription"),
    (0X00280702, "AT", "DataBlock"),
    (0X00280710, "US", "NormalizationFactorFormat"),
    (0X00280720, "US", "ZonalMapNumberFormat"),
    (0X00280721, "AT", "ZonalMapLocation"),
    (0X00280722, "US", "ZonalMapFormat"),
    (0X00280730, "US", "AdaptiveMapFormat"),
    (0X00280740, "US", "CodeNumberFormat"),
    (0X00280A02, "CS", "PixelSpacingCalibrationType"),
    (0X00280A04, "LO", "PixelSpacingCalibrationDescription"),
    (0X00281040, "CS", "PixelIntensityRelationship"),
    (0X00281041, "SS", "PixelIntensityRelationshipSign"),
    (0X00281050, "DS", "WindowCenter"),
    (0X00281051, "DS", "WindowWidth"),
    (0X00281052, "DS", "RescaleIntercept"),
    (0X00281053, "DS", "RescaleSlope"),
    (0X00281054, "LO", "RescaleType"),
    (0X00281055, "LO", "WindowCenterWidthExplanation"),
    (0X00281056, "CS", "VOILUTFunction"),
    (0X00281080, "CS", "GrayScale"),
    (0X00281090, "CS", "RecommendedViewingMode"),
    (0X00281100, "SS", "GrayLookupTableDescriptor"),
    (0X00281101, "SS", "RedPaletteColorLookupTableDescriptor"),
    (0X00281102, "SS", "GreenPaletteColorLookupTableDescriptor"),
    (0X00281103, "SS", "BluePaletteColorLookupTableDescriptor"),
    (0X00281104, "US", "AlphaPaletteColorLookupTableDescriptor"),
    (0X00281111, "SS", "LargeRedPaletteColorLookupTableDescriptor"),
    (0X00281112, "SS", "LargeGreenPaletteColorLookupTableDescriptor"),
    (0X00281113, "SS", "LargeBluePaletteColorLookupTableDescriptor"),
    (0X00281199, "UI", "PaletteColorLookupTableUID"),
    (0X00281200, "OW", "GrayLookupTableData"),
    (0X00281201, "OW", "RedPaletteColorLookupTableData"),
    (0X00281202, "OW", "GreenPaletteColorLookupTableData"),
    (0X00281203, "OW", "BluePaletteColorLookupTableData"),
    (0X00281204, "OW", "AlphaPaletteColorLookupTableData"),
    (0X00281211, "OW", "LargeRedPaletteColorLookupTableData"),
    (0X00281212, "OW", "LargeGreenPaletteColorLookupTableData"),
    (0X00281213, "OW", "LargeBluePaletteColorLookupTableData"),
    (0X00281214, "UI", "LargePaletteColorLookupTableUID"),
    (0X00281221, "OW", "SegmentedRedPaletteColorLookupTableData"),
    (0X00281222, "OW", "SegmentedGreenPaletteColorLookupTableData"),
    (0X00281223, "OW", "SegmentedBluePaletteColorLookupTableData"),
    (0X00281224, "OW", "SegmentedAlphaPaletteColorLookupTableData"),
    (0X00281230, "SQ", "StoredValueColorRangeSequence"),
    (0X00281231, "FD", "MinimumStoredValueMapped"),
    (0X00281232, "FD", "MaximumStoredValueMapped"),
    (0X00281300, "CS", "BreastImplantPresent"),
    (0X00281350, "CS", "PartialView"),
    (0X00281351, "ST", "PartialViewDescription"),
    (0X00281352, "SQ", "PartialViewCodeSequence"),
    (0X0028135A, "CS", "SpatialLocationsPreserved"),
    (0X00281401, "SQ", "DataFrameAssignmentSequence"),
    (0X00281402, "CS", "DataPathAssignment"),
    (0X00281403, "US", "BitsMappedToColorLookupTable"),
    (0X00281404, "SQ", "BlendingLUT1Sequence"),
    (0X00281405, "CS", "BlendingLUT1TransferFunction"),
    (0X00281406, "FD", "BlendingWeightConstant"),
    (0X00281407, "US", "BlendingLookupTableDescriptor"),
    (0X00281408, "OW", "BlendingLookupTableData"),
    (0X0028140B, "SQ", "EnhancedPaletteColorLookupTableSequence"),
    (0X0028140C, "SQ", "BlendingLUT2Sequence"),
    (0X0028140D, "CS", "BlendingLUT2TransferFunction"),
    (0X0028140E, "CS", "DataPathID"),
    (0X0028140F, "CS", "RGBLUTTransferFunction"),
    (0X00281410, "CS", "AlphaLUTTransferFunction"),
    (0X00282000, "OB", "ICCProfile"),
    (0X00282002, "CS", "ColorSpace"),
    (0X00282110, "CS", "LossyImageCompression"),
    (0X00282112, "DS", "LossyImageCompressionRatio"),
    (0X00282114, "CS", "LossyImageCompressionMethod"),
    (0X00283000, "SQ", "ModalityLUTSequence"),
    (0X00283002, "SS", "LUTDescriptor"),
    (0X00283003, "LO", "LUTExplanation"),
    (0X00283004, "LO", "ModalityLUTType"),
    (0X00283006, "OW", "LUTData"),
    (0X00283010, "SQ", "VOILUTSequence"),
    (0X00283110, "SQ", "SoftcopyVOILUTSequence"),
    (0X00284000, "LT", "ImagePresentationComments"),
    (0X00285000, "SQ", "BiPlaneAcquisitionSequence"),
    (0X00286010, "US", "RepresentativeFrameNumber"),
    (0X00286020, "US", "FrameNumbersOfInterest"),
    (0X00286022, "LO", "FrameOfInterestDescription"),
    (0X00286023, "CS", "FrameOfInterestType"),
    (0X00286030, "US", "MaskPointers"),
    (0X00286040, "US", "RWavePointer"),
    (0X00286100, "SQ", "MaskSubtractionSequence"),
    (0X00286101, "CS", "MaskOperation"),
    (0X00286102, "US", "ApplicableFrameRange"),
    (0X00286110, "US", "MaskFrameNumbers"),
    (0X00286112, "US", "ContrastFrameAveraging"),
    (0X00286114, "FL", "MaskSubPixelShift"),
    (0X00286120, "SS", "TIDOffset"),
    (0X00286190, "ST", "MaskOperationExplanation"),
    (0X00287000, "SQ", "EquipmentAdministratorSequence"),
    (0X00287001, "US", "NumberOfDisplaySubsystems"),
    (0X00287002, "US", "CurrentConfigurationID"),
    (0X00287003, "US", "DisplaySubsystemID"),
    (0X00287004, "SH", "DisplaySubsystemName"),
    (0X00287005, "LO", "DisplaySubsystemDescription"),
    (0X00287006, "CS", "SystemStatus"),
    (0X00287007, "LO", "SystemStatusComment"),
    (0X00287008, "SQ", "TargetLuminanceCharacteristicsSequence"),
    (0X00287009, "US", "LuminanceCharacteristicsID"),
    (0X0028700A, "SQ", "DisplaySubsystemConfigurationSequence"),
    (0X0028700B, "US", "ConfigurationID"),
    (0X0028700C, "SH", "ConfigurationName"),
    (0X0028700D, "LO", "ConfigurationDescription"),
    (0X0028700E, "US", "ReferencedTargetLuminanceCharacteristicsID"),
    (0X0028700F, "SQ", "QAResultsSequence"),
    (0X00287010, "SQ", "DisplaySubsystemQAResultsSequence"),
    (0X00287011, "SQ", "ConfigurationQAResultsSequence"),
    (0X00287012, "SQ", "MeasurementEquipmentSequence"),
    (0X00287013, "CS", "MeasurementFunctions"),
    (0X00287014, "CS", "MeasurementEquipmentType"),
    (0X00287015, "SQ", "VisualEvaluationResultSequence"),
    (0X00287016, "SQ", "DisplayCalibrationResultSequence"),
    (0X00287017, "US", "DDLValue"),
    (0X00287018, "FL", "CIExyWhitePoint"),
    (0X00287019, "CS", "DisplayFunctionType"),
    (0X0028701A, "FL", "GammaValue"),
    (0X0028701B, "US", "NumberOfLuminancePoints"),
    (0X0028701C, "SQ", "LuminanceResponseSequence"),
    (0X0028701D, "FL", "TargetMinimumLuminance"),
    (0X0028701E, "FL", "TargetMaximumLuminance"),
    (0X0028701F, "FL", "LuminanceValue"),
    (0X00287020, "LO", "LuminanceResponseDescription"),
    (0X00287021, "CS", "WhitePointFlag"),
    (0X00287022, "SQ", "DisplayDeviceTypeCodeSequence"),
    (0X00287023, "SQ", "DisplaySubsystemSequence"),
    (0X00287024, "SQ", "LuminanceResultSequence"),
    (0X00287025, "CS", "AmbientLightValueSource"),
    (0X00287026, "CS", "MeasuredCharacteristics"),
    (0X00287027, "SQ", "LuminanceUniformityResultSequence"),
    (0X00287028, "SQ", "VisualEvaluationTestSequence"),
    (0X00287029, "CS", "TestResult"),
    (0X0028702A, "LO", "TestResultComment"),
    (0X0028702B, "CS", "TestImageValidation"),
    (0X0028702C, "SQ", "TestPatternCodeSequence"),
    (0X0028702D, "SQ", "MeasurementPatternCodeSequence"),
    (0X0028702E, "SQ", "VisualEvaluationMethodCodeSequence"),
    (0X00287FE0, "UR", "PixelDataProviderURL"),
    (0X00289001, "UL", "DataPointRows"),
    (0X00289002, "UL", "DataPointColumns"),
    (0X00289003, "CS", "SignalDomainColumns"),
    (0X00289099, "US", "LargestMonochromePixelValue"),
    (0X00289108, "CS", "DataRepresentation"),
    (0X00289110, "SQ", "PixelMeasuresSequence"),
    (0X00289132, "SQ", "FrameVOILUTSequence"),
    (0X00289145, "SQ", "PixelValueTransformationSequence"),
    (0X00289235, "CS", "SignalDomainRows"),
    (0X00289411, "FL", "DisplayFilterPercentage"),
    (0X00289415, "SQ", "FramePixelShiftSequence"),
    (0X00289416, "US", "SubtractionItemID"),
    (0X00289422, "SQ", "PixelIntensityRelationshipLUTSequence"),
    (0X00289443, "SQ", "FramePixelDataPropertiesSequence"),
    (0X00289444, "CS", "GeometricalProperties"),
    (0X00289445, "FL", "GeometricMaximumDistortion"),
    (0X00289446, "CS", "ImageProcessingApplied"),
    (0X00289454, "CS", "MaskSelectionMode"),
    (0X00289474, "CS", "LUTFunction"),
    (0X00289478, "FL", "MaskVisibilityPercentage"),
    (0X00289501, "SQ", "PixelShiftSequence"),
    (0X00289502, "SQ", "RegionPixelShiftSequence"),
    (0X00289503, "SS", "VerticesOfTheRegion"),
    (0X00289505, "SQ", "MultiFramePresentationSequence"),
    (0X00289506, "US", "PixelShiftFrameRange"),
    (0X00289507, "US", "LUTFrameRange"),
    (0X00289520, "DS", "ImageToEquipmentMappingMatrix"),
    (0X00289537, "CS", "EquipmentCoordinateSystemIdentification"),
    (0X0032000A, "CS", "StudyStatusID"),
    (0X0032000C, "CS", "StudyPriorityID"),
    (0X00320012, "LO", "StudyIDIssuer"),
    (0X00320032, "DA", "StudyVerifiedDate"),
    (0X00320033, "TM", "StudyVerifiedTime"),
    (0X00320034, "DA", "StudyReadDate"),
    (0X00320035, "TM", "StudyReadTime"),
    (0X00321000, "DA", "ScheduledStudyStartDate"),
    (0X00321001, "TM", "ScheduledStudyStartTime"),
    (0X00321010, "DA", "ScheduledStudyStopDate"),
    (0X00321011, "TM", "ScheduledStudyStopTime"),
    (0X00321020, "LO", "ScheduledStudyLocation"),
    (0X00321021, "AE", "ScheduledStudyLocationAETitle"),
    (0X00321030, "LO", "ReasonForStudy"),
    (0X00321031, "SQ", "RequestingPhysicianIdentificationSequence"),
    (0X00321032, "PN", "RequestingPhysician"),
    (0X00321033, "LO", "RequestingService"),
    (0X00321034, "SQ", "RequestingServiceCodeSequence"),
    (0X00321040, "DA", "StudyArrivalDate"),
    (0X00321041, "TM", "StudyArrivalTime"),
    (0X00321050, "DA", "StudyCompletionDate"),
    (0X00321051, "TM", "StudyCompletionTime"),
    (0X00321055, "CS", "StudyComponentStatusID"),
    (0X00321060, "LO", "RequestedProcedureDescription"),
    (0X00321064, "SQ", "RequestedProcedureCodeSequence"),
    (0X00321066, "UT", "ReasonForVisit"),
    (0X00321067, "SQ", "ReasonForVisitCodeSequence"),
    (0X00321070, "LO", "RequestedContrastAgent"),
    (0X00324000, "LT", "StudyComments"),
    (0X00340001, "SQ", "FlowIdentifierSequence"),
    (0X00340002, "OB", "FlowIdentifier"),
    (0X00340003, "UI", "FlowTransferSyntaxUID"),
    (0X00340004, "UL", "FlowRTPSamplingRate"),
    (0X00340005, "OB", "SourceIdentifier"),
    (0X00340007, "OB", "FrameOriginTimestamp"),
    (0X00340008, "CS", "IncludesImagingSubject"),
    (0X00340009, "SQ", "FrameUsefulnessGroupSequence"),
    (0X0034000A, "SQ", "RealTimeBulkDataFlowSequence"),
    (0X0034000B, "SQ", "CameraPositionGroupSequence"),
    (0X0034000C, "CS", "IncludesInformation"),
    (0X0034000D, "SQ", "TimeOfFrameGroupSequence"),
    (0X00380004, "SQ", "ReferencedPatientAliasSequence"),
    (0X00380008, "CS", "VisitStatusID"),
    (0X00380010, "LO", "AdmissionID"),
    (0X00380011, "LO", "IssuerOfAdmissionID"),
    (0X00380014, "SQ", "IssuerOfAdmissionIDSequence"),
    (0X00380016, "LO", "RouteOfAdmissions"),
    (0X0038001A, "DA", "ScheduledAdmissionDate"),
    (0X0038001B, "TM", "ScheduledAdmissionTime"),
    (0X0038001C, "DA", "ScheduledDischargeDate"),
    (0X0038001D, "TM", "ScheduledDischargeTime"),
    (0X0038001E, "LO", "ScheduledPatientInstitutionResidence"),
    (0X00380020, "DA", "AdmittingDate"),
    (0X00380021, "TM", "AdmittingTime"),
    (0X00380030, "DA", "DischargeDate"),
    (0X00380032, "TM", "DischargeTime"),
    (0X00380040, "LO", "DischargeDiagnosisDescription"),
    (0X00380044, "SQ", "DischargeDiagnosisCodeSequence"),
    (0X00380050, "LO", "SpecialNeeds"),
    (0X00380060, "LO", "ServiceEpisodeID"),
    (0X00380061, "LO", "IssuerOfServiceEpisodeID"),
    (0X00380062, "LO", "ServiceEpisodeDescription"),
    (0X00380064, "SQ", "IssuerOfServiceEpisodeIDSequence"),
    (0X00380100, "SQ", "PertinentDocumentsSequence"),
    (0X00380101, "SQ", "PertinentResourcesSequence"),
    (0X00380102, "LO", "ResourceDescription"),
    (0X00380300, "LO", "CurrentPatientLocation"),
    (0X00380400, "LO", "PatientInstitutionResidence"),
    (0X00380500, "LO", "PatientState"),
    (0X00380502, "SQ", "PatientClinicalTrialParticipationSequence"),
    (0X00384000, "LT", "VisitComments"),
    (0X003A0004, "CS", "WaveformOriginality"),
    (0X003A0005, "US", "NumberOfWaveformChannels"),
    (0X003A0010, "UL", "NumberOfWaveformSamples"),
    (0X003A001A, "DS", "SamplingFrequency"),
    (0X003A0020, "SH", "MultiplexGroupLabel"),
    (0X003A0200, "SQ", "ChannelDefinitionSequence"),
    (0X003A0202, "IS", "WaveformChannelNumber"),
    (0X003A0203, "SH", "ChannelLabel"),
    (0X003A0205, "CS", "ChannelStatus"),
    (0X003A0208, "SQ", "ChannelSourceSequence"),
    (0X003A0209, "SQ", "ChannelSourceModifiersSequence"),
    (0X003A020A, "SQ", "SourceWaveformSequence"),
    (0X003A020C, "LO", "ChannelDerivationDescription"),
    (0X003A0210, "DS", "ChannelSensitivity"),
    (0X003A0211, "SQ", "ChannelSensitivityUnitsSequence"),
    (0X003A0212, "DS", "ChannelSensitivityCorrectionFactor"),
    (0X003A0213, "DS", "ChannelBaseline"),
    (0X003A0214, "DS", "ChannelTimeSkew"),
    (0X003A0215, "DS", "ChannelSampleSkew"),
    (0X003A0218, "DS", "ChannelOffset"),
    (0X003A021A, "US", "WaveformBitsStored"),
    (0X003A0220, "DS", "FilterLowFrequency"),
    (0X003A0221, "DS", "FilterHighFrequency"),
    (0X003A0222, "DS", "NotchFilterFrequency"),
    (0X003A0223, "DS", "NotchFilterBandwidth"),
    (0X003A0230, "FL", "WaveformDataDisplayScale"),
    (0X003A0231, "US", "WaveformDisplayBackgroundCIELabValue"),
    (0X003A0240, "SQ", "WaveformPresentationGroupSequence"),
    (0X003A0241, "US", "PresentationGroupNumber"),
    (0X003A0242, "SQ", "ChannelDisplaySequence"),
    (0X003A0244, "US", "ChannelRecommendedDisplayCIELabValue"),
    (0X003A0245, "FL", "ChannelPosition"),
    (0X003A0246, "CS", "DisplayShadingFlag"),
    (0X003A0247, "FL", "FractionalChannelDisplayScale"),
    (0X003A0248, "FL", "AbsoluteChannelDisplayScale"),
    (0X003A0300, "SQ", "MultiplexedAudioChannelsDescriptionCodeSequence"),
    (0X003A0301, "IS", "ChannelIdentificationCode"),
    (0X003A0302, "CS", "ChannelMode"),
    (0X003A0310, "UI", "MultiplexGroupUID"),
    (0X003A0311, "DS", "PowerlineFrequency"),
    (0X003A0312, "SQ", "ChannelImpedanceSequence"),
    (0X003A0313, "DS", "ImpedanceValue"),
    (0X003A0314, "DT", "ImpedanceMeasurementDateTime"),
    (0X003A0315, "DS", "ImpedanceMeasurementFrequency"),
    (0X003A0316, "CS", "ImpedanceMeasurementCurrentType"),
    (0X00400001, "AE", "ScheduledStationAETitle"),
    (0X00400002, "DA", "ScheduledProcedureStepStartDate"),
    (0X00400003, "TM", "ScheduledProcedureStepStartTime"),
    (0X00400004, "DA", "ScheduledProcedureStepEndDate"),
    (0X00400005, "TM", "ScheduledProcedureStepEndTime"),
    (0X00400006, "PN", "ScheduledPerformingPhysicianName"),
    (0X00400007, "LO", "ScheduledProcedureStepDescription"),
    (0X00400008, "SQ", "ScheduledProtocolCodeSequence"),
    (0X00400009, "SH", "ScheduledProcedureStepID"),
    (0X0040000A, "SQ", "StageCodeSequence"),
    (0X0040000B, "SQ", "ScheduledPerformingPhysicianIdentificationSequence"),
    (0X00400010, "SH", "ScheduledStationName"),
    (0X00400011, "SH", "ScheduledProcedureStepLocation"),
    (0X00400012, "LO", "PreMedication"),
    (0X00400020, "CS", "ScheduledProcedureStepStatus"),
    (0X00400026, "SQ", "OrderPlacerIdentifierSequence"),
    (0X00400027, "SQ", "OrderFillerIdentifierSequence"),
    (0X00400031, "UT", "LocalNamespaceEntityID"),
    (0X00400032, "UT", "UniversalEntityID"),
    (0X00400033, "CS", "UniversalEntityIDType"),
    (0X00400035, "CS", "IdentifierTypeCode"),
    (0X00400036, "SQ", "AssigningFacilitySequence"),
    (0X00400039, "SQ", "AssigningJurisdictionCodeSequence"),
    (0X0040003A, "SQ", "AssigningAgencyOrDepartmentCodeSequence"),
    (0X00400100, "SQ", "ScheduledProcedureStepSequence"),
    (0X00400220, "SQ", "ReferencedNonImageCompositeSOPInstanceSequence"),
    (0X00400241, "AE", "PerformedStationAETitle"),
    (0X00400242, "SH", "PerformedStationName"),
    (0X00400243, "SH", "PerformedLocation"),
    (0X00400244, "DA", "PerformedProcedureStepStartDate"),
    (0X00400245, "TM", "PerformedProcedureStepStartTime"),
    (0X00400250, "DA", "PerformedProcedureStepEndDate"),
    (0X00400251, "TM", "PerformedProcedureStepEndTime"),
    (0X00400252, "CS", "PerformedProcedureStepStatus"),
    (0X00400253, "SH", "PerformedProcedureStepID"),
    (0X00400254, "LO", "PerformedProcedureStepDescription"),
    (0X00400255, "LO", "PerformedProcedureTypeDescription"),
    (0X00400260, "SQ", "PerformedProtocolCodeSequence"),
    (0X00400261, "CS", "PerformedProtocolType"),
    (0X00400270, "SQ", "ScheduledStepAttributesSequence"),
    (0X00400275, "SQ", "RequestAttributesSequence"),
    (0X00400280, "ST", "CommentsOnThePerformedProcedureStep"),
    (0X00400281, "SQ", "PerformedProcedureStepDiscontinuationReasonCodeSequence"),
    (0X00400293, "SQ", "QuantitySequence"),
    (0X00400294, "DS", "Quantity"),
    (0X00400295, "SQ", "MeasuringUnitsSequence"),
    (0X00400296, "SQ", "BillingItemSequence"),
    (0X00400300, "US", "TotalTimeOfFluoroscopy"),
    (0X00400301, "US", "TotalNumberOfExposures"),
    (0X00400302, "US", "EntranceDose"),
    (0X00400303, "US", "ExposedArea"),
    (0X00400306, "DS", "DistanceSourceToEntrance"),
    (0X00400307, "DS", "DistanceSourceToSupport"),
    (0X0040030E, "SQ", "ExposureDoseSequence"),
    (0X00400310, "ST", "CommentsOnRadiationDose"),
    (0X00400312, "DS", "XRayOutput"),
    (0X00400314, "DS", "HalfValueLayer"),
    (0X00400316, "DS", "OrganDose"),
    (0X00400318, "CS", "OrganExposed"),
    (0X00400320, "SQ", "BillingProcedureStepSequence"),
    (0X00400321, "SQ", "FilmConsumptionSequence"),
    (0X00400324, "SQ", "BillingSuppliesAndDevicesSequence"),
    (0X00400330, "SQ", "ReferencedProcedureStepSequence"),
    (0X00400340, "SQ", "PerformedSeriesSequence"),
    (0X00400400, "LT", "CommentsOnTheScheduledProcedureStep"),
    (0X00400440, "SQ", "ProtocolContextSequence"),
    (0X00400441, "SQ", "ContentItemModifierSequence"),
    (0X00400500, "SQ", "ScheduledSpecimenSequence"),
    (0X0040050A, "LO", "SpecimenAccessionNumber"),
    (0X00400512, "LO", "ContainerIdentifier"),
    (0X00400513, "SQ", "IssuerOfTheContainerIdentifierSequence"),
    (0X00400515, "SQ", "AlternateContainerIdentifierSequence"),
    (0X00400518, "SQ", "ContainerTypeCodeSequence"),
    (0X0040051A, "LO", "ContainerDescription"),
    (0X00400520, "SQ", "ContainerComponentSequence"),
    (0X00400550, "SQ", "SpecimenSequence"),
    (0X00400551, "LO", "SpecimenIdentifier"),
    (0X00400552, "SQ", "SpecimenDescriptionSequenceTrial"),
    (0X00400553, "ST", "SpecimenDescriptionTrial"),
    (0X00400554, "UI", "SpecimenUID"),
    (0X00400555, "SQ", "AcquisitionContextSequence"),
    (0X00400556, "ST", "AcquisitionContextDescription"),
    (0X00400560, "SQ", "SpecimenDescriptionSequence"),
    (0X00400562, "SQ", "IssuerOfTheSpecimenIdentifierSequence"),
    (0X0040059A, "SQ", "SpecimenTypeCodeSequence"),
    (0X00400600, "LO", "SpecimenShortDescription"),
    (0X00400602, "UT", "SpecimenDetailedDescription"),
    (0X00400610, "SQ", "SpecimenPreparationSequence"),
    (0X00400612, "SQ", "SpecimenPreparationStepContentItemSequence"),
    (0X00400620, "SQ", "SpecimenLocalizationContentItemSequence"),
    (0X004006FA, "LO", "SlideIdentifier"),
    (0X00400710, "SQ", "WholeSlideMicroscopyImageFrameTypeSequence"),
    (0X0040071A, "SQ", "ImageCenterPointCoordinatesSequence"),
    (0X0040072A, "DS", "XOffsetInSlideCoordinateSystem"),
    (0X0040073A, "DS", "YOffsetInSlideCoordinateSystem"),
    (0X0040074A, "DS", "ZOffsetInSlideCoordinateSystem"),
    (0X004008D8, "SQ", "PixelSpacingSequence"),
    (0X004008DA, "SQ", "CoordinateSystemAxisCodeSequence"),
    (0X004008EA, "SQ", "MeasurementUnitsCodeSequence"),
    (0X004009F8, "SQ", "VitalStainCodeSequenceTrial"),
    (0X00401001, "SH", "RequestedProcedureID"),
    (0X00401002, "LO", "ReasonForTheRequestedProcedure"),
    (0X00401003, "SH", "RequestedProcedurePriority"),
    (0X00401004, "LO", "PatientTransportArrangements"),
    (0X00401005, "LO", "RequestedProcedureLocation"),
    (0X00401006, "SH", "PlacerOrderNumberProcedure"),
    (0X00401007, "SH", "FillerOrderNumberProcedure"),
    (0X00401008, "LO", "ConfidentialityCode"),
    (0X00401009, "SH", "ReportingPriority"),
    (0X0040100A, "SQ", "ReasonForRequestedProcedureCodeSequence"),
    (0X00401010, "PN", "NamesOfIntendedRecipientsOfResults"),
    (0X00401011, "SQ", "IntendedRecipientsOfResultsIdentificationSequence"),
    (0X00401012, "SQ", "ReasonForPerformedProcedureCodeSequence"),
    (0X00401060, "LO", "RequestedProcedureDescriptionTrial"),
    (0X00401101, "SQ", "PersonIdentificationCodeSequence"),
    (0X00401102, "ST", "PersonAddress"),
    (0X00401103, "LO", "PersonTelephoneNumbers"),
    (0X00401104, "LT", "PersonTelecomInformation"),
    (0X00401400, "LT", "RequestedProcedureComments"),
    (0X00402001, "LO", "ReasonForTheImagingServiceRequest"),
    (0X00402004, "DA", "IssueDateOfImagingServiceRequest"),
    (0X00402005, "TM", "IssueTimeOfImagingServiceRequest"),
    (0X00402006, "SH", "PlacerOrderNumberImagingServiceRequestRetired"),
    (0X00402007, "SH", "FillerOrderNumberImagingServiceRequestRetired"),
    (0X00402008, "PN", "OrderEnteredBy"),
    (0X00402009, "SH", "OrderEntererLocation"),
    (0X00402010, "SH", "OrderCallbackPhoneNumber"),
    (0X00402011, "LT", "OrderCallbackTelecomInformation"),
    (0X00402016, "LO", "PlacerOrderNumberImagingServiceRequest"),
    (0X00402017, "LO", "FillerOrderNumberImagingServiceRequest"),
    (0X00402400, "LT", "ImagingServiceRequestComments"),
    (0X00403001, "LO", "ConfidentialityConstraintOnPatientDataDescription"),
    (0X00404001, "CS", "GeneralPurposeScheduledProcedureStepStatus"),
    (0X00404002, "CS", "GeneralPurposePerformedProcedureStepStatus"),
    (0X00404003, "CS", "GeneralPurposeScheduledProcedureStepPriority"),
    (0X00404004, "SQ", "ScheduledProcessingApplicationsCodeSequence"),
    (0X00404005, "DT", "ScheduledProcedureStepStartDateTime"),
    (0X00404006, "CS", "MultipleCopiesFlag"),
    (0X00404007, "SQ", "PerformedProcessingApplicationsCodeSequence"),
    (0X00404008, "DT", "ScheduledProcedureStepExpirationDateTime"),
    (0X00404009, "SQ", "HumanPerformerCodeSequence"),
    (0X00404010, "DT", "ScheduledProcedureStepModificationDateTime"),
    (0X00404011, "DT", "ExpectedCompletionDateTime"),
    (0X00404015, "SQ", "ResultingGeneralPurposePerformedProcedureStepsSequence"),
    (0X00404016, "SQ", "ReferencedGeneralPurposeScheduledProcedureStepSequence"),
    (0X00404018, "SQ", "ScheduledWorkitemCodeSequence"),
    (0X00404019, "SQ", "PerformedWorkitemCodeSequence"),
    (0X00404020, "CS", "InputAvailabilityFlag"),
    (0X00404021, "SQ", "InputInformationSequence"),
    (0X00404022, "SQ", "RelevantInformationSequence"),
    (0X00404023, "UI", "ReferencedGeneralPurposeScheduledProcedureStepTransactionUID"),
    (0X00404025, "SQ", "ScheduledStationNameCodeSequence"),
    (0X00404026, "SQ", "ScheduledStationClassCodeSequence"),
    (0X00404027, "SQ", "ScheduledStationGeographicLocationCodeSequence"),
    (0X00404028, "SQ", "PerformedStationNameCodeSequence"),
    (0X00404029, "SQ", "PerformedStationClassCodeSequence"),
    (0X00404030, "SQ", "PerformedStationGeographicLocationCodeSequence"),
    (0X00404031, "SQ", "RequestedSubsequentWorkitemCodeSequence"),
    (0X00404032, "SQ", "NonDICOMOutputCodeSequence"),
    (0X00404033, "SQ", "OutputInformationSequence"),
    (0X00404034, "SQ", "ScheduledHumanPerformersSequence"),
    (0X00404035, "SQ", "ActualHumanPerformersSequence"),
    (0X00404036, "LO", "HumanPerformerOrganization"),
    (0X00404037, "PN", "HumanPerformerName"),
    (0X00404040, "CS", "RawDataHandling"),
    (0X00404041, "CS", "InputReadinessState"),
    (0X00404050, "DT", "PerformedProcedureStepStartDateTime"),
    (0X00404051, "DT", "PerformedProcedureStepEndDateTime"),
    (0X00404052, "DT", "ProcedureStepCancellationDateTime"),
    (0X00404070, "SQ", "OutputDestinationSequence"),
    (0X00404071, "SQ", "DICOMStorageSequence"),
    (0X00404072, "SQ", "STOWRSStorageSequence"),
    (0X00404073, "UR", "StorageURL"),
    (0X00404074, "SQ", "XDSStorageSequence"),
    (0X00408302, "DS", "EntranceDoseInmGy"),
    (0X00408303, "CS", "EntranceDoseDerivation"),
    (0X00409092, "SQ", "ParametricMapFrameTypeSequence"),
    (0X00409094, "SQ", "ReferencedImageRealWorldValueMappingSequence"),
    (0X00409096, "SQ", "RealWorldValueMappingSequence"),
    (0X00409098, "SQ", "PixelValueMappingCodeSequence"),
    (0X00409210, "SH", "LUTLabel"),
    (0X00409211, "US", "RealWorldValueLastValueMapped"),
    (0X00409212, "FD", "RealWorldValueLUTData"),
    (0X00409213, "FD", "DoubleFloatRealWorldValueLastValueMapped"),
    (0X00409214, "FD", "DoubleFloatRealWorldValueFirstValueMapped"),
    (0X00409216, "US", "RealWorldValueFirstValueMapped"),
    (0X00409220, "SQ", "QuantityDefinitionSequence"),
    (0X00409224, "FD", "RealWorldValueIntercept"),
    (0X00409225, "FD", "RealWorldValueSlope"),
    (0X0040A007, "CS", "FindingsFlagTrial"),
    (0X0040A010, "CS", "RelationshipType"),
    (0X0040A020, "SQ", "FindingsSequenceTrial"),
    (0X0040A021, "UI", "FindingsGroupUIDTrial"),
    (0X0040A022, "UI", "ReferencedFindingsGroupUIDTrial"),
    (0X0040A023, "DA", "FindingsGroupRecordingDateTrial"),
    (0X0040A024, "TM", "FindingsGroupRecordingTimeTrial"),
    (0X0040A026, "SQ", "FindingsSourceCategoryCodeSequenceTrial"),
    (0X0040A027, "LO", "VerifyingOrganization"),
    (0X0040A028, "SQ", "DocumentingOrganizationIdentifierCodeSequenceTrial"),
    (0X0040A030, "DT", "VerificationDateTime"),
    (0X0040A032, "DT", "ObservationDateTime"),
    (0X0040A033, "DT", "ObservationStartDateTime"),
    (0X0040A040, "CS", "ValueType"),
    (0X0040A043, "SQ", "ConceptNameCodeSequence"),
    (0X0040A047, "LO", "MeasurementPrecisionDescriptionTrial"),
    (0X0040A050, "CS", "ContinuityOfContent"),
    (0X0040A057, "CS", "UrgencyOrPriorityAlertsTrial"),
    (0X0040A060, "LO", "SequencingIndicatorTrial"),
    (0X0040A066, "SQ", "DocumentIdentifierCodeSequenceTrial"),
    (0X0040A067, "PN", "DocumentAuthorTrial"),
    (0X0040A068, "SQ", "DocumentAuthorIdentifierCodeSequenceTrial"),
    (0X0040A070, "SQ", "IdentifierCodeSequenceTrial"),
    (0X0040A073, "SQ", "VerifyingObserverSequence"),
    (0X0040A074, "OB", "ObjectBinaryIdentifierTrial"),
    (0X0040A075, "PN", "VerifyingObserverName"),
    (0X0040A076, "SQ", "DocumentingObserverIdentifierCodeSequenceTrial"),
    (0X0040A078, "SQ", "AuthorObserverSequence"),
    (0X0040A07A, "SQ", "ParticipantSequence"),
    (0X0040A07C, "SQ", "CustodialOrganizationSequence"),
    (0X0040A080, "CS", "ParticipationType"),
    (0X0040A082, "DT", "ParticipationDateTime"),
    (0X0040A084, "CS", "ObserverType"),
    (0X0040A085, "SQ", "ProcedureIdentifierCodeSequenceTrial"),
    (0X0040A088, "SQ", "VerifyingObserverIdentificationCodeSequence"),
    (0X0040A089, "OB", "ObjectDirectoryBinaryIdentifierTrial"),
    (0X0040A090, "SQ", "EquivalentCDADocumentSequence"),
    (0X0040A0B0, "US", "ReferencedWaveformChannels"),
    (0X0040A110, "DA", "DateOfDocumentOrVerbalTransactionTrial"),
    (0X0040A112, "TM", "TimeOfDocumentCreationOrVerbalTransactionTrial"),
    (0X0040A120, "DT", "DateTime"),
    (0X0040A121, "DA", "Date"),
    (0X0040A122, "TM", "Time"),
    (0X0040A123, "PN", "PersonName"),
    (0X0040A124, "UI", "UID"),
    (0X0040A125, "CS", "ReportStatusIDTrial"),
    (0X0040A130, "CS", "TemporalRangeType"),
    (0X0040A132, "UL", "ReferencedSamplePositions"),
    (0X0040A136, "US", "ReferencedFrameNumbers"),
    (0X0040A138, "DS", "ReferencedTimeOffsets"),
    (0X0040A13A, "DT", "ReferencedDateTime"),
    (0X0040A160, "UT", "TextValue"),
    (0X0040A161, "FD", "FloatingPointValue"),
    (0X0040A162, "SL", "RationalNumeratorValue"),
    (0X0040A163, "UL", "RationalDenominatorValue"),
    (0X0040A167, "SQ", "ObservationCategoryCodeSequenceTrial"),
    (0X0040A168, "SQ", "ConceptCodeSequence"),
    (0X0040A16A, "ST", "BibliographicCitationTrial"),
    (0X0040A170, "SQ", "PurposeOfReferenceCodeSequence"),
    (0X0040A171, "UI", "ObservationUID"),
    (0X0040A172, "UI", "ReferencedObservationUIDTrial"),
    (0X0040A173, "CS", "ReferencedObservationClassTrial"),
    (0X0040A174, "CS", "ReferencedObjectObservationClassTrial"),
    (0X0040A180, "US", "AnnotationGroupNumber"),
    (0X0040A192, "DA", "ObservationDateTrial"),
    (0X0040A193, "TM", "ObservationTimeTrial"),
    (0X0040A194, "CS", "MeasurementAutomationTrial"),
    (0X0040A195, "SQ", "ModifierCodeSequence"),
    (0X0040A224, "ST", "IdentificationDescriptionTrial"),
    (0X0040A290, "CS", "CoordinatesSetGeometricTypeTrial"),
    (0X0040A296, "SQ", "AlgorithmCodeSequenceTrial"),
    (0X0040A297, "ST", "AlgorithmDescriptionTrial"),
    (0X0040A29A, "SL", "PixelCoordinatesSetTrial"),
    (0X0040A300, "SQ", "MeasuredValueSequence"),
    (0X0040A301, "SQ", "NumericValueQualifierCodeSequence"),
    (0X0040A307, "PN", "CurrentObserverTrial"),
    (0X0040A30A, "DS", "NumericValue"),
    (0X0040A313, "SQ", "ReferencedAccessionSequenceTrial"),
    (0X0040A33A, "ST", "ReportStatusCommentTrial"),
    (0X0040A340, "SQ", "ProcedureContextSequenceTrial"),
    (0X0040A352, "PN", "VerbalSourceTrial"),
    (0X0040A353, "ST", "AddressTrial"),
    (0X0040A354, "LO", "TelephoneNumberTrial"),
    (0X0040A358, "SQ", "VerbalSourceIdentifierCodeSequenceTrial"),
    (0X0040A360, "SQ", "PredecessorDocumentsSequence"),
    (0X0040A370, "SQ", "ReferencedRequestSequence"),
    (0X0040A372, "SQ", "PerformedProcedureCodeSequence"),
    (0X0040A375, "SQ", "CurrentRequestedProcedureEvidenceSequence"),
    (0X0040A380, "SQ", "ReportDetailSequenceTrial"),
    (0X0040A385, "SQ", "PertinentOtherEvidenceSequence"),
    (0X0040A390, "SQ", "HL7StructuredDocumentReferenceSequence"),
    (0X0040A402, "UI", "ObservationSubjectUIDTrial"),
    (0X0040A403, "CS", "ObservationSubjectClassTrial"),
    (0X0040A404, "SQ", "ObservationSubjectTypeCodeSequenceTrial"),
    (0X0040A491, "CS", "CompletionFlag"),
    (0X0040A492, "LO", "CompletionFlagDescription"),
    (0X0040A493, "CS", "VerificationFlag"),
    (0X0040A494, "CS", "ArchiveRequested"),
    (0X0040A496, "CS", "PreliminaryFlag"),
    (0X0040A504, "SQ", "ContentTemplateSequence"),
    (0X0040A525, "SQ", "IdenticalDocumentsSequence"),
    (0X0040A600, "CS", "ObservationSubjectContextFlagTrial"),
    (0X0040A601, "CS", "ObserverContextFlagTrial"),
    (0X0040A603, "CS", "ProcedureContextFlagTrial"),
    (0X0040A730, "SQ", "ContentSequence"),
    (0X0040A731, "SQ", "RelationshipSequenceTrial"),
    (0X0040A732, "SQ", "RelationshipTypeCodeSequenceTrial"),
    (0X0040A744, "SQ", "LanguageCodeSequenceTrial"),
    (0X0040A801, "SQ", "TabulatedValuesSequence"),
    (0X0040A802, "UL", "NumberOfTableRows"),
    (0X0040A803, "UL", "NumbeOfTableColumns"),
    (0X0040A804, "UL", "TableRowNumber"),
    (0X0040A805, "UL", "TableColumnNumber"),
    (0X0040A806, "SQ", "TableRowDefinitionSequence"),
    (0X0040A807, "SQ", "TableColumnDefinitionSequence"),
    (0X0040A808, "SQ", "CellValuesSequence"),
    (0X0040A992, "ST", "UniformResourceLocatorTrial"),
    (0X0040B020, "SQ", "WaveformAnnotationSequence"),
    (0X0040DB00, "CS", "TemplateIdentifier"),
    (0X0040DB06, "DT", "TemplateVersion"),
    (0X0040DB07, "DT", "TemplateLocalVersion"),
    (0X0040DB0B, "CS", "TemplateExtensionFlag"),
    (0X0040DB0C, "UI", "TemplateExtensionOrganizationUID"),
    (0X0040DB0D, "UI", "TemplateExtensionCreatorUID"),
    (0X0040DB73, "UL", "ReferencedContentItemIdentifier"),
    (0X0040E001, "ST", "HL7InstanceIdentifier"),
    (0X0040E004, "DT", "HL7DocumentEffectiveTime"),
    (0X0040E006, "SQ", "HL7DocumentTypeCodeSequence"),
    (0X0040E008, "SQ", "DocumentClassCodeSequence"),
    (0X0040E010, "UR", "RetrieveURI"),
    (0X0040E011, "UI", "RetrieveLocationUID"),
    (0X0040E020, "CS", "TypeOfInstances"),
    (0X0040E021, "SQ", "DICOMRetrievalSequence"),
    (0X0040E022, "SQ", "DICOMMediaRetrievalSequence"),
    (0X0040E023, "SQ", "WADORetrievalSequence"),
    (0X0040E024, "SQ", "XDSRetrievalSequence"),
    (0X0040E025, "SQ", "WADORSRetrievalSequence"),
    (0X0040E030, "UI", "RepositoryUniqueID"),
    (0X0040E031, "UI", "HomeCommunityID"),
    (0X00420010, "ST", "DocumentTitle"),
    (0X00420011, "OB", "EncapsulatedDocument"),
    (0X00420012, "LO", "MIMETypeOfEncapsulatedDocument"),
    (0X00420013, "SQ", "SourceInstanceSequence"),
    (0X00420014, "LO", "ListOfMIMETypes"),
    (0X00420015, "UL", "EncapsulatedDocumentLength"),
    (0X00440001, "ST", "ProductPackageIdentifier"),
    (0X00440002, "CS", "SubstanceAdministrationApproval"),
    (0X00440003, "LT", "ApprovalStatusFurtherDescription"),
    (0X00440004, "DT", "ApprovalStatusDateTime"),
    (0X00440007, "SQ", "ProductTypeCodeSequence"),
    (0X00440008, "LO", "ProductName"),
    (0X00440009, "LT", "ProductDescription"),
    (0X0044000A, "LO", "ProductLotIdentifier"),
    (0X0044000B, "DT", "ProductExpirationDateTime"),
    (0X00440010, "DT", "SubstanceAdministrationDateTime"),
    (0X00440011, "LO", "SubstanceAdministrationNotes"),
    (0X00440012, "LO", "SubstanceAdministrationDeviceID"),
    (0X00440013, "SQ", "ProductParameterSequence"),
    (0X00440019, "SQ", "SubstanceAdministrationParameterSequence"),
    (0X00440100, "SQ", "ApprovalSequence"),
    (0X00440101, "SQ", "AssertionCodeSequence"),
    (0X00440102, "UI", "AssertionUID"),
    (0X00440103, "SQ", "AsserterIdentificationSequence"),
    (0X00440104, "DT", "AssertionDateTime"),
    (0X00440105, "DT", "AssertionExpirationDateTime"),
    (0X00440106, "UT", "AssertionComments"),
    (0X00440107, "SQ", "RelatedAssertionSequence"),
    (0X00440108, "UI", "ReferencedAssertionUID"),
    (0X00440109, "SQ", "ApprovalSubjectSequence"),
    (0X0044010A, "SQ", "OrganizationalRoleCodeSequence"),
    (0X00460012, "LO", "LensDescription"),
    (0X00460014, "SQ", "RightLensSequence"),
    (0X00460015, "SQ", "LeftLensSequence"),
    (0X00460016, "SQ", "UnspecifiedLateralityLensSequence"),
    (0X00460018, "SQ", "CylinderSequence"),
    (0X00460028, "SQ", "PrismSequence"),
    (0X00460030, "FD", "HorizontalPrismPower"),
    (0X00460032, "CS", "HorizontalPrismBase"),
    (0X00460034, "FD", "VerticalPrismPower"),
    (0X00460036, "CS", "VerticalPrismBase"),
    (0X00460038, "CS", "LensSegmentType"),
    (0X00460040, "FD", "OpticalTransmittance"),
    (0X00460042, "FD", "ChannelWidth"),
    (0X00460044, "FD", "PupilSize"),
    (0X00460046, "FD", "CornealSize"),
    (0X00460047, "SQ", "CornealSizeSequence"),
    (0X00460050, "SQ", "AutorefractionRightEyeSequence"),
    (0X00460052, "SQ", "AutorefractionLeftEyeSequence"),
    (0X00460060, "FD", "DistancePupillaryDistance"),
    (0X00460062, "FD", "NearPupillaryDistance"),
    (0X00460063, "FD", "IntermediatePupillaryDistance"),
    (0X00460064, "FD", "OtherPupillaryDistance"),
    (0X00460070, "SQ", "KeratometryRightEyeSequence"),
    (0X00460071, "SQ", "KeratometryLeftEyeSequence"),
    (0X00460074, "SQ", "SteepKeratometricAxisSequence"),
    (0X00460075, "FD", "RadiusOfCurvature"),
    (0X00460076, "FD", "KeratometricPower"),
    (0X00460077, "FD", "KeratometricAxis"),
    (0X00460080, "SQ", "FlatKeratometricAxisSequence"),
    (0X00460092, "CS", "BackgroundColor"),
    (0X00460094, "CS", "Optotype"),
    (0X00460095, "CS", "OptotypePresentation"),
    (0X00460097, "SQ", "SubjectiveRefractionRightEyeSequence"),
    (0X00460098, "SQ", "SubjectiveRefractionLeftEyeSequence"),
    (0X00460100, "SQ", "AddNearSequence"),
    (0X00460101, "SQ", "AddIntermediateSequence"),
    (0X00460102, "SQ", "AddOtherSequence"),
    (0X00460104, "FD", "AddPower"),
    (0X00460106, "FD", "ViewingDistance"),
    (0X00460110, "SQ", "CorneaMeasurementsSequence"),
    (0X00460111, "SQ", "SourceOfCorneaMeasurementDataCodeSequence"),
    (0X00460112, "SQ", "SteepCornealAxisSequence"),
    (0X00460113, "SQ", "FlatCornealAxisSequence"),
    (0X00460114, "FD", "CornealPower"),
    (0X00460115, "FD", "CornealAxis"),
    (0X00460116, "SQ", "CorneaMeasurementMethodCodeSequence"),
    (0X00460117, "FL", "RefractiveIndexOfCornea"),
    (0X00460118, "FL", "RefractiveIndexOfAqueousHumor"),
    (0X00460121, "SQ", "VisualAcuityTypeCodeSequence"),
    (0X00460122, "SQ", "VisualAcuityRightEyeSequence"),
    (0X00460123, "SQ", "VisualAcuityLeftEyeSequence"),
    (0X00460124, "SQ", "VisualAcuityBothEyesOpenSequence"),
    (0X00460125, "CS", "ViewingDistanceType"),
    (0X00460135, "SS", "VisualAcuityModifiers"),
    (0X00460137, "FD", "DecimalVisualAcuity"),
    (0X00460139, "LO", "OptotypeDetailedDefinition"),
    (0X00460145, "SQ", "ReferencedRefractiveMeasurementsSequence"),
    (0X00460146, "FD", "SpherePower"),
    (0X00460147, "FD", "CylinderPower"),
    (0X00460201, "CS", "CornealTopographySurface"),
    (0X00460202, "FL", "CornealVertexLocation"),
    (0X00460203, "FL", "PupilCentroidXCoordinate"),
    (0X00460204, "FL", "PupilCentroidYCoordinate"),
    (0X00460205, "FL", "EquivalentPupilRadius"),
    (0X00460207, "SQ", "CornealTopographyMapTypeCodeSequence"),
    (0X00460208, "IS", "VerticesOfTheOutlineOfPupil"),
    (0X00460210, "SQ", "CornealTopographyMappingNormalsSequence"),
    (0X00460211, "SQ", "MaximumCornealCurvatureSequence"),
    (0X00460212, "FL", "MaximumCornealCurvature"),
    (0X00460213, "FL", "MaximumCornealCurvatureLocation"),
    (0X00460215, "SQ", "MinimumKeratometricSequence"),
    (0X00460218, "SQ", "SimulatedKeratometricCylinderSequence"),
    (0X00460220, "FL", "AverageCornealPower"),
    (0X00460224, "FL", "CornealISValue"),
    (0X00460227, "FL", "AnalyzedArea"),
    (0X00460230, "FL", "SurfaceRegularityIndex"),
    (0X00460232, "FL", "SurfaceAsymmetryIndex"),
    (0X00460234, "FL", "CornealEccentricityIndex"),
    (0X00460236, "FL", "KeratoconusPredictionIndex"),
    (0X00460238, "FL", "DecimalPotentialVisualAcuity"),
    (0X00460242, "CS", "CornealTopographyMapQualityEvaluation"),
    (0X00460244, "SQ", "SourceImageCornealProcessedDataSequence"),
    (0X00460247, "FL", "CornealPointLocation"),
    (0X00460248, "CS", "CornealPointEstimated"),
    (0X00460249, "FL", "AxialPower"),
    (0X00460250, "FL", "TangentialPower"),
    (0X00460251, "FL", "RefractivePower"),
    (0X00460252, "FL", "RelativeElevation"),
    (0X00460253, "FL", "CornealWavefront"),
    (0X00480001, "FL", "ImagedVolumeWidth"),
    (0X00480002, "FL", "ImagedVolumeHeight"),
    (0X00480003, "FL", "ImagedVolumeDepth"),
    (0X00480006, "UL", "TotalPixelMatrixColumns"),
    (0X00480007, "UL", "TotalPixelMatrixRows"),
    (0X00480008, "SQ", "TotalPixelMatrixOriginSequence"),
    (0X00480010, "CS", "SpecimenLabelInImage"),
    (0X00480011, "CS", "FocusMethod"),
    (0X00480012, "CS", "ExtendedDepthOfField"),
    (0X00480013, "US", "NumberOfFocalPlanes"),
    (0X00480014, "FL", "DistanceBetweenFocalPlanes"),
    (0X00480015, "US", "RecommendedAbsentPixelCIELabValue"),
    (0X00480100, "SQ", "IlluminatorTypeCodeSequence"),
    (0X00480102, "DS", "ImageOrientationSlide"),
    (0X00480105, "SQ", "OpticalPathSequence"),
    (0X00480106, "SH", "OpticalPathIdentifier"),
    (0X00480107, "ST", "OpticalPathDescription"),
    (0X00480108, "SQ", "IlluminationColorCodeSequence"),
    (0X00480110, "SQ", "SpecimenReferenceSequence"),
    (0X00480111, "DS", "CondenserLensPower"),
    (0X00480112, "DS", "ObjectiveLensPower"),
    (0X00480113, "DS", "ObjectiveLensNumericalAperture"),
    (0X00480120, "SQ", "PaletteColorLookupTableSequence"),
    (0X00480200, "SQ", "ReferencedImageNavigationSequence"),
    (0X00480201, "US", "TopLeftHandCornerOfLocalizerArea"),
    (0X00480202, "US", "BottomRightHandCornerOfLocalizerArea"),
    (0X00480207, "SQ", "OpticalPathIdentificationSequence"),
    (0X0048021A, "SQ", "PlanePositionSlideSequence"),
    (0X0048021E, "SL", "ColumnPositionInTotalImagePixelMatrix"),
    (0X0048021F, "SL", "RowPositionInTotalImagePixelMatrix"),
    (0X00480301, "CS", "PixelOriginInterpretation"),
    (0X00480302, "UL", "NumberOfOpticalPaths"),
    (0X00480303, "UL", "TotalPixelMatrixFocalPlanes"),
    (0X00500004, "CS", "CalibrationImage"),
    (0X00500010, "SQ", "DeviceSequence"),
    (0X00500012, "SQ", "ContainerComponentTypeCodeSequence"),
    (0X00500013, "FD", "ContainerComponentThickness"),
    (0X00500014, "DS", "DeviceLength"),
    (0X00500015, "FD", "ContainerComponentWidth"),
    (0X00500016, "DS", "DeviceDiameter"),
    (0X00500017, "CS", "DeviceDiameterUnits"),
    (0X00500018, "DS", "DeviceVolume"),
    (0X00500019, "DS", "InterMarkerDistance"),
    (0X0050001A, "CS", "ContainerComponentMaterial"),
    (0X0050001B, "LO", "ContainerComponentID"),
    (0X0050001C, "FD", "ContainerComponentLength"),
    (0X0050001D, "FD", "ContainerComponentDiameter"),
    (0X0050001E, "LO", "ContainerComponentDescription"),
    (0X00500020, "LO", "DeviceDescription"),
    (0X00500021, "ST", "LongDeviceDescription"),
    (0X00520001, "FL", "ContrastBolusIngredientPercentByVolume"),
    (0X00520002, "FD", "OCTFocalDistance"),
    (0X00520003, "FD", "BeamSpotSize"),
    (0X00520004, "FD", "EffectiveRefractiveIndex"),
    (0X00520006, "CS", "OCTAcquisitionDomain"),
    (0X00520007, "FD", "OCTOpticalCenterWavelength"),
    (0X00520008, "FD", "AxialResolution"),
    (0X00520009, "FD", "RangingDepth"),
    (0X00520011, "FD", "ALineRate"),
    (0X00520012, "US", "ALinesPerFrame"),
    (0X00520013, "FD", "CatheterRotationalRate"),
    (0X00520014, "FD", "ALinePixelSpacing"),
    (0X00520016, "SQ", "ModeOfPercutaneousAccessSequence"),
    (0X00520025, "SQ", "IntravascularOCTFrameTypeSequence"),
    (0X00520026, "CS", "OCTZOffsetApplied"),
    (0X00520027, "SQ", "IntravascularFrameContentSequence"),
    (0X00520028, "FD", "IntravascularLongitudinalDistance"),
    (0X00520029, "SQ", "IntravascularOCTFrameContentSequence"),
    (0X00520030, "SS", "OCTZOffsetCorrection"),
    (0X00520031, "CS", "CatheterDirectionOfRotation"),
    (0X00520033, "FD", "SeamLineLocation"),
    (0X00520034, "FD", "FirstALineLocation"),
    (0X00520036, "US", "SeamLineIndex"),
    (0X00520038, "US", "NumberOfPaddedALines"),
    (0X00520039, "CS", "InterpolationType"),
    (0X0052003A, "CS", "RefractiveIndexApplied"),
    (0X00540010, "US", "EnergyWindowVector"),
    (0X00540011, "US", "NumberOfEnergyWindows"),
    (0X00540012, "SQ", "EnergyWindowInformationSequence"),
    (0X00540013, "SQ", "EnergyWindowRangeSequence"),
    (0X00540014, "DS", "EnergyWindowLowerLimit"),
    (0X00540015, "DS", "EnergyWindowUpperLimit"),
    (0X00540016, "SQ", "RadiopharmaceuticalInformationSequence"),
    (0X00540017, "IS", "ResidualSyringeCounts"),
    (0X00540018, "SH", "EnergyWindowName"),
    (0X00540020, "US", "DetectorVector"),
    (0X00540021, "US", "NumberOfDetectors"),
    (0X00540022, "SQ", "DetectorInformationSequence"),
    (0X00540030, "US", "PhaseVector"),
    (0X00540031, "US", "NumberOfPhases"),
    (0X00540032, "SQ", "PhaseInformationSequence"),
    (0X00540033, "US", "NumberOfFramesInPhase"),
    (0X00540036, "IS", "PhaseDelay"),
    (0X00540038, "IS", "PauseBetweenFrames"),
    (0X00540039, "CS", "PhaseDescription"),
    (0X00540050, "US", "RotationVector"),
    (0X00540051, "US", "NumberOfRotations"),
    (0X00540052, "SQ", "RotationInformationSequence"),
    (0X00540053, "US", "NumberOfFramesInRotation"),
    (0X00540060, "US", "RRIntervalVector"),
    (0X00540061, "US", "NumberOfRRIntervals"),
    (0X00540062, "SQ", "GatedInformationSequence"),
    (0X00540063, "SQ", "DataInformationSequence"),
    (0X00540070, "US", "TimeSlotVector"),
    (0X00540071, "US", "NumberOfTimeSlots"),
    (0X00540072, "SQ", "TimeSlotInformationSequence"),
    (0X00540073, "DS", "TimeSlotTime"),
    (0X00540080, "US", "SliceVector"),
    (0X00540081, "US", "NumberOfSlices"),
    (0X00540090, "US", "AngularViewVector"),
    (0X00540100, "US", "TimeSliceVector"),
    (0X00540101, "US", "NumberOfTimeSlices"),
    (0X00540200, "DS", "StartAngle"),
    (0X00540202, "CS", "TypeOfDetectorMotion"),
    (0X00540210, "IS", "TriggerVector"),
    (0X00540211, "US", "NumberOfTriggersInPhase"),
    (0X00540220, "SQ", "ViewCodeSequence"),
    (0X00540222, "SQ", "ViewModifierCodeSequence"),
    (0X00540300, "SQ", "RadionuclideCodeSequence"),
    (0X00540302, "SQ", "AdministrationRouteCodeSequence"),
    (0X00540304, "SQ", "RadiopharmaceuticalCodeSequence"),
    (0X00540306, "SQ", "CalibrationDataSequence"),
    (0X00540308, "US", "EnergyWindowNumber"),
    (0X00540400, "SH", "ImageID"),
    (0X00540410, "SQ", "PatientOrientationCodeSequence"),
    (0X00540412, "SQ", "PatientOrientationModifierCodeSequence"),
    (0X00540414, "SQ", "PatientGantryRelationshipCodeSequence"),
    (0X00540500, "CS", "SliceProgressionDirection"),
    (0X00540501, "CS", "ScanProgressionDirection"),
    (0X00541000, "CS", "SeriesType"),
    (0X00541001, "CS", "Units"),
    (0X00541002, "CS", "CountsSource"),
    (0X00541004, "CS", "ReprojectionMethod"),
    (0X00541006, "CS", "SUVType"),
    (0X00541100, "CS", "RandomsCorrectionMethod"),
    (0X00541101, "LO", "AttenuationCorrectionMethod"),
    (0X00541102, "CS", "DecayCorrection"),
    (0X00541103, "LO", "ReconstructionMethod"),
    (0X00541104, "LO", "DetectorLinesOfResponseUsed"),
    (0X00541105, "LO", "ScatterCorrectionMethod"),
    (0X00541200, "DS", "AxialAcceptance"),
    (0X00541201, "IS", "AxialMash"),
    (0X00541202, "IS", "TransverseMash"),
    (0X00541203, "DS", "DetectorElementSize"),
    (0X00541210, "DS", "CoincidenceWindowWidth"),
    (0X00541220, "CS", "SecondaryCountsType"),
    (0X00541300, "DS", "FrameReferenceTime"),
    (0X00541310, "IS", "PrimaryPromptsCountsAccumulated"),
    (0X00541311, "IS", "SecondaryCountsAccumulated"),
    (0X00541320, "DS", "SliceSensitivityFactor"),
    (0X00541321, "DS", "DecayFactor"),
    (0X00541322, "DS", "DoseCalibrationFactor"),
    (0X00541323, "DS", "ScatterFractionFactor"),
    (0X00541324, "DS", "DeadTimeFactor"),
    (0X00541330, "US", "ImageIndex"),
    (0X00541400, "CS", "CountsIncluded"),
    (0X00541401, "CS", "DeadTimeCorrectionFlag"),
    (0X00603000, "SQ", "HistogramSequence"),
    (0X00603002, "US", "HistogramNumberOfBins"),
    (0X00603004, "SS", "HistogramFirstBinValue"),
    (0X00603006, "SS", "HistogramLastBinValue"),
    (0X00603008, "US", "HistogramBinWidth"),
    (0X00603010, "LO", "HistogramExplanation"),
    (0X00603020, "UL", "HistogramData"),
    (0X00620001, "CS", "SegmentationType"),
    (0X00620002, "SQ", "SegmentSequence"),
    (0X00620003, "SQ", "SegmentedPropertyCategoryCodeSequence"),
    (0X00620004, "US", "SegmentNumber"),
    (0X00620005, "LO", "SegmentLabel"),
    (0X00620006, "ST", "SegmentDescription"),
    (0X00620007, "SQ", "SegmentationAlgorithmIdentificationSequence"),
    (0X00620008, "CS", "SegmentAlgorithmType"),
    (0X00620009, "LO", "SegmentAlgorithmName"),
    (0X0062000A, "SQ", "SegmentIdentificationSequence"),
    (0X0062000B, "US", "ReferencedSegmentNumber"),
    (0X0062000C, "US", "RecommendedDisplayGrayscaleValue"),
    (0X0062000D, "US", "RecommendedDisplayCIELabValue"),
    (0X0062000E, "US", "MaximumFractionalValue"),
    (0X0062000F, "SQ", "SegmentedPropertyTypeCodeSequence"),
    (0X00620010, "CS", "SegmentationFractionalType"),
    (0X00620011, "SQ", "SegmentedPropertyTypeModifierCodeSequence"),
    (0X00620012, "SQ", "UsedSegmentsSequence"),
    (0X00620013, "CS", "SegmentsOverlap"),
    (0X00620020, "UT", "TrackingID"),
    (0X00620021, "UI", "TrackingUID"),
    (0X00640002, "SQ", "DeformableRegistrationSequence"),
    (0X00640003, "UI", "SourceFrameOfReferenceUID"),
    (0X00640005, "SQ", "DeformableRegistrationGridSequence"),
    (0X00640007, "UL", "GridDimensions"),
    (0X00640008, "FD", "GridResolution"),
    (0X00640009, "OF", "VectorGridData"),
    (0X0064000F, "SQ", "PreDeformationMatrixRegistrationSequence"),
    (0X00640010, "SQ", "PostDeformationMatrixRegistrationSequence"),
    (0X00660001, "UL", "NumberOfSurfaces"),
    (0X00660002, "SQ", "SurfaceSequence"),
    (0X00660003, "UL", "SurfaceNumber"),
    (0X00660004, "LT", "SurfaceComments"),
    (0X00660009, "CS", "SurfaceProcessing"),
    (0X0066000A, "FL", "SurfaceProcessingRatio"),
    (0X0066000B, "LO", "SurfaceProcessingDescription"),
    (0X0066000C, "FL", "RecommendedPresentationOpacity"),
    (0X0066000D, "CS", "RecommendedPresentationType"),
    (0X0066000E, "CS", "FiniteVolume"),
    (0X00660010, "CS", "Manifold"),
    (0X00660011, "SQ", "SurfacePointsSequence"),
    (0X00660012, "SQ", "SurfacePointsNormalsSequence"),
    (0X00660013, "SQ", "SurfaceMeshPrimitivesSequence"),
    (0X00660015, "UL", "NumberOfSurfacePoints"),
    (0X00660016, "OF", "PointCoordinatesData"),
    (0X00660017, "FL", "PointPositionAccuracy"),
    (0X00660018, "FL", "MeanPointDistance"),
    (0X00660019, "FL", "MaximumPointDistance"),
    (0X0066001A, "FL", "PointsBoundingBoxCoordinates"),
    (0X0066001B, "FL", "AxisOfRotation"),
    (0X0066001C, "FL", "CenterOfRotation"),
    (0X0066001E, "UL", "NumberOfVectors"),
    (0X0066001F, "US", "VectorDimensionality"),
    (0X00660020, "FL", "VectorAccuracy"),
    (0X00660021, "OF", "VectorCoordinateData"),
    (0X00660022, "OD", "DoublePointCoordinatesData"),
    (0X00660023, "OW", "TrianglePointIndexList"),
    (0X00660024, "OW", "EdgePointIndexList"),
    (0X00660025, "OW", "VertexPointIndexList"),
    (0X00660026, "SQ", "TriangleStripSequence"),
    (0X00660027, "SQ", "TriangleFanSequence"),
    (0X00660028, "SQ", "LineSequence"),
    (0X00660029, "OW", "PrimitivePointIndexList"),
    (0X0066002A, "UL", "SurfaceCount"),
    (0X0066002B, "SQ", "ReferencedSurfaceSequence"),
    (0X0066002C, "UL", "ReferencedSurfaceNumber"),
    (0X0066002D, "SQ", "SegmentSurfaceGenerationAlgorithmIdentificationSequence"),
    (0X0066002E, "SQ", "SegmentSurfaceSourceInstanceSequence"),
    (0X0066002F, "SQ", "AlgorithmFamilyCodeSequence"),
    (0X00660030, "SQ", "AlgorithmNameCodeSequence"),
    (0X00660031, "LO", "AlgorithmVersion"),
    (0X00660032, "LT", "AlgorithmParameters"),
    (0X00660034, "SQ", "FacetSequence"),
    (0X00660035, "SQ", "SurfaceProcessingAlgorithmIdentificationSequence"),
    (0X00660036, "LO", "AlgorithmName"),
    (0X00660037, "FL", "RecommendedPointRadius"),
    (0X00660038, "FL", "RecommendedLineThickness"),
    (0X00660040, "OL", "LongPrimitivePointIndexList"),
    (0X00660041, "OL", "LongTrianglePointIndexList"),
    (0X00660042, "OL", "LongEdgePointIndexList"),
    (0X00660043, "OL", "LongVertexPointIndexList"),
    (0X00660101, "SQ", "TrackSetSequence"),
    (0X00660102, "SQ", "TrackSequence"),
    (0X00660103, "OW", "RecommendedDisplayCIELabValueList"),
    (0X00660104, "SQ", "TrackingAlgorithmIdentificationSequence"),
    (0X00660105, "UL", "TrackSetNumber"),
    (0X00660106, "LO", "TrackSetLabel"),
    (0X00660107, "UT", "TrackSetDescription"),
    (0X00660108, "SQ", "TrackSetAnatomicalTypeCodeSequence"),
    (0X00660121, "SQ", "MeasurementsSequence"),
    (0X00660124, "SQ", "TrackSetStatisticsSequence"),
    (0X00660125, "OF", "FloatingPointValues"),
    (0X00660129, "OL", "TrackPointIndexList"),
    (0X00660130, "SQ", "TrackStatisticsSequence"),
    (0X00660132, "SQ", "MeasurementValuesSequence"),
    (0X00660133, "SQ", "DiffusionAcquisitionCodeSequence"),
    (0X00660134, "SQ", "DiffusionModelCodeSequence"),
    (0X00686210, "LO", "ImplantSize"),
    (0X00686221, "LO", "ImplantTemplateVersion"),
    (0X00686222, "SQ", "ReplacedImplantTemplateSequence"),
    (0X00686223, "CS", "ImplantType"),
    (0X00686224, "SQ", "DerivationImplantTemplateSequence"),
    (0X00686225, "SQ", "OriginalImplantTemplateSequence"),
    (0X00686226, "DT", "EffectiveDateTime"),
    (0X00686230, "SQ", "ImplantTargetAnatomySequence"),
    (0X00686260, "SQ", "InformationFromManufacturerSequence"),
    (0X00686265, "SQ", "NotificationFromManufacturerSequence"),
    (0X00686270, "DT", "InformationIssueDateTime"),
    (0X00686280, "ST", "InformationSummary"),
    (0X006862A0, "SQ", "ImplantRegulatoryDisapprovalCodeSequence"),
    (0X006862A5, "FD", "OverallTemplateSpatialTolerance"),
    (0X006862C0, "SQ", "HPGLDocumentSequence"),
    (0X006862D0, "US", "HPGLDocumentID"),
    (0X006862D5, "LO", "HPGLDocumentLabel"),
    (0X006862E0, "SQ", "ViewOrientationCodeSequence"),
    (0X006862F0, "SQ", "ViewOrientationModifierCodeSequence"),
    (0X006862F2, "FD", "HPGLDocumentScaling"),
    (0X00686300, "OB", "HPGLDocument"),
    (0X00686310, "US", "HPGLContourPenNumber"),
    (0X00686320, "SQ", "HPGLPenSequence"),
    (0X00686330, "US", "HPGLPenNumber"),
    (0X00686340, "LO", "HPGLPenLabel"),
    (0X00686345, "ST", "HPGLPenDescription"),
    (0X00686346, "FD", "RecommendedRotationPoint"),
    (0X00686347, "FD", "BoundingRectangle"),
    (0X00686350, "US", "ImplantTemplate3DModelSurfaceNumber"),
    (0X00686360, "SQ", "SurfaceModelDescriptionSequence"),
    (0X00686380, "LO", "SurfaceModelLabel"),
    (0X00686390, "FD", "SurfaceModelScalingFactor"),
    (0X006863A0, "SQ", "MaterialsCodeSequence"),
    (0X006863A4, "SQ", "CoatingMaterialsCodeSequence"),
    (0X006863A8, "SQ", "ImplantTypeCodeSequence"),
    (0X006863AC, "SQ", "FixationMethodCodeSequence"),
    (0X006863B0, "SQ", "MatingFeatureSetsSequence"),
    (0X006863C0, "US", "MatingFeatureSetID"),
    (0X006863D0, "LO", "MatingFeatureSetLabel"),
    (0X006863E0, "SQ", "MatingFeatureSequence"),
    (0X006863F0, "US", "MatingFeatureID"),
    (0X00686400, "SQ", "MatingFeatureDegreeOfFreedomSequence"),
    (0X00686410, "US", "DegreeOfFreedomID"),
    (0X00686420, "CS", "DegreeOfFreedomType"),
    (0X00686430, "SQ", "TwoDMatingFeatureCoordinatesSequence"),
    (0X00686440, "US", "ReferencedHPGLDocumentID"),
    (0X00686450, "FD", "TwoDMatingPoint"),
    (0X00686460, "FD", "TwoDMatingAxes"),
    (0X00686470, "SQ", "TwoDDegreeOfFreedomSequence"),
    (0X00686490, "FD", "ThreeDDegreeOfFreedomAxis"),
    (0X006864A0, "FD", "RangeOfFreedom"),
    (0X006864C0, "FD", "ThreeDMatingPoint"),
    (0X006864D0, "FD", "ThreeDMatingAxes"),
    (0X006864F0, "FD", "TwoDDegreeOfFreedomAxis"),
    (0X00686500, "SQ", "PlanningLandmarkPointSequence"),
    (0X00686510, "SQ", "PlanningLandmarkLineSequence"),
    (0X00686520, "SQ", "PlanningLandmarkPlaneSequence"),
    (0X00686530, "US", "PlanningLandmarkID"),
    (0X00686540, "LO", "PlanningLandmarkDescription"),
    (0X00686545, "SQ", "PlanningLandmarkIdentificationCodeSequence"),
    (0X00686550, "SQ", "TwoDPointCoordinatesSequence"),
    (0X00686560, "FD", "TwoDPointCoordinates"),
    (0X00686590, "FD", "ThreeDPointCoordinates"),
    (0X006865A0, "SQ", "TwoDLineCoordinatesSequence"),
    (0X006865B0, "FD", "TwoDLineCoordinates"),
    (0X006865D0, "FD", "ThreeDLineCoordinates"),
    (0X006865E0, "SQ", "TwoDPlaneCoordinatesSequence"),
    (0X006865F0, "FD", "TwoDPlaneIntersection"),
    (0X00686610, "FD", "ThreeDPlaneOrigin"),
    (0X00686620, "FD", "ThreeDPlaneNormal"),
    (0X00687001, "CS", "ModelModification"),
    (0X00687002, "CS", "ModelMirroring"),
    (0X00687003, "SQ", "ModelUsageCodeSequence"),
    (0X00687004, "UI", "ModelGroupUID"),
    (0X00687005, "UR", "RelativeURIReferenceWithinEncapsulatedDocument"),
    (0X006A0001, "CS", "AnnotationCoordinateType"),
    (0X006A0002, "SQ", "AnnotationGroupSequence"),
    (0X006A0003, "UI", "AnnotationGroupUID"),
    (0X006A0005, "LO", "AnnotationGroupLabel"),
    (0X006A0006, "UT", "AnnotationGroupDescription"),
    (0X006A0007, "CS", "AnnotationGroupGenerationType"),
    (0X006A0008, "SQ", "AnnotationGroupAlgorithmIdentificationSequence"),
    (0X006A0009, "SQ", "AnnotationPropertyCategoryCodeSequence"),
    (0X006A000A, "SQ", "AnnotationPropertyTypeCodeSequence"),
    (0X006A000B, "SQ", "AnnotationPropertyTypeModifierCodeSequence"),
    (0X006A000C, "UL", "NumberOfAnnotations"),
    (0X006A000D, "CS", "AnnotationAppliesToAllOpticalPaths"),
    (0X006A000E, "SH", "ReferencedOpticalPathIdentifier"),
    (0X006A000F, "CS", "AnnotationAppliesToAllZPlanes"),
    (0X006A0010, "FD", "CommonZCoordinateValue"),
    (0X006A0011, "OL", "AnnotationIndexList"),
    (0X00700001, "SQ", "GraphicAnnotationSequence"),
    (0X00700002, "CS", "GraphicLayer"),
    (0X00700003, "CS", "BoundingBoxAnnotationUnits"),
    (0X00700004, "CS", "AnchorPointAnnotationUnits"),
    (0X00700005, "CS", "GraphicAnnotationUnits"),
    (0X00700006, "ST", "UnformattedTextValue"),
    (0X00700008, "SQ", "TextObjectSequence"),
    (0X00700009, "SQ", "GraphicObjectSequence"),
    (0X00700010, "FL", "BoundingBoxTopLeftHandCorner"),
    (0X00700011, "FL", "BoundingBoxBottomRightHandCorner"),
    (0X00700012, "CS", "BoundingBoxTextHorizontalJustification"),
    (0X00700014, "FL", "AnchorPoint"),
    (0X00700015, "CS", "AnchorPointVisibility"),
    (0X00700020, "US", "GraphicDimensions"),
    (0X00700021, "US", "NumberOfGraphicPoints"),
    (0X00700022, "FL", "GraphicData"),
    (0X00700023, "CS", "GraphicType"),
    (0X00700024, "CS", "GraphicFilled"),
    (0X00700040, "IS", "ImageRotationRetired"),
    (0X00700041, "CS", "ImageHorizontalFlip"),
    (0X00700042, "US", "ImageRotation"),
    (0X00700050, "US", "DisplayedAreaTopLeftHandCornerTrial"),
    (0X00700051, "US", "DisplayedAreaBottomRightHandCornerTrial"),
    (0X00700052, "SL", "DisplayedAreaTopLeftHandCorner"),
    (0X00700053, "SL", "DisplayedAreaBottomRightHandCorner"),
    (0X0070005A, "SQ", "DisplayedAreaSelectionSequence"),
    (0X00700060, "SQ", "GraphicLayerSequence"),
    (0X00700062, "IS", "GraphicLayerOrder"),
    (0X00700066, "US", "GraphicLayerRecommendedDisplayGrayscaleValue"),
    (0X00700067, "US", "GraphicLayerRecommendedDisplayRGBValue"),
    (0X00700068, "LO", "GraphicLayerDescription"),
    (0X00700080, "CS", "ContentLabel"),
    (0X00700081, "LO", "ContentDescription"),
    (0X00700082, "DA", "PresentationCreationDate"),
    (0X00700083, "TM", "PresentationCreationTime"),
    (0X00700084, "PN", "ContentCreatorName"),
    (0X00700086, "SQ", "ContentCreatorIdentificationCodeSequence"),
    (0X00700087, "SQ", "AlternateContentDescriptionSequence"),
    (0X00700100, "CS", "PresentationSizeMode"),
    (0X00700101, "DS", "PresentationPixelSpacing"),
    (0X00700102, "IS", "PresentationPixelAspectRatio"),
    (0X00700103, "FL", "PresentationPixelMagnificationRatio"),
    (0X00700207, "LO", "GraphicGroupLabel"),
    (0X00700208, "ST", "GraphicGroupDescription"),
    (0X00700209, "SQ", "CompoundGraphicSequence"),
    (0X00700226, "UL", "CompoundGraphicInstanceID"),
    (0X00700227, "LO", "FontName"),
    (0X00700228, "CS", "FontNameType"),
    (0X00700229, "LO", "CSSFontName"),
    (0X00700230, "FD", "RotationAngle"),
    (0X00700231, "SQ", "TextStyleSequence"),
    (0X00700232, "SQ", "LineStyleSequence"),
    (0X00700233, "SQ", "FillStyleSequence"),
    (0X00700234, "SQ", "GraphicGroupSequence"),
    (0X00700241, "US", "TextColorCIELabValue"),
    (0X00700242, "CS", "HorizontalAlignment"),
    (0X00700243, "CS", "VerticalAlignment"),
    (0X00700244, "CS", "ShadowStyle"),
    (0X00700245, "FL", "ShadowOffsetX"),
    (0X00700246, "FL", "ShadowOffsetY"),
    (0X00700247, "US", "ShadowColorCIELabValue"),
    (0X00700248, "CS", "Underlined"),
    (0X00700249, "CS", "Bold"),
    (0X00700250, "CS", "Italic"),
    (0X00700251, "US", "PatternOnColorCIELabValue"),
    (0X00700252, "US", "PatternOffColorCIELabValue"),
    (0X00700253, "FL", "LineThickness"),
    (0X00700254, "CS", "LineDashingStyle"),
    (0X00700255, "UL", "LinePattern"),
    (0X00700256, "OB", "FillPattern"),
    (0X00700257, "CS", "FillMode"),
    (0X00700258, "FL", "ShadowOpacity"),
    (0X00700261, "FL", "GapLength"),
    (0X00700262, "FL", "DiameterOfVisibility"),
    (0X00700273, "FL", "RotationPoint"),
    (0X00700274, "CS", "TickAlignment"),
    (0X00700278, "CS", "ShowTickLabel"),
    (0X00700279, "CS", "TickLabelAlignment"),
    (0X00700282, "CS", "CompoundGraphicUnits"),
    (0X00700284, "FL", "PatternOnOpacity"),
    (0X00700285, "FL", "PatternOffOpacity"),
    (0X00700287, "SQ", "MajorTicksSequence"),
    (0X00700288, "FL", "TickPosition"),
    (0X00700289, "SH", "TickLabel"),
    (0X00700294, "CS", "CompoundGraphicType"),
    (0X00700295, "UL", "GraphicGroupID"),
    (0X00700306, "CS", "ShapeType"),
    (0X00700308, "SQ", "RegistrationSequence"),
    (0X00700309, "SQ", "MatrixRegistrationSequence"),
    (0X0070030A, "SQ", "MatrixSequence"),
    (0X0070030B, "FD", "FrameOfReferenceToDisplayedCoordinateSystemTransformationMatrix"),
    (0X0070030C, "CS", "FrameOfReferenceTransformationMatrixType"),
    (0X0070030D, "SQ", "RegistrationTypeCodeSequence"),
    (0X0070030F, "ST", "FiducialDescription"),
    (0X00700310, "SH", "FiducialIdentifier"),
    (0X00700311, "SQ", "FiducialIdentifierCodeSequence"),
    (0X00700312, "FD", "ContourUncertaintyRadius"),
    (0X00700314, "SQ", "UsedFiducialsSequence"),
    (0X00700318, "SQ", "GraphicCoordinatesDataSequence"),
    (0X0070031A, "UI", "FiducialUID"),
    (0X0070031B, "UI", "ReferencedFiducialUID"),
    (0X0070031C, "SQ", "FiducialSetSequence"),
    (0X0070031E, "SQ", "FiducialSequence"),
    (0X0070031F, "SQ", "FiducialsPropertyCategoryCodeSequence"),
    (0X00700401, "US", "GraphicLayerRecommendedDisplayCIELabValue"),
    (0X00700402, "SQ", "BlendingSequence"),
    (0X00700403, "FL", "RelativeOpacity"),
    (0X00700404, "SQ", "ReferencedSpatialRegistrationSequence"),
    (0X00700405, "CS", "BlendingPosition"),
    (0X00701101, "UI", "PresentationDisplayCollectionUID"),
    (0X00701102, "UI", "PresentationSequenceCollectionUID"),
    (0X00701103, "US", "PresentationSequencePositionIndex"),
    (0X00701104, "SQ", "RenderedImageReferenceSequence"),
    (0X00701201, "SQ", "VolumetricPresentationStateInputSequence"),
    (0X00701202, "CS", "PresentationInputType"),
    (0X00701203, "US", "InputSequencePositionIndex"),
    (0X00701204, "CS", "Crop"),
    (0X00701205, "US", "CroppingSpecificationIndex"),
    (0X00701206, "CS", "CompositingMethod"),
    (0X00701207, "US", "VolumetricPresentationInputNumber"),
    (0X00701208, "CS", "ImageVolumeGeometry"),
    (0X00701209, "UI", "VolumetricPresentationInputSetUID"),
    (0X0070120A, "SQ", "VolumetricPresentationInputSetSequence"),
    (0X0070120B, "CS", "GlobalCrop"),
    (0X0070120C, "US", "GlobalCroppingSpecificationIndex"),
    (0X0070120D, "CS", "RenderingMethod"),
    (0X00701301, "SQ", "VolumeCroppingSequence"),
    (0X00701302, "CS", "VolumeCroppingMethod"),
    (0X00701303, "FD", "BoundingBoxCrop"),
    (0X00701304, "SQ", "ObliqueCroppingPlaneSequence"),
    (0X00701305, "FD", "Plane"),
    (0X00701306, "FD", "PlaneNormal"),
    (0X00701309, "US", "CroppingSpecificationNumber"),
    (0X00701501, "CS", "MultiPlanarReconstructionStyle"),
    (0X00701502, "CS", "MPRThicknessType"),
    (0X00701503, "FD", "MPRSlabThickness"),
    (0X00701505, "FD", "MPRTopLeftHandCorner"),
    (0X00701507, "FD", "MPRViewWidthDirection"),
    (0X00701508, "FD", "MPRViewWidth"),
    (0X0070150C, "UL", "NumberOfVolumetricCurvePoints"),
    (0X0070150D, "OD", "VolumetricCurvePoints"),
    (0X00701511, "FD", "MPRViewHeightDirection"),
    (0X00701512, "FD", "MPRViewHeight"),
    (0X00701602, "CS", "RenderProjection"),
    (0X00701603, "FD", "ViewpointPosition"),
    (0X00701604, "FD", "ViewpointLookAtPoint"),
    (0X00701605, "FD", "ViewpointUpDirection"),
    (0X00701606, "FD", "RenderFieldOfView"),
    (0X00701607, "FD", "SamplingStepSize"),
    (0X00701701, "CS", "ShadingStyle"),
    (0X00701702, "FD", "AmbientReflectionIntensity"),
    (0X00701703, "FD", "LightDirection"),
    (0X00701704, "FD", "DiffuseReflectionIntensity"),
    (0X00701705, "FD", "SpecularReflectionIntensity"),
    (0X00701706, "FD", "Shininess"),
    (0X00701801, "SQ", "PresentationStateClassificationComponentSequence"),
    (0X00701802, "CS", "ComponentType"),
    (0X00701803, "SQ", "ComponentInputSequence"),
    (0X00701804, "US", "VolumetricPresentationInputIndex"),
    (0X00701805, "SQ", "PresentationStateCompositorComponentSequence"),
    (0X00701806, "SQ", "WeightingTransferFunctionSequence"),
    (0X00701807, "US", "WeightingLookupTableDescriptor"),
    (0X00701808, "OB", "WeightingLookupTableData"),
    (0X00701901, "SQ", "VolumetricAnnotationSequence"),
    (0X00701903, "SQ", "ReferencedStructuredContextSequence"),
    (0X00701904, "UI", "ReferencedContentItem"),
    (0X00701905, "SQ", "VolumetricPresentationInputAnnotationSequence"),
    (0X00701907, "CS", "AnnotationClipping"),
    (0X00701A01, "CS", "PresentationAnimationStyle"),
    (0X00701A03, "FD", "RecommendedAnimationRate"),
    (0X00701A04, "SQ", "AnimationCurveSequence"),
    (0X00701A05, "FD", "AnimationStepSize"),
    (0X00701A06, "FD", "SwivelRange"),
    (0X00701A07, "OD", "VolumetricCurveUpDirections"),
    (0X00701A08, "SQ", "VolumeStreamSequence"),
    (0X00701A09, "LO", "RGBATransferFunctionDescription"),
    (0X00701B01, "SQ", "AdvancedBlendingSequence"),
    (0X00701B02, "US", "BlendingInputNumber"),
    (0X00701B03, "SQ", "BlendingDisplayInputSequence"),
    (0X00701B04, "SQ", "BlendingDisplaySequence"),
    (0X00701B06, "CS", "BlendingMode"),
    (0X00701B07, "CS", "TimeSeriesBlending"),
    (0X00701B08, "CS", "GeometryForDisplay"),
    (0X00701B11, "SQ", "ThresholdSequence"),
    (0X00701B12, "SQ", "ThresholdValueSequence"),
    (0X00701B13, "CS", "ThresholdType"),
    (0X00701B14, "FD", "ThresholdValue"),
    (0X00720002, "SH", "HangingProtocolName"),
    (0X00720004, "LO", "HangingProtocolDescription"),
    (0X00720006, "CS", "HangingProtocolLevel"),
    (0X00720008, "LO", "HangingProtocolCreator"),
    (0X0072000A, "DT", "HangingProtocolCreationDateTime"),
    (0X0072000C, "SQ", "HangingProtocolDefinitionSequence"),
    (0X0072000E, "SQ", "HangingProtocolUserIdentificationCodeSequence"),
    (0X00720010, "LO", "HangingProtocolUserGroupName"),
    (0X00720012, "SQ", "SourceHangingProtocolSequence"),
    (0X00720014, "US", "NumberOfPriorsReferenced"),
    (0X00720020, "SQ", "ImageSetsSequence"),
    (0X00720022, "SQ", "ImageSetSelectorSequence"),
    (0X00720024, "CS", "ImageSetSelectorUsageFlag"),
    (0X00720026, "AT", "SelectorAttribute"),
    (0X00720028, "US", "SelectorValueNumber"),
    (0X00720030, "SQ", "TimeBasedImageSetsSequence"),
    (0X00720032, "US", "ImageSetNumber"),
    (0X00720034, "CS", "ImageSetSelectorCategory"),
    (0X00720038, "US", "RelativeTime"),
    (0X0072003A, "CS", "RelativeTimeUnits"),
    (0X0072003C, "SS", "AbstractPriorValue"),
    (0X0072003E, "SQ", "AbstractPriorCodeSequence"),
    (0X00720040, "LO", "ImageSetLabel"),
    (0X00720050, "CS", "SelectorAttributeVR"),
    (0X00720052, "AT", "SelectorSequencePointer"),
    (0X00720054, "LO", "SelectorSequencePointerPrivateCreator"),
    (0X00720056, "LO", "SelectorAttributePrivateCreator"),
    (0X0072005E, "AE", "SelectorAEValue"),
    (0X0072005F, "AS", "SelectorASValue"),
    (0X00720060, "AT", "SelectorATValue"),
    (0X00720061, "DA", "SelectorDAValue"),
    (0X00720062, "CS", "SelectorCSValue"),
    (0X00720063, "DT", "SelectorDTValue"),
    (0X00720064, "IS", "SelectorISValue"),
    (0X00720065, "OB", "SelectorOBValue"),
    (0X00720066, "LO", "SelectorLOValue"),
    (0X00720067, "OF", "SelectorOFValue"),
    (0X00720068, "LT", "SelectorLTValue"),
    (0X00720069, "OW", "SelectorOWValue"),
    (0X0072006A, "PN", "SelectorPNValue"),
    (0X0072006B, "TM", "SelectorTMValue"),
    (0X0072006C, "SH", "SelectorSHValue"),
    (0X0072006D, "UN", "SelectorUNValue"),
    (0X0072006E, "ST", "SelectorSTValue"),
    (0X0072006F, "UC", "SelectorUCValue"),
    (0X00720070, "UT", "SelectorUTValue"),
    (0X00720071, "UR", "SelectorURValue"),
    (0X00720072, "DS", "SelectorDSValue"),
    (0X00720073, "OD", "SelectorODValue"),
    (0X00720074, "FD", "SelectorFDValue"),
    (0X00720075, "OL", "SelectorOLValue"),
    (0X00720076, "FL", "SelectorFLValue"),
    (0X00720078, "UL", "SelectorULValue"),
    (0X0072007A, "US", "SelectorUSValue"),
    (0X0072007C, "SL", "SelectorSLValue"),
    (0X0072007E, "SS", "SelectorSSValue"),
    (0X0072007F, "UI", "SelectorUIValue"),
    (0X00720080, "SQ", "SelectorCodeSequenceValue"),
    (0X00720081, "OV", "SelectorOVValue"),
    (0X00720082, "SV", "SelectorSVValue"),
    (0X00720083, "UV", "SelectorUVValue"),
    (0X00720100, "US", "NumberOfScreens"),
    (0X00720102, "SQ", "NominalScreenDefinitionSequence"),
    (0X00720104, "US", "NumberOfVerticalPixels"),
    (0X00720106, "US", "NumberOfHorizontalPixels"),
    (0X00720108, "FD", "DisplayEnvironmentSpatialPosition"),
    (0X0072010A, "US", "ScreenMinimumGrayscaleBitDepth"),
    (0X0072010C, "US", "ScreenMinimumColorBitDepth"),
    (0X0072010E, "US", "ApplicationMaximumRepaintTime"),
    (0X00720200, "SQ", "DisplaySetsSequence"),
    (0X00720202, "US", "DisplaySetNumber"),
    (0X00720203, "LO", "DisplaySetLabel"),
    (0X00720204, "US", "DisplaySetPresentationGroup"),
    (0X00720206, "LO", "DisplaySetPresentationGroupDescription"),
    (0X00720208, "CS", "PartialDataDisplayHandling"),
    (0X00720210, "SQ", "SynchronizedScrollingSequence"),
    (0X00720212, "US", "DisplaySetScrollingGroup"),
    (0X00720214, "SQ", "NavigationIndicatorSequence"),
    (0X00720216, "US", "NavigationDisplaySet"),
    (0X00720218, "US", "ReferenceDisplaySets"),
    (0X00720300, "SQ", "ImageBoxesSequence"),
    (0X00720302, "US", "ImageBoxNumber"),
    (0X00720304, "CS", "ImageBoxLayoutType"),
    (0X00720306, "US", "ImageBoxTileHorizontalDimension"),
    (0X00720308, "US", "ImageBoxTileVerticalDimension"),
    (0X00720310, "CS", "ImageBoxScrollDirection"),
    (0X00720312, "CS", "ImageBoxSmallScrollType"),
    (0X00720314, "US", "ImageBoxSmallScrollAmount"),
    (0X00720316, "CS", "ImageBoxLargeScrollType"),
    (0X00720318, "US", "ImageBoxLargeScrollAmount"),
    (0X00720320, "US", "ImageBoxOverlapPriority"),
    (0X00720330, "FD", "CineRelativeToRealTime"),
    (0X00720400, "SQ", "FilterOperationsSequence"),
    (0X00720402, "CS", "FilterByCategory"),
    (0X00720404, "CS", "FilterByAttributePresence"),
    (0X00720406, "CS", "FilterByOperator"),
    (0X00720420, "US", "StructuredDisplayBackgroundCIELabValue"),
    (0X00720421, "US", "EmptyImageBoxCIELabValue"),
    (0X00720422, "SQ", "StructuredDisplayImageBoxSequence"),
    (0X00720424, "SQ", "StructuredDisplayTextBoxSequence"),
    (0X00720427, "SQ", "ReferencedFirstFrameSequence"),
    (0X00720430, "SQ", "ImageBoxSynchronizationSequence"),
    (0X00720432, "US", "SynchronizedImageBoxList"),
    (0X00720434, "CS", "TypeOfSynchronization"),
    (0X00720500, "CS", "BlendingOperationType"),
    (0X00720510, "CS", "ReformattingOperationType"),
    (0X00720512, "FD", "ReformattingThickness"),
    (0X00720514, "FD", "ReformattingInterval"),
    (0X00720516, "CS", "ReformattingOperationInitialViewDirection"),
    (0X00720520, "CS", "ThreeDRenderingType"),
    (0X00720600, "SQ", "SortingOperationsSequence"),
    (0X00720602, "CS", "SortByCategory"),
    (0X00720604, "CS", "SortingDirection"),
    (0X00720700, "CS", "DisplaySetPatientOrientation"),
    (0X00720702, "CS", "VOIType"),
    (0X00720704, "CS", "PseudoColorType"),
    (0X00720705, "SQ", "PseudoColorPaletteInstanceReferenceSequence"),
    (0X00720706, "CS", "ShowGrayscaleInverted"),
    (0X00720710, "CS", "ShowImageTrueSizeFlag"),
    (0X00720712, "CS", "ShowGraphicAnnotationFlag"),
    (0X00720714, "CS", "ShowPatientDemographicsFlag"),
    (0X00720716, "CS", "ShowAcquisitionTechniquesFlag"),
    (0X00720717, "CS", "DisplaySetHorizontalJustification"),
    (0X00720718, "CS", "DisplaySetVerticalJustification"),
    (0X00740120, "FD", "ContinuationStartMeterset"),
    (0X00740121, "FD", "ContinuationEndMeterset"),
    (0X00741000, "CS", "ProcedureStepState"),
    (0X00741002, "SQ", "ProcedureStepProgressInformationSequence"),
    (0X00741004, "DS", "ProcedureStepProgress"),
    (0X00741006, "ST", "ProcedureStepProgressDescription"),
    (0X00741007, "SQ", "ProcedureStepProgressParametersSequence"),
    (0X00741008, "SQ", "ProcedureStepCommunicationsURISequence"),
    (0X0074100A, "UR", "ContactURI"),
    (0X0074100C, "LO", "ContactDisplayName"),
    (0X0074100E, "SQ", "ProcedureStepDiscontinuationReasonCodeSequence"),
    (0X00741020, "SQ", "BeamTaskSequence"),
    (0X00741022, "CS", "BeamTaskType"),
    (0X00741024, "IS", "BeamOrderIndexTrial"),
    (0X00741025, "CS", "AutosequenceFlag"),
    (0X00741026, "FD", "TableTopVerticalAdjustedPosition"),
    (0X00741027, "FD", "TableTopLongitudinalAdjustedPosition"),
    (0X00741028, "FD", "TableTopLateralAdjustedPosition"),
    (0X0074102A, "FD", "PatientSupportAdjustedAngle"),
    (0X0074102B, "FD", "TableTopEccentricAdjustedAngle"),
    (0X0074102C, "FD", "TableTopPitchAdjustedAngle"),
    (0X0074102D, "FD", "TableTopRollAdjustedAngle"),
    (0X00741030, "SQ", "DeliveryVerificationImageSequence"),
    (0X00741032, "CS", "VerificationImageTiming"),
    (0X00741034, "CS", "DoubleExposureFlag"),
    (0X00741036, "CS", "DoubleExposureOrdering"),
    (0X00741038, "DS", "DoubleExposureMetersetTrial"),
    (0X0074103A, "DS", "DoubleExposureFieldDeltaTrial"),
    (0X00741040, "SQ", "RelatedReferenceRTImageSequence"),
    (0X00741042, "SQ", "GeneralMachineVerificationSequence"),
    (0X00741044, "SQ", "ConventionalMachineVerificationSequence"),
    (0X00741046, "SQ", "IonMachineVerificationSequence"),
    (0X00741048, "SQ", "FailedAttributesSequence"),
    (0X0074104A, "SQ", "OverriddenAttributesSequence"),
    (0X0074104C, "SQ", "ConventionalControlPointVerificationSequence"),
    (0X0074104E, "SQ", "IonControlPointVerificationSequence"),
    (0X00741050, "SQ", "AttributeOccurrenceSequence"),
    (0X00741052, "AT", "AttributeOccurrencePointer"),
    (0X00741054, "UL", "AttributeItemSelector"),
    (0X00741056, "LO", "AttributeOccurrencePrivateCreator"),
    (0X00741057, "IS", "SelectorSequencePointerItems"),
    (0X00741200, "CS", "ScheduledProcedureStepPriority"),
    (0X00741202, "LO", "WorklistLabel"),
    (0X00741204, "LO", "ProcedureStepLabel"),
    (0X00741210, "SQ", "ScheduledProcessingParametersSequence"),
    (0X00741212, "SQ", "PerformedProcessingParametersSequence"),
    (0X00741216, "SQ", "UnifiedProcedureStepPerformedProcedureSequence"),
    (0X00741220, "SQ", "RelatedProcedureStepSequence"),
    (0X00741222, "LO", "ProcedureStepRelationshipType"),
    (0X00741224, "SQ", "ReplacedProcedureStepSequence"),
    (0X00741230, "LO", "DeletionLock"),
    (0X00741234, "AE", "ReceivingAE"),
    (0X00741236, "AE", "RequestingAE"),
    (0X00741238, "LT", "ReasonForCancellation"),
    (0X00741242, "CS", "SCPStatus"),
    (0X00741244, "CS", "SubscriptionListStatus"),
    (0X00741246, "CS", "UnifiedProcedureStepListStatus"),
    (0X00741324, "UL", "BeamOrderIndex"),
    (0X00741338, "FD", "DoubleExposureMeterset"),
    (0X0074133A, "FD", "DoubleExposureFieldDelta"),
    (0X00741401, "SQ", "BrachyTaskSequence"),
    (0X00741402, "DS", "ContinuationStartTotalReferenceAirKerma"),
    (0X00741403, "DS", "ContinuationEndTotalReferenceAirKerma"),
    (0X00741404, "IS", "ContinuationPulseNumber"),
    (0X00741405, "SQ", "ChannelDeliveryOrderSequence"),
    (0X00741406, "IS", "ReferencedChannelNumber"),
    (0X00741407, "DS", "StartCumulativeTimeWeight"),
    (0X00741408, "DS", "EndCumulativeTimeWeight"),
    (0X00741409, "SQ", "OmittedChannelSequence"),
    (0X0074140A, "CS", "ReasonForChannelOmission"),
    (0X0074140B, "LO", "ReasonForChannelOmissionDescription"),
    (0X0074140C, "IS", "ChannelDeliveryOrderIndex"),
    (0X0074140D, "SQ", "ChannelDeliveryContinuationSequence"),
    (0X0074140E, "SQ", "OmittedApplicationSetupSequence"),
    (0X00760001, "LO", "ImplantAssemblyTemplateName"),
    (0X00760003, "LO", "ImplantAssemblyTemplateIssuer"),
    (0X00760006, "LO", "ImplantAssemblyTemplateVersion"),
    (0X00760008, "SQ", "ReplacedImplantAssemblyTemplateSequence"),
    (0X0076000A, "CS", "ImplantAssemblyTemplateType"),
    (0X0076000C, "SQ", "OriginalImplantAssemblyTemplateSequence"),
    (0X0076000E, "SQ", "DerivationImplantAssemblyTemplateSequence"),
    (0X00760010, "SQ", "ImplantAssemblyTemplateTargetAnatomySequence"),
    (0X00760020, "SQ", "ProcedureTypeCodeSequence"),
    (0X00760030, "LO", "SurgicalTechnique"),
    (0X00760032, "SQ", "ComponentTypesSequence"),
    (0X00760034, "SQ", "ComponentTypeCodeSequence"),
    (0X00760036, "CS", "ExclusiveComponentType"),
    (0X00760038, "CS", "MandatoryComponentType"),
    (0X00760040, "SQ", "ComponentSequence"),
    (0X00760055, "US", "ComponentID"),
    (0X00760060, "SQ", "ComponentAssemblySequence"),
    (0X00760070, "US", "Component1ReferencedID"),
    (0X00760080, "US", "Component1ReferencedMatingFeatureSetID"),
    (0X00760090, "US", "Component1ReferencedMatingFeatureID"),
    (0X007600A0, "US", "Component2ReferencedID"),
    (0X007600B0, "US", "Component2ReferencedMatingFeatureSetID"),
    (0X007600C0, "US", "Component2ReferencedMatingFeatureID"),
    (0X00780001, "LO", "ImplantTemplateGroupName"),
    (0X00780010, "ST", "ImplantTemplateGroupDescription"),
    (0X00780020, "LO", "ImplantTemplateGroupIssuer"),
    (0X00780024, "LO", "ImplantTemplateGroupVersion"),
    (0X00780026, "SQ", "ReplacedImplantTemplateGroupSequence"),
    (0X00780028, "SQ", "ImplantTemplateGroupTargetAnatomySequence"),
    (0X0078002A, "SQ", "ImplantTemplateGroupMembersSequence"),
    (0X0078002E, "US", "ImplantTemplateGroupMemberID"),
    (0X00780050, "FD", "ThreeDImplantTemplateGroupMemberMatchingPoint"),
    (0X00780060, "FD", "ThreeDImplantTemplateGroupMemberMatchingAxes"),
    (0X00780070, "SQ", "ImplantTemplateGroupMemberMatching2DCoordinatesSequence"),
    (0X00780090, "FD", "TwoDImplantTemplateGroupMemberMatchingPoint"),
    (0X007800A0, "FD", "TwoDImplantTemplateGroupMemberMatchingAxes"),
    (0X007800B0, "SQ", "ImplantTemplateGroupVariationDimensionSequence"),
    (0X007800B2, "LO", "ImplantTemplateGroupVariationDimensionName"),
    (0X007800B4, "SQ", "ImplantTemplateGroupVariationDimensionRankSequence"),
    (0X007800B6, "US", "ReferencedImplantTemplateGroupMemberID"),
    (0X007800B8, "US", "ImplantTemplateGroupVariationDimensionRank"),
    (0X00800001, "SQ", "SurfaceScanAcquisitionTypeCodeSequence"),
    (0X00800002, "SQ", "SurfaceScanModeCodeSequence"),
    (0X00800003, "SQ", "RegistrationMethodCodeSequence"),
    (0X00800004, "FD", "ShotDurationTime"),
    (0X00800005, "FD", "ShotOffsetTime"),
    (0X00800006, "US", "SurfacePointPresentationValueData"),
    (0X00800007, "US", "SurfacePointColorCIELabValueData"),
    (0X00800008, "SQ", "UVMappingSequence"),
    (0X00800009, "SH", "TextureLabel"),
    (0X00800010, "OF", "UValueData"),
    (0X00800011, "OF", "VValueData"),
    (0X00800012, "SQ", "ReferencedTextureSequence"),
    (0X00800013, "SQ", "ReferencedSurfaceDataSequence"),
    (0X00820001, "CS", "AssessmentSummary"),
    (0X00820003, "UT", "AssessmentSummaryDescription"),
    (0X00820004, "SQ", "AssessedSOPInstanceSequence"),
    (0X00820005, "SQ", "ReferencedComparisonSOPInstanceSequence"),
    (0X00820006, "UL", "NumberOfAssessmentObservations"),
    (0X00820007, "SQ", "AssessmentObservationsSequence"),
    (0X00820008, "CS", "ObservationSignificance"),
    (0X0082000A, "UT", "ObservationDescription"),
    (0X0082000C, "SQ", "StructuredConstraintObservationSequence"),
    (0X00820010, "SQ", "AssessedAttributeValueSequence"),
    (0X00820016, "LO", "AssessmentSetID"),
    (0X00820017, "SQ", "AssessmentRequesterSequence"),
    (0X00820018, "LO", "SelectorAttributeName"),
    (0X00820019, "LO", "SelectorAttributeKeyword"),
    (0X00820021, "SQ", "AssessmentTypeCodeSequence"),
    (0X00820022, "SQ", "ObservationBasisCodeSequence"),
    (0X00820023, "LO", "AssessmentLabel"),
    (0X00820032, "CS", "ConstraintType"),
    (0X00820033, "UT", "SpecificationSelectionGuidance"),
    (0X00820034, "SQ", "ConstraintValueSequence"),
    (0X00820035, "SQ", "RecommendedDefaultValueSequence"),
    (0X00820036, "CS", "ConstraintViolationSignificance"),
    (0X00820037, "UT", "ConstraintViolationCondition"),
    (0X00820038, "CS", "ModifiableConstraintFlag"),
    (0X00880130, "SH", "StorageMediaFileSetID"),
    (0X00880140, "UI", "StorageMediaFileSetUID"),
    (0X00880200, "SQ", "IconImageSequence"),
    (0X00880904, "LO", "TopicTitle"),
    (0X00880906, "ST", "TopicSubject"),
    (0X00880910, "LO", "TopicAuthor"),
    (0X00880912, "LO", "TopicKeywords"),
    (0X01000410, "CS", "SOPInstanceStatus"),
    (0X01000420, "DT", "SOPAuthorizationDateTime"),
    (0X01000424, "LT", "SOPAuthorizationComment"),
    (0X01000426, "LO", "AuthorizationEquipmentCertificationNumber"),
    (0X04000005, "US", "MACIDNumber"),
    (0X04000010, "UI", "MACCalculationTransferSyntaxUID"),
    (0X04000015, "CS", "MACAlgorithm"),
    (0X04000020, "AT", "DataElementsSigned"),
    (0X04000100, "UI", "DigitalSignatureUID"),
    (0X04000105, "DT", "DigitalSignatureDateTime"),
    (0X04000110, "CS", "CertificateType"),
    (0X04000115, "OB", "CertificateOfSigner"),
    (0X04000120, "OB", "Signature"),
    (0X04000305, "CS", "CertifiedTimestampType"),
    (0X04000310, "OB", "CertifiedTimestamp"),
    (0X04000315, "FL", ""),
    (0X04000401, "SQ", "DigitalSignaturePurposeCodeSequence"),
    (0X04000402, "SQ", "ReferencedDigitalSignatureSequence"),
    (0X04000403, "SQ", "ReferencedSOPInstanceMACSequence"),
    (0X04000404, "OB", "MAC"),
    (0X04000500, "SQ", "EncryptedAttributesSequence"),
    (0X04000510, "UI", "EncryptedContentTransferSyntaxUID"),
    (0X04000520, "OB", "EncryptedContent"),
    (0X04000550, "SQ", "ModifiedAttributesSequence"),
    (0X04000551, "SQ", "NonconformingModifiedAttributesSequence"),
    (0X04000552, "OB", "NonconformingDataElementValue"),
    (0X04000561, "SQ", "OriginalAttributesSequence"),
    (0X04000562, "DT", "AttributeModificationDateTime"),
    (0X04000563, "LO", "ModifyingSystem"),
    (0X04000564, "LO", "SourceOfPreviousValues"),
    (0X04000565, "CS", "ReasonForTheAttributeModification"),
    (0X04000600, "CS", "InstanceOriginStatus"),
    (0X20000010, "IS", "NumberOfCopies"),
    (0X2000001E, "SQ", "PrinterConfigurationSequence"),
    (0X20000020, "CS", "PrintPriority"),
    (0X20000030, "CS", "MediumType"),
    (0X20000040, "CS", "FilmDestination"),
    (0X20000050, "LO", "FilmSessionLabel"),
    (0X20000060, "IS", "MemoryAllocation"),
    (0X20000061, "IS", "MaximumMemoryAllocation"),
    (0X20000062, "CS", "ColorImagePrintingFlag"),
    (0X20000063, "CS", "CollationFlag"),
    (0X20000065, "CS", "AnnotationFlag"),
    (0X20000067, "CS", "ImageOverlayFlag"),
    (0X20000069, "CS", "PresentationLUTFlag"),
    (0X2000006A, "CS", "ImageBoxPresentationLUTFlag"),
    (0X200000A0, "US", "MemoryBitDepth"),
    (0X200000A1, "US", "PrintingBitDepth"),
    (0X200000A2, "SQ", "MediaInstalledSequence"),
    (0X200000A4, "SQ", "OtherMediaAvailableSequence"),
    (0X200000A8, "SQ", "SupportedImageDisplayFormatsSequence"),
    (0X20000500, "SQ", "ReferencedFilmBoxSequence"),
    (0X20000510, "SQ", "ReferencedStoredPrintSequence"),
    (0X20100010, "ST", "ImageDisplayFormat"),
    (0X20100030, "CS", "AnnotationDisplayFormatID"),
    (0X20100040, "CS", "FilmOrientation"),
    (0X20100050, "CS", "FilmSizeID"),
    (0X20100052, "CS", "PrinterResolutionID"),
    (0X20100054, "CS", "DefaultPrinterResolutionID"),
    (0X20100060, "CS", "MagnificationType"),
    (0X20100080, "CS", "SmoothingType"),
    (0X201000A6, "CS", "DefaultMagnificationType"),
    (0X201000A7, "CS", "OtherMagnificationTypesAvailable"),
    (0X201000A8, "CS", "DefaultSmoothingType"),
    (0X201000A9, "CS", "OtherSmoothingTypesAvailable"),
    (0X20100100, "CS", "BorderDensity"),
    (0X20100110, "CS", "EmptyImageDensity"),
    (0X20100120, "US", "MinDensity"),
    (0X20100130, "US", "MaxDensity"),
    (0X20100140, "CS", "Trim"),
    (0X20100150, "ST", "ConfigurationInformation"),
    (0X20100152, "LT", "ConfigurationInformationDescription"),
    (0X20100154, "IS", "MaximumCollatedFilms"),
    (0X2010015E, "US", "Illumination"),
    (0X20100160, "US", "ReflectedAmbientLight"),
    (0X20100376, "DS", "PrinterPixelSpacing"),
    (0X20100500, "SQ", "ReferencedFilmSessionSequence"),
    (0X20100510, "SQ", "ReferencedImageBoxSequence"),
    (0X20100520, "SQ", "ReferencedBasicAnnotationBoxSequence"),
    (0X20200010, "US", "ImageBoxPosition"),
    (0X20200020, "CS", "Polarity"),
    (0X20200030, "DS", "RequestedImageSize"),
    (0X20200040, "CS", "RequestedDecimateCropBehavior"),
    (0X20200050, "CS", "RequestedResolutionID"),
    (0X202000A0, "CS", "RequestedImageSizeFlag"),
    (0X202000A2, "CS", "DecimateCropResult"),
    (0X20200110, "SQ", "BasicGrayscaleImageSequence"),
    (0X20200111, "SQ", "BasicColorImageSequence"),
    (0X20200130, "SQ", "ReferencedImageOverlayBoxSequence"),
    (0X20200140, "SQ", "ReferencedVOILUTBoxSequence"),
    (0X20300010, "US", "AnnotationPosition"),
    (0X20300020, "LO", "TextString"),
    (0X20400010, "SQ", "ReferencedOverlayPlaneSequence"),
    (0X20400011, "US", "ReferencedOverlayPlaneGroups"),
    (0X20400020, "SQ", "OverlayPixelDataSequence"),
    (0X20400060, "CS", "OverlayMagnificationType"),
    (0X20400070, "CS", "OverlaySmoothingType"),
    (0X20400072, "CS", "OverlayOrImageMagnification"),
    (0X20400074, "US", "MagnifyToNumberOfColumns"),
    (0X20400080, "CS", "OverlayForegroundDensity"),
    (0X20400082, "CS", "OverlayBackgroundDensity"),
    (0X20400090, "CS", "OverlayMode"),
    (0X20400100, "CS", "ThresholdDensity"),
    (0X20400500, "SQ", "ReferencedImageBoxSequenceRetired"),
    (0X20500010, "SQ", "PresentationLUTSequence"),
    (0X20500020, "CS", "PresentationLUTShape"),
    (0X20500500, "SQ", "ReferencedPresentationLUTSequence"),
    (0X21000010, "SH", "PrintJobID"),
    (0X21000020, "CS", "ExecutionStatus"),
    (0X21000030, "CS", "ExecutionStatusInfo"),
    (0X21000040, "DA", "CreationDate"),
    (0X21000050, "TM", "CreationTime"),
    (0X21000070, "AE", "Originator"),
    (0X21000140, "AE", "DestinationAE"),
    (0X21000160, "SH", "OwnerID"),
    (0X21000170, "IS", "NumberOfFilms"),
    (0X21000500, "SQ", "ReferencedPrintJobSequencePullStoredPrint"),
    (0X21100010, "CS", "PrinterStatus"),
    (0X21100020, "CS", "PrinterStatusInfo"),
    (0X21100030, "LO", "PrinterName"),
    (0X21100099, "SH", "PrintQueueID"),
    (0X21200010, "CS", "QueueStatus"),
    (0X21200050, "SQ", "PrintJobDescriptionSequence"),
    (0X21200070, "SQ", "ReferencedPrintJobSequence"),
    (0X21300010, "SQ", "PrintManagementCapabilitiesSequence"),
    (0X21300015, "SQ", "PrinterCharacteristicsSequence"),
    (0X21300030, "SQ", "FilmBoxContentSequence"),
    (0X21300040, "SQ", "ImageBoxContentSequence"),
    (0X21300050, "SQ", "AnnotationContentSequence"),
    (0X21300060, "SQ", "ImageOverlayBoxContentSequence"),
    (0X21300080, "SQ", "PresentationLUTContentSequence"),
    (0X213000A0, "SQ", "ProposedStudySequence"),
    (0X213000C0, "SQ", "OriginalImageSequence"),
    (0X22000001, "CS", "LabelUsingInformationExtractedFromInstances"),
    (0X22000002, "UT", "LabelText"),
    (0X22000003, "CS", "LabelStyleSelection"),
    (0X22000004, "LT", "MediaDisposition"),
    (0X22000005, "LT", "BarcodeValue"),
    (0X22000006, "CS", "BarcodeSymbology"),
    (0X22000007, "CS", "AllowMediaSplitting"),
    (0X22000008, "CS", "IncludeNonDICOMObjects"),
    (0X22000009, "CS", "IncludeDisplayApplication"),
    (0X2200000A, "CS", "PreserveCompositeInstancesAfterMediaCreation"),
    (0X2200000B, "US", "TotalNumberOfPiecesOfMediaCreated"),
    (0X2200000C, "LO", "RequestedMediaApplicationProfile"),
    (0X2200000D, "SQ", "ReferencedStorageMediaSequence"),
    (0X2200000E, "AT", "FailureAttributes"),
    (0X2200000F, "CS", "AllowLossyCompression"),
    (0X22000020, "CS", "RequestPriority"),
    (0X30020002, "SH", "RTImageLabel"),
    (0X30020003, "LO", "RTImageName"),
    (0X30020004, "ST", "RTImageDescription"),
    (0X3002000A, "CS", "ReportedValuesOrigin"),
    (0X3002000C, "CS", "RTImagePlane"),
    (0X3002000D, "DS", "XRayImageReceptorTranslation"),
    (0X3002000E, "DS", "XRayImageReceptorAngle"),
    (0X30020010, "DS", "RTImageOrientation"),
    (0X30020011, "DS", "ImagePlanePixelSpacing"),
    (0X30020012, "DS", "RTImagePosition"),
    (0X30020020, "SH", "RadiationMachineName"),
    (0X30020022, "DS", "RadiationMachineSAD"),
    (0X30020024, "DS", "RadiationMachineSSD"),
    (0X30020026, "DS", "RTImageSID"),
    (0X30020028, "DS", "SourceToReferenceObjectDistance"),
    (0X30020029, "IS", "FractionNumber"),
    (0X30020030, "SQ", "ExposureSequence"),
    (0X30020032, "DS", "MetersetExposure"),
    (0X30020034, "DS", "DiaphragmPosition"),
    (0X30020040, "SQ", "FluenceMapSequence"),
    (0X30020041, "CS", "FluenceDataSource"),
    (0X30020042, "DS", "FluenceDataScale"),
    (0X30020050, "SQ", "PrimaryFluenceModeSequence"),
    (0X30020051, "CS", "FluenceMode"),
    (0X30020052, "SH", "FluenceModeID"),
    (0X30040001, "CS", "DVHType"),
    (0X30040002, "CS", "DoseUnits"),
    (0X30040004, "CS", "DoseType"),
    (0X30040005, "CS", "SpatialTransformOfDose"),
    (0X30040006, "LO", "DoseComment"),
    (0X30040008, "DS", "NormalizationPoint"),
    (0X3004000A, "CS", "DoseSummationType"),
    (0X3004000C, "DS", "GridFrameOffsetVector"),
    (0X3004000E, "DS", "DoseGridScaling"),
    (0X30040010, "SQ", "RTDoseROISequence"),
    (0X30040012, "DS", "DoseValue"),
    (0X30040014, "CS", "TissueHeterogeneityCorrection"),
    (0X30040040, "DS", "DVHNormalizationPoint"),
    (0X30040042, "DS", "DVHNormalizationDoseValue"),
    (0X30040050, "SQ", "DVHSequence"),
    (0X30040052, "DS", "DVHDoseScaling"),
    (0X30040054, "CS", "DVHVolumeUnits"),
    (0X30040056, "IS", "DVHNumberOfBins"),
    (0X30040058, "DS", "DVHData"),
    (0X30040060, "SQ", "DVHReferencedROISequence"),
    (0X30040062, "CS", "DVHROIContributionType"),
    (0X30040070, "DS", "DVHMinimumDose"),
    (0X30040072, "DS", "DVHMaximumDose"),
    (0X30040074, "DS", "DVHMeanDose"),
    (0X30060002, "SH", "StructureSetLabel"),
    (0X30060004, "LO", "StructureSetName"),
    (0X30060006, "ST", "StructureSetDescription"),
    (0X30060008, "DA", "StructureSetDate"),
    (0X30060009, "TM", "StructureSetTime"),
    (0X30060010, "SQ", "ReferencedFrameOfReferenceSequence"),
    (0X30060012, "SQ", "RTReferencedStudySequence"),
    (0X30060014, "SQ", "RTReferencedSeriesSequence"),
    (0X30060016, "SQ", "ContourImageSequence"),
    (0X30060018, "SQ", "PredecessorStructureSetSequence"),
    (0X30060020, "SQ", "StructureSetROISequence"),
    (0X30060022, "IS", "ROINumber"),
    (0X30060024, "UI", "ReferencedFrameOfReferenceUID"),
    (0X30060026, "LO", "ROIName"),
    (0X30060028, "ST", "ROIDescription"),
    (0X3006002A, "IS", "ROIDisplayColor"),
    (0X3006002C, "DS", "ROIVolume"),
    (0X30060030, "SQ", "RTRelatedROISequence"),
    (0X30060033, "CS", "RTROIRelationship"),
    (0X30060036, "CS", "ROIGenerationAlgorithm"),
    (0X30060037, "SQ", "ROIDerivationAlgorithmIdentificationSequence"),
    (0X30060038, "LO", "ROIGenerationDescription"),
    (0X30060039, "SQ", "ROIContourSequence"),
    (0X30060040, "SQ", "ContourSequence"),
    (0X30060042, "CS", "ContourGeometricType"),
    (0X30060044, "DS", "ContourSlabThickness"),
    (0X30060045, "DS", "ContourOffsetVector"),
    (0X30060046, "IS", "NumberOfContourPoints"),
    (0X30060048, "IS", "ContourNumber"),
    (0X30060049, "IS", "AttachedContours"),
    (0X3006004A, "SQ", "SourcePixelPlanesCharacteristicsSequence"),
    (0X30060050, "DS", "ContourData"),
    (0X30060080, "SQ", "RTROIObservationsSequence"),
    (0X30060082, "IS", "ObservationNumber"),
    (0X30060084, "IS", "ReferencedROINumber"),
    (0X30060085, "SH", "ROIObservationLabel"),
    (0X30060086, "SQ", "RTROIIdentificationCodeSequence"),
    (0X30060088, "ST", "ROIObservationDescription"),
    (0X300600A0, "SQ", "RelatedRTROIObservationsSequence"),
    (0X300600A4, "CS", "RTROIInterpretedType"),
    (0X300600A6, "PN", "ROIInterpreter"),
    (0X300600B0, "SQ", "ROIPhysicalPropertiesSequence"),
    (0X300600B2, "CS", "ROIPhysicalProperty"),
    (0X300600B4, "DS", "ROIPhysicalPropertyValue"),
    (0X300600B6, "SQ", "ROIElementalCompositionSequence"),
    (0X300600B7, "US", "ROIElementalCompositionAtomicNumber"),
    (0X300600B8, "FL", "ROIElementalCompositionAtomicMassFraction"),
    (0X300600B9, "SQ", "AdditionalRTROIIdentificationCodeSequence"),
    (0X300600C0, "SQ", "FrameOfReferenceRelationshipSequence"),
    (0X300600C2, "UI", "RelatedFrameOfReferenceUID"),
    (0X300600C4, "CS", "FrameOfReferenceTransformationType"),
    (0X300600C6, "DS", "FrameOfReferenceTransformationMatrix"),
    (0X300600C8, "LO", "FrameOfReferenceTransformationComment"),
    (0X300600C9, "SQ", "PatientLocationCoordinatesSequence"),
    (0X300600CA, "SQ", "PatientLocationCoordinatesCodeSequence"),
    (0X300600CB, "SQ", "PatientSupportPositionSequence"),
    (0X30080010, "SQ", "MeasuredDoseReferenceSequence"),
    (0X30080012, "ST", "MeasuredDoseDescription"),
    (0X30080014, "CS", "MeasuredDoseType"),
    (0X30080016, "DS", "MeasuredDoseValue"),
    (0X30080020, "SQ", "TreatmentSessionBeamSequence"),
    (0X30080021, "SQ", "TreatmentSessionIonBeamSequence"),
    (0X30080022, "IS", "CurrentFractionNumber"),
    (0X30080024, "DA", "TreatmentControlPointDate"),
    (0X30080025, "TM", "TreatmentControlPointTime"),
    (0X3008002A, "CS", "TreatmentTerminationStatus"),
    (0X3008002B, "SH", "TreatmentTerminationCode"),
    (0X3008002C, "CS", "TreatmentVerificationStatus"),
    (0X30080030, "SQ", "ReferencedTreatmentRecordSequence"),
    (0X30080032, "DS", "SpecifiedPrimaryMeterset"),
    (0X30080033, "DS", "SpecifiedSecondaryMeterset"),
    (0X30080036, "DS", "DeliveredPrimaryMeterset"),
    (0X30080037, "DS", "DeliveredSecondaryMeterset"),
    (0X3008003A, "DS", "SpecifiedTreatmentTime"),
    (0X3008003B, "DS", "DeliveredTreatmentTime"),
    (0X30080040, "SQ", "ControlPointDeliverySequence"),
    (0X30080041, "SQ", "IonControlPointDeliverySequence"),
    (0X30080042, "DS", "SpecifiedMeterset"),
    (0X30080044, "DS", "DeliveredMeterset"),
    (0X30080045, "FL", "MetersetRateSet"),
    (0X30080046, "FL", "MetersetRateDelivered"),
    (0X30080047, "FL", "ScanSpotMetersetsDelivered"),
    (0X30080048, "DS", "DoseRateDelivered"),
    (0X30080050, "SQ", "TreatmentSummaryCalculatedDoseReferenceSequence"),
    (0X30080052, "DS", "CumulativeDoseToDoseReference"),
    (0X30080054, "DA", "FirstTreatmentDate"),
    (0X30080056, "DA", "MostRecentTreatmentDate"),
    (0X3008005A, "IS", "NumberOfFractionsDelivered"),
    (0X30080060, "SQ", "OverrideSequence"),
    (0X30080061, "AT", "ParameterSequencePointer"),
    (0X30080062, "AT", "OverrideParameterPointer"),
    (0X30080063, "IS", "ParameterItemIndex"),
    (0X30080064, "IS", "MeasuredDoseReferenceNumber"),
    (0X30080065, "AT", "ParameterPointer"),
    (0X30080066, "ST", "OverrideReason"),
    (0X30080067, "US", "ParameterValueNumber"),
    (0X30080068, "SQ", "CorrectedParameterSequence"),
    (0X3008006A, "FL", "CorrectionValue"),
    (0X30080070, "SQ", "CalculatedDoseReferenceSequence"),
    (0X30080072, "IS", "CalculatedDoseReferenceNumber"),
    (0X30080074, "ST", "CalculatedDoseReferenceDescription"),
    (0X30080076, "DS", "CalculatedDoseReferenceDoseValue"),
    (0X30080078, "DS", "StartMeterset"),
    (0X3008007A, "DS", "EndMeterset"),
    (0X30080080, "SQ", "ReferencedMeasuredDoseReferenceSequence"),
    (0X30080082, "IS", "ReferencedMeasuredDoseReferenceNumber"),
    (0X30080090, "SQ", "ReferencedCalculatedDoseReferenceSequence"),
    (0X30080092, "IS", "ReferencedCalculatedDoseReferenceNumber"),
    (0X300800A0, "SQ", "BeamLimitingDeviceLeafPairsSequence"),
    (0X300800B0, "SQ", "RecordedWedgeSequence"),
    (0X300800C0, "SQ", "RecordedCompensatorSequence"),
    (0X300800D0, "SQ", "RecordedBlockSequence"),
    (0X300800E0, "SQ", "TreatmentSummaryMeasuredDoseReferenceSequence"),
    (0X300800F0, "SQ", "RecordedSnoutSequence"),
    (0X300800F2, "SQ", "RecordedRangeShifterSequence"),
    (0X300800F4, "SQ", "RecordedLateralSpreadingDeviceSequence"),
    (0X300800F6, "SQ", "RecordedRangeModulatorSequence"),
    (0X30080100, "SQ", "RecordedSourceSequence"),
    (0X30080105, "LO", "SourceSerialNumber"),
    (0X30080110, "SQ", "TreatmentSessionApplicationSetupSequence"),
    (0X30080116, "CS", "ApplicationSetupCheck"),
    (0X30080120, "SQ", "RecordedBrachyAccessoryDeviceSequence"),
    (0X30080122, "IS", "ReferencedBrachyAccessoryDeviceNumber"),
    (0X30080130, "SQ", "RecordedChannelSequence"),
    (0X30080132, "DS", "SpecifiedChannelTotalTime"),
    (0X30080134, "DS", "DeliveredChannelTotalTime"),
    (0X30080136, "IS", "SpecifiedNumberOfPulses"),
    (0X30080138, "IS", "DeliveredNumberOfPulses"),
    (0X3008013A, "DS", "SpecifiedPulseRepetitionInterval"),
    (0X3008013C, "DS", "DeliveredPulseRepetitionInterval"),
    (0X30080140, "SQ", "RecordedSourceApplicatorSequence"),
    (0X30080142, "IS", "ReferencedSourceApplicatorNumber"),
    (0X30080150, "SQ", "RecordedChannelShieldSequence"),
    (0X30080152, "IS", "ReferencedChannelShieldNumber"),
    (0X30080160, "SQ", "BrachyControlPointDeliveredSequence"),
    (0X30080162, "DA", "SafePositionExitDate"),
    (0X30080164, "TM", "SafePositionExitTime"),
    (0X30080166, "DA", "SafePositionReturnDate"),
    (0X30080168, "TM", "SafePositionReturnTime"),
    (0X30080171, "SQ", "PulseSpecificBrachyControlPointDeliveredSequence"),
    (0X30080172, "US", "PulseNumber"),
    (0X30080173, "SQ", "BrachyPulseControlPointDeliveredSequence"),
    (0X30080200, "CS", "CurrentTreatmentStatus"),
    (0X30080202, "ST", "TreatmentStatusComment"),
    (0X30080220, "SQ", "FractionGroupSummarySequence"),
    (0X30080223, "IS", "ReferencedFractionNumber"),
    (0X30080224, "CS", "FractionGroupType"),
    (0X30080230, "CS", "BeamStopperPosition"),
    (0X30080240, "SQ", "FractionStatusSummarySequence"),
    (0X30080250, "DA", "TreatmentDate"),
    (0X30080251, "TM", "TreatmentTime"),
    (0X300A0002, "SH", "RTPlanLabel"),
    (0X300A0003, "LO", "RTPlanName"),
    (0X300A0004, "ST", "RTPlanDescription"),
    (0X300A0006, "DA", "RTPlanDate"),
    (0X300A0007, "TM", "RTPlanTime"),
    (0X300A0009, "LO", "TreatmentProtocols"),
    (0X300A000A, "CS", "PlanIntent"),
    (0X300A000B, "LO", "TreatmentSites"),
    (0X300A000C, "CS", "RTPlanGeometry"),
    (0X300A000E, "ST", "PrescriptionDescription"),
    (0X300A0010, "SQ", "DoseReferenceSequence"),
    (0X300A0012, "IS", "DoseReferenceNumber"),
    (0X300A0013, "UI", "DoseReferenceUID"),
    (0X300A0014, "CS", "DoseReferenceStructureType"),
    (0X300A0015, "CS", "NominalBeamEnergyUnit"),
    (0X300A0016, "LO", "DoseReferenceDescription"),
    (0X300A0018, "DS", "DoseReferencePointCoordinates"),
    (0X300A001A, "DS", "NominalPriorDose"),
    (0X300A0020, "CS", "DoseReferenceType"),
    (0X300A0021, "DS", "ConstraintWeight"),
    (0X300A0022, "DS", "DeliveryWarningDose"),
    (0X300A0023, "DS", "DeliveryMaximumDose"),
    (0X300A0025, "DS", "TargetMinimumDose"),
    (0X300A0026, "DS", "TargetPrescriptionDose"),
    (0X300A0027, "DS", "TargetMaximumDose"),
    (0X300A0028, "DS", "TargetUnderdoseVolumeFraction"),
    (0X300A002A, "DS", "OrganAtRiskFullVolumeDose"),
    (0X300A002B, "DS", "OrganAtRiskLimitDose"),
    (0X300A002C, "DS", "OrganAtRiskMaximumDose"),
    (0X300A002D, "DS", "OrganAtRiskOverdoseVolumeFraction"),
    (0X300A0040, "SQ", "ToleranceTableSequence"),
    (0X300A0042, "IS", "ToleranceTableNumber"),
    (0X300A0043, "SH", "ToleranceTableLabel"),
    (0X300A0044, "DS", "GantryAngleTolerance"),
    (0X300A0046, "DS", "BeamLimitingDeviceAngleTolerance"),
    (0X300A0048, "SQ", "BeamLimitingDeviceToleranceSequence"),
    (0X300A004A, "DS", "BeamLimitingDevicePositionTolerance"),
    (0X300A004B, "FL", "SnoutPositionTolerance"),
    (0X300A004C, "DS", "PatientSupportAngleTolerance"),
    (0X300A004E, "DS", "TableTopEccentricAngleTolerance"),
    (0X300A004F, "FL", "TableTopPitchAngleTolerance"),
    (0X300A0050, "FL", "TableTopRollAngleTolerance"),
    (0X300A0051, "DS", "TableTopVerticalPositionTolerance"),
    (0X300A0052, "DS", "TableTopLongitudinalPositionTolerance"),
    (0X300A0053, "DS", "TableTopLateralPositionTolerance"),
    (0X300A0055, "CS", "RTPlanRelationship"),
    (0X300A0070, "SQ", "FractionGroupSequence"),
    (0X300A0071, "IS", "FractionGroupNumber"),
    (0X300A0072, "LO", "FractionGroupDescription"),
    (0X300A0078, "IS", "NumberOfFractionsPlanned"),
    (0X300A0079, "IS", "NumberOfFractionPatternDigitsPerDay"),
    (0X300A007A, "IS", "RepeatFractionCycleLength"),
    (0X300A007B, "LT", "FractionPattern"),
    (0X300A0080, "IS", "NumberOfBeams"),
    (0X300A0082, "DS", "BeamDoseSpecificationPoint"),
    (0X300A0083, "UI", "ReferencedDoseReferenceUID"),
    (0X300A0084, "DS", "BeamDose"),
    (0X300A0086, "DS", "BeamMeterset"),
    (0X300A0088, "FL", "BeamDosePointDepth"),
    (0X300A0089, "FL", "BeamDosePointEquivalentDepth"),
    (0X300A008A, "FL", "BeamDosePointSSD"),
    (0X300A008B, "CS", "BeamDoseMeaning"),
    (0X300A008C, "SQ", "BeamDoseVerificationControlPointSequence"),
    (0X300A008D, "FL", "AverageBeamDosePointDepth"),
    (0X300A008E, "FL", "AverageBeamDosePointEquivalentDepth"),
    (0X300A008F, "FL", "AverageBeamDosePointSSD"),
    (0X300A0090, "CS", "BeamDoseType"),
    (0X300A0091, "DS", "AlternateBeamDose"),
    (0X300A0092, "CS", "AlternateBeamDoseType"),
    (0X300A0093, "CS", "DepthValueAveragingFlag"),
    (0X300A0094, "DS", "BeamDosePointSourceToExternalContourDistance"),
    (0X300A00A0, "IS", "NumberOfBrachyApplicationSetups"),
    (0X300A00A2, "DS", "BrachyApplicationSetupDoseSpecificationPoint"),
    (0X300A00A4, "DS", "BrachyApplicationSetupDose"),
    (0X300A00B0, "SQ", "BeamSequence"),
    (0X300A00B2, "SH", "TreatmentMachineName"),
    (0X300A00B3, "CS", "PrimaryDosimeterUnit"),
    (0X300A00B4, "DS", "SourceAxisDistance"),
    (0X300A00B6, "SQ", "BeamLimitingDeviceSequence"),
    (0X300A00B8, "CS", "RTBeamLimitingDeviceType"),
    (0X300A00BA, "DS", "SourceToBeamLimitingDeviceDistance"),
    (0X300A00BB, "FL", "IsocenterToBeamLimitingDeviceDistance"),
    (0X300A00BC, "IS", "NumberOfLeafJawPairs"),
    (0X300A00BE, "DS", "LeafPositionBoundaries"),
    (0X300A00C0, "IS", "BeamNumber"),
    (0X300A00C2, "LO", "BeamName"),
    (0X300A00C3, "ST", "BeamDescription"),
    (0X300A00C4, "CS", "BeamType"),
    (0X300A00C5, "FD", "BeamDeliveryDurationLimit"),
    (0X300A00C6, "CS", "RadiationType"),
    (0X300A00C7, "CS", "HighDoseTechniqueType"),
    (0X300A00C8, "IS", "ReferenceImageNumber"),
    (0X300A00CA, "SQ", "PlannedVerificationImageSequence"),
    (0X300A00CC, "LO", "ImagingDeviceSpecificAcquisitionParameters"),
    (0X300A00CE, "CS", "TreatmentDeliveryType"),
    (0X300A00D0, "IS", "NumberOfWedges"),
    (0X300A00D1, "SQ", "WedgeSequence"),
    (0X300A00D2, "IS", "WedgeNumber"),
    (0X300A00D3, "CS", "WedgeType"),
    (0X300A00D4, "SH", "WedgeID"),
    (0X300A00D5, "IS", "WedgeAngle"),
    (0X300A00D6, "DS", "WedgeFactor"),
    (0X300A00D7, "FL", "TotalWedgeTrayWaterEquivalentThickness"),
    (0X300A00D8, "DS", "WedgeOrientation"),
    (0X300A00D9, "FL", "IsocenterToWedgeTrayDistance"),
    (0X300A00DA, "DS", "SourceToWedgeTrayDistance"),
    (0X300A00DB, "FL", "WedgeThinEdgePosition"),
    (0X300A00DC, "SH", "BolusID"),
    (0X300A00DD, "ST", "BolusDescription"),
    (0X300A00DE, "DS", "EffectiveWedgeAngle"),
    (0X300A00E0, "IS", "NumberOfCompensators"),
    (0X300A00E1, "SH", "MaterialID"),
    (0X300A00E2, "DS", "TotalCompensatorTrayFactor"),
    (0X300A00E3, "SQ", "CompensatorSequence"),
    (0X300A00E4, "IS", "CompensatorNumber"),
    (0X300A00E5, "SH", "CompensatorID"),
    (0X300A00E6, "DS", "SourceToCompensatorTrayDistance"),
    (0X300A00E7, "IS", "CompensatorRows"),
    (0X300A00E8, "IS", "CompensatorColumns"),
    (0X300A00E9, "DS", "CompensatorPixelSpacing"),
    (0X300A00EA, "DS", "CompensatorPosition"),
    (0X300A00EB, "DS", "CompensatorTransmissionData"),
    (0X300A00EC, "DS", "CompensatorThicknessData"),
    (0X300A00ED, "IS", "NumberOfBoli"),
    (0X300A00EE, "CS", "CompensatorType"),
    (0X300A00EF, "SH", "CompensatorTrayID"),
    (0X300A00F0, "IS", "NumberOfBlocks"),
    (0X300A00F2, "DS", "TotalBlockTrayFactor"),
    (0X300A00F3, "FL", "TotalBlockTrayWaterEquivalentThickness"),
    (0X300A00F4, "SQ", "BlockSequence"),
    (0X300A00F5, "SH", "BlockTrayID"),
    (0X300A00F6, "DS", "SourceToBlockTrayDistance"),
    (0X300A00F7, "FL", "IsocenterToBlockTrayDistance"),
    (0X300A00F8, "CS", "BlockType"),
    (0X300A00F9, "LO", "AccessoryCode"),
    (0X300A00FA, "CS", "BlockDivergence"),
    (0X300A00FB, "CS", "BlockMountingPosition"),
    (0X300A00FC, "IS", "BlockNumber"),
    (0X300A00FE, "LO", "BlockName"),
    (0X300A0100, "DS", "BlockThickness"),
    (0X300A0102, "DS", "BlockTransmission"),
    (0X300A0104, "IS", "BlockNumberOfPoints"),
    (0X300A0106, "DS", "BlockData"),
    (0X300A0107, "SQ", "ApplicatorSequence"),
    (0X300A0108, "SH", "ApplicatorID"),
    (0X300A0109, "CS", "ApplicatorType"),
    (0X300A010A, "LO", "ApplicatorDescription"),
    (0X300A010C, "DS", "CumulativeDoseReferenceCoefficient"),
    (0X300A010E, "DS", "FinalCumulativeMetersetWeight"),
    (0X300A0110, "IS", "NumberOfControlPoints"),
    (0X300A0111, "SQ", "ControlPointSequence"),
    (0X300A0112, "IS", "ControlPointIndex"),
    (0X300A0114, "DS", "NominalBeamEnergy"),
    (0X300A0115, "DS", "DoseRateSet"),
    (0X300A0116, "SQ", "WedgePositionSequence"),
    (0X300A0118, "CS", "WedgePosition"),
    (0X300A011A, "SQ", "BeamLimitingDevicePositionSequence"),
    (0X300A011C, "DS", "LeafJawPositions"),
    (0X300A011E, "DS", "GantryAngle"),
    (0X300A011F, "CS", "GantryRotationDirection"),
    (0X300A0120, "DS", "BeamLimitingDeviceAngle"),
    (0X300A0121, "CS", "BeamLimitingDeviceRotationDirection"),
    (0X300A0122, "DS", "PatientSupportAngle"),
    (0X300A0123, "CS", "PatientSupportRotationDirection"),
    (0X300A0124, "DS", "TableTopEccentricAxisDistance"),
    (0X300A0125, "DS", "TableTopEccentricAngle"),
    (0X300A0126, "CS", "TableTopEccentricRotationDirection"),
    (0X300A0128, "DS", "TableTopVerticalPosition"),
    (0X300A0129, "DS", "TableTopLongitudinalPosition"),
    (0X300A012A, "DS", "TableTopLateralPosition"),
    (0X300A012C, "DS", "IsocenterPosition"),
    (0X300A012E, "DS", "SurfaceEntryPoint"),
    (0X300A0130, "DS", "SourceToSurfaceDistance"),
    (0X300A0131, "FL", "AverageBeamDosePointSourceToExternalContourDistance"),
    (0X300A0132, "FL", "SourceToExternalContourDistance"),
    (0X300A0133, "FL", "ExternalContourEntryPoint"),
    (0X300A0134, "DS", "CumulativeMetersetWeight"),
    (0X300A0140, "FL", "TableTopPitchAngle"),
    (0X300A0142, "CS", "TableTopPitchRotationDirection"),
    (0X300A0144, "FL", "TableTopRollAngle"),
    (0X300A0146, "CS", "TableTopRollRotationDirection"),
    (0X300A0148, "FL", "HeadFixationAngle"),
    (0X300A014A, "FL", "GantryPitchAngle"),
    (0X300A014C, "CS", "GantryPitchRotationDirection"),
    (0X300A014E, "FL", "GantryPitchAngleTolerance"),
    (0X300A0150, "CS", "FixationEye"),
    (0X300A0151, "DS", "ChairHeadFramePosition"),
    (0X300A0152, "DS", "HeadFixationAngleTolerance"),
    (0X300A0153, "DS", "ChairHeadFramePositionTolerance"),
    (0X300A0154, "DS", "FixationLightAzimuthalAngleTolerance"),
    (0X300A0155, "DS", "FixationLightPolarAngleTolerance"),
    (0X300A0180, "SQ", "PatientSetupSequence"),
    (0X300A0182, "IS", "PatientSetupNumber"),
    (0X300A0183, "LO", "PatientSetupLabel"),
    (0X300A0184, "LO", "PatientAdditionalPosition"),
    (0X300A0190, "SQ", "FixationDeviceSequence"),
    (0X300A0192, "CS", "FixationDeviceType"),
    (0X300A0194, "SH", "FixationDeviceLabel"),
    (0X300A0196, "ST", "FixationDeviceDescription"),
    (0X300A0198, "SH", "FixationDevicePosition"),
    (0X300A0199, "FL", "FixationDevicePitchAngle"),
    (0X300A019A, "FL", "FixationDeviceRollAngle"),
    (0X300A01A0, "SQ", "ShieldingDeviceSequence"),
    (0X300A01A2, "CS", "ShieldingDeviceType"),
    (0X300A01A4, "SH", "ShieldingDeviceLabel"),
    (0X300A01A6, "ST", "ShieldingDeviceDescription"),
    (0X300A01A8, "SH", "ShieldingDevicePosition"),
    (0X300A01B0, "CS", "SetupTechnique"),
    (0X300A01B2, "ST", "SetupTechniqueDescription"),
    (0X300A01B4, "SQ", "SetupDeviceSequence"),
    (0X300A01B6, "CS", "SetupDeviceType"),
    (0X300A01B8, "SH", "SetupDeviceLabel"),
    (0X300A01BA, "ST", "SetupDeviceDescription"),
    (0X300A01BC, "DS", "SetupDeviceParameter"),
    (0X300A01D0, "ST", "SetupReferenceDescription"),
    (0X300A01D2, "DS", "TableTopVerticalSetupDisplacement"),
    (0X300A01D4, "DS", "TableTopLongitudinalSetupDisplacement"),
    (0X300A01D6, "DS", "TableTopLateralSetupDisplacement"),
    (0X300A0200, "CS", "BrachyTreatmentTechnique"),
    (0X300A0202, "CS", "BrachyTreatmentType"),
    (0X300A0206, "SQ", "TreatmentMachineSequence"),
    (0X300A0210, "SQ", "SourceSequence"),
    (0X300A0212, "IS", "SourceNumber"),
    (0X300A0214, "CS", "SourceType"),
    (0X300A0216, "LO", "SourceManufacturer"),
    (0X300A0218, "DS", "ActiveSourceDiameter"),
    (0X300A021A, "DS", "ActiveSourceLength"),
    (0X300A021B, "SH", "SourceModelID"),
    (0X300A021C, "LO", "SourceDescription"),
    (0X300A0222, "DS", "SourceEncapsulationNominalThickness"),
    (0X300A0224, "DS", "SourceEncapsulationNominalTransmission"),
    (0X300A0226, "LO", "SourceIsotopeName"),
    (0X300A0228, "DS", "SourceIsotopeHalfLife"),
    (0X300A0229, "CS", "SourceStrengthUnits"),
    (0X300A022A, "DS", "ReferenceAirKermaRate"),
    (0X300A022B, "DS", "SourceStrength"),
    (0X300A022C, "DA", "SourceStrengthReferenceDate"),
    (0X300A022E, "TM", "SourceStrengthReferenceTime"),
    (0X300A0230, "SQ", "ApplicationSetupSequence"),
    (0X300A0232, "CS", "ApplicationSetupType"),
    (0X300A0234, "IS", "ApplicationSetupNumber"),
    (0X300A0236, "LO", "ApplicationSetupName"),
    (0X300A0238, "LO", "ApplicationSetupManufacturer"),
    (0X300A0240, "IS", "TemplateNumber"),
    (0X300A0242, "SH", "TemplateType"),
    (0X300A0244, "LO", "TemplateName"),
    (0X300A0250, "DS", "TotalReferenceAirKerma"),
    (0X300A0260, "SQ", "BrachyAccessoryDeviceSequence"),
    (0X300A0262, "IS", "BrachyAccessoryDeviceNumber"),
    (0X300A0263, "SH", "BrachyAccessoryDeviceID"),
    (0X300A0264, "CS", "BrachyAccessoryDeviceType"),
    (0X300A0266, "LO", "BrachyAccessoryDeviceName"),
    (0X300A026A, "DS", "BrachyAccessoryDeviceNominalThickness"),
    (0X300A026C, "DS", "BrachyAccessoryDeviceNominalTransmission"),
    (0X300A0271, "DS", "ChannelEffectiveLength"),
    (0X300A0272, "DS", "ChannelInnerLength"),
    (0X300A0273, "SH", "AfterloaderChannelID"),
    (0X300A0274, "DS", "SourceApplicatorTipLength"),
    (0X300A0280, "SQ", "ChannelSequence"),
    (0X300A0282, "IS", "ChannelNumber"),
    (0X300A0284, "DS", "ChannelLength"),
    (0X300A0286, "DS", "ChannelTotalTime"),
    (0X300A0288, "CS", "SourceMovementType"),
    (0X300A028A, "IS", "NumberOfPulses"),
    (0X300A028C, "DS", "PulseRepetitionInterval"),
    (0X300A0290, "IS", "SourceApplicatorNumber"),
    (0X300A0291, "SH", "SourceApplicatorID"),
    (0X300A0292, "CS", "SourceApplicatorType"),
    (0X300A0294, "LO", "SourceApplicatorName"),
    (0X300A0296, "DS", "SourceApplicatorLength"),
    (0X300A0298, "LO", "SourceApplicatorManufacturer"),
    (0X300A029C, "DS", "SourceApplicatorWallNominalThickness"),
    (0X300A029E, "DS", "SourceApplicatorWallNominalTransmission"),
    (0X300A02A0, "DS", "SourceApplicatorStepSize"),
    (0X300A02A1, "IS", "ApplicatorShapeReferencedROINumber"),
    (0X300A02A2, "IS", "TransferTubeNumber"),
    (0X300A02A4, "DS", "TransferTubeLength"),
    (0X300A02B0, "SQ", "ChannelShieldSequence"),
    (0X300A02B2, "IS", "ChannelShieldNumber"),
    (0X300A02B3, "SH", "ChannelShieldID"),
    (0X300A02B4, "LO", "ChannelShieldName"),
    (0X300A02B8, "DS", "ChannelShieldNominalThickness"),
    (0X300A02BA, "DS", "ChannelShieldNominalTransmission"),
    (0X300A02C8, "DS", "FinalCumulativeTimeWeight"),
    (0X300A02D0, "SQ", "BrachyControlPointSequence"),
    (0X300A02D2, "DS", "ControlPointRelativePosition"),
    (0X300A02D4, "DS", "ControlPoint3DPosition"),
    (0X300A02D6, "DS", "CumulativeTimeWeight"),
    (0X300A02E0, "CS", "CompensatorDivergence"),
    (0X300A02E1, "CS", "CompensatorMountingPosition"),
    (0X300A02E2, "DS", "SourceToCompensatorDistance"),
    (0X300A02E3, "FL", "TotalCompensatorTrayWaterEquivalentThickness"),
    (0X300A02E4, "FL", "IsocenterToCompensatorTrayDistance"),
    (0X300A02E5, "FL", "CompensatorColumnOffset"),
    (0X300A02E6, "FL", "IsocenterToCompensatorDistances"),
    (0X300A02E7, "FL", "CompensatorRelativeStoppingPowerRatio"),
    (0X300A02E8, "FL", "CompensatorMillingToolDiameter"),
    (0X300A02EA, "SQ", "IonRangeCompensatorSequence"),
    (0X300A02EB, "LT", "CompensatorDescription"),
    (0X300A0302, "IS", "RadiationMassNumber"),
    (0X300A0304, "IS", "RadiationAtomicNumber"),
    (0X300A0306, "SS", "RadiationChargeState"),
    (0X300A0308, "CS", "ScanMode"),
    (0X300A0309, "CS", "ModulatedScanModeType"),
    (0X300A030A, "FL", "VirtualSourceAxisDistances"),
    (0X300A030C, "SQ", "SnoutSequence"),
    (0X300A030D, "FL", "SnoutPosition"),
    (0X300A030F, "SH", "SnoutID"),
    (0X300A0312, "IS", "NumberOfRangeShifters"),
    (0X300A0314, "SQ", "RangeShifterSequence"),
    (0X300A0316, "IS", "RangeShifterNumber"),
    (0X300A0318, "SH", "RangeShifterID"),
    (0X300A0320, "CS", "RangeShifterType"),
    (0X300A0322, "LO", "RangeShifterDescription"),
    (0X300A0330, "IS", "NumberOfLateralSpreadingDevices"),
    (0X300A0332, "SQ", "LateralSpreadingDeviceSequence"),
    (0X300A0334, "IS", "LateralSpreadingDeviceNumber"),
    (0X300A0336, "SH", "LateralSpreadingDeviceID"),
    (0X300A0338, "CS", "LateralSpreadingDeviceType"),
    (0X300A033A, "LO", "LateralSpreadingDeviceDescription"),
    (0X300A033C, "FL", "LateralSpreadingDeviceWaterEquivalentThickness"),
    (0X300A0340, "IS", "NumberOfRangeModulators"),
    (0X300A0342, "SQ", "RangeModulatorSequence"),
    (0X300A0344, "IS", "RangeModulatorNumber"),
    (0X300A0346, "SH", "RangeModulatorID"),
    (0X300A0348, "CS", "RangeModulatorType"),
    (0X300A034A, "LO", "RangeModulatorDescription"),
    (0X300A034C, "SH", "BeamCurrentModulationID"),
    (0X300A0350, "CS", "PatientSupportType"),
    (0X300A0352, "SH", "PatientSupportID"),
    (0X300A0354, "LO", "PatientSupportAccessoryCode"),
    (0X300A0355, "LO", "TrayAccessoryCode"),
    (0X300A0356, "FL", "FixationLightAzimuthalAngle"),
    (0X300A0358, "FL", "FixationLightPolarAngle"),
    (0X300A035A, "FL", "MetersetRate"),
    (0X300A0360, "SQ", "RangeShifterSettingsSequence"),
    (0X300A0362, "LO", "RangeShifterSetting"),
    (0X300A0364, "FL", "IsocenterToRangeShifterDistance"),
    (0X300A0366, "FL", "RangeShifterWaterEquivalentThickness"),
    (0X300A0370, "SQ", "LateralSpreadingDeviceSettingsSequence"),
    (0X300A0372, "LO", "LateralSpreadingDeviceSetting"),
    (0X300A0374, "FL", "IsocenterToLateralSpreadingDeviceDistance"),
    (0X300A0380, "SQ", "RangeModulatorSettingsSequence"),
    (0X300A0382, "FL", "RangeModulatorGatingStartValue"),
    (0X300A0384, "FL", "RangeModulatorGatingStopValue"),
    (0X300A0386, "FL", "RangeModulatorGatingStartWaterEquivalentThickness"),
    (0X300A0388, "FL", "RangeModulatorGatingStopWaterEquivalentThickness"),
    (0X300A038A, "FL", "IsocenterToRangeModulatorDistance"),
    (0X300A038F, "FL", "ScanSpotTimeOffset"),
    (0X300A0390, "SH", "ScanSpotTuneID"),
    (0X300A0391, "IS", "ScanSpotPrescribedIndices"),
    (0X300A0392, "IS", "NumberOfScanSpotPositions"),
    (0X300A0393, "CS", "ScanSpotReordered"),
    (0X300A0394, "FL", "ScanSpotPositionMap"),
    (0X300A0395, "CS", "ScanSpotReorderingAllowed"),
    (0X300A0396, "FL", "ScanSpotMetersetWeights"),
    (0X300A0398, "FL", "ScanningSpotSize"),
    (0X300A0399, "FL", "ScanSpotSizesDelivered"),
    (0X300A039A, "IS", "NumberOfPaintings"),
    (0X300A03A0, "SQ", "IonToleranceTableSequence"),
    (0X300A03A2, "SQ", "IonBeamSequence"),
    (0X300A03A4, "SQ", "IonBeamLimitingDeviceSequence"),
    (0X300A03A6, "SQ", "IonBlockSequence"),
    (0X300A03A8, "SQ", "IonControlPointSequence"),
    (0X300A03AA, "SQ", "IonWedgeSequence"),
    (0X300A03AC, "SQ", "IonWedgePositionSequence"),
    (0X300A0401, "SQ", "ReferencedSetupImageSequence"),
    (0X300A0402, "ST", "SetupImageComment"),
    (0X300A0410, "SQ", "MotionSynchronizationSequence"),
    (0X300A0412, "FL", "ControlPointOrientation"),
    (0X300A0420, "SQ", "GeneralAccessorySequence"),
    (0X300A0421, "SH", "GeneralAccessoryID"),
    (0X300A0422, "ST", "GeneralAccessoryDescription"),
    (0X300A0423, "CS", "GeneralAccessoryType"),
    (0X300A0424, "IS", "GeneralAccessoryNumber"),
    (0X300A0425, "FL", "SourceToGeneralAccessoryDistance"),
    (0X300A0426, "DS", "IsocenterToGeneralAccessoryDistance"),
    (0X300A0431, "SQ", "ApplicatorGeometrySequence"),
    (0X300A0432, "CS", "ApplicatorApertureShape"),
    (0X300A0433, "FL", "ApplicatorOpening"),
    (0X300A0434, "FL", "ApplicatorOpeningX"),
    (0X300A0435, "FL", "ApplicatorOpeningY"),
    (0X300A0436, "FL", "SourceToApplicatorMountingPositionDistance"),
    (0X300A0440, "IS", "NumberOfBlockSlabItems"),
    (0X300A0441, "SQ", "BlockSlabSequence"),
    (0X300A0442, "DS", "BlockSlabThickness"),
    (0X300A0443, "US", "BlockSlabNumber"),
    (0X300A0450, "SQ", "DeviceMotionControlSequence"),
    (0X300A0451, "CS", "DeviceMotionExecutionMode"),
    (0X300A0452, "CS", "DeviceMotionObservationMode"),
    (0X300A0453, "SQ", "DeviceMotionParameterCodeSequence"),
    (0X300A0501, "FL", "DistalDepthFraction"),
    (0X300A0502, "FL", "DistalDepth"),
    (0X300A0503, "FL", "NominalRangeModulationFractions"),
    (0X300A0504, "FL", "NominalRangeModulatedRegionDepths"),
    (0X300A0505, "SQ", "DepthDoseParametersSequence"),
    (0X300A0506, "SQ", "DeliveredDepthDoseParametersSequence"),
    (0X300A0507, "FL", "DeliveredDistalDepthFraction"),
    (0X300A0508, "FL", "DeliveredDistalDepth"),
    (0X300A0509, "FL", "DeliveredNominalRangeModulationFractions"),
    (0X300A0510, "FL", "DeliveredNominalRangeModulatedRegionDepths"),
    (0X300A0511, "CS", "DeliveredReferenceDoseDefinition"),
    (0X300A0512, "CS", "ReferenceDoseDefinition"),
    (0X300A0600, "US", "RTControlPointIndex"),
    (0X300A0601, "US", "RadiationGenerationModeIndex"),
    (0X300A0602, "US", "ReferencedDefinedDeviceIndex"),
    (0X300A0603, "US", "RadiationDoseIdentificationIndex"),
    (0X300A0604, "US", "NumberOfRTControlPoints"),
    (0X300A0605, "US", "ReferencedRadiationGenerationModeIndex"),
    (0X300A0606, "US", "TreatmentPositionIndex"),
    (0X300A0607, "US", "ReferencedDeviceIndex"),
    (0X300A0608, "LO", "TreatmentPositionGroupLabel"),
    (0X300A0609, "UI", "TreatmentPositionGroupUID"),
    (0X300A060A, "SQ", "TreatmentPositionGroupSequence"),
    (0X300A060B, "US", "ReferencedTreatmentPositionIndex"),
    (0X300A060C, "US", "ReferencedRadiationDoseIdentificationIndex"),
    (0X300A060D, "FD", "RTAccessoryHolderWaterEquivalentThickness"),
    (0X300A060E, "US", "ReferencedRTAccessoryHolderDeviceIndex"),
    (0X300A060F, "CS", "RTAccessoryHolderSlotExistenceFlag"),
    (0X300A0610, "SQ", "RTAccessoryHolderSlotSequence"),
    (0X300A0611, "LO", "RTAccessoryHolderSlotID"),
    (0X300A0612, "FD", "RTAccessoryHolderSlotDistance"),
    (0X300A0613, "FD", "RTAccessorySlotDistance"),
    (0X300A0614, "SQ", "RTAccessoryHolderDefinitionSequence"),
    (0X300A0615, "LO", "RTAccessoryDeviceSlotID"),
    (0X300A0616, "SQ", "RTRadiationSequence"),
    (0X300A0617, "SQ", "RadiationDoseSequence"),
    (0X300A0618, "SQ", "RadiationDoseIdentificationSequence"),
    (0X300A0619, "LO", "RadiationDoseIdentificationLabel"),
    (0X300A061A, "CS", "ReferenceDoseType"),
    (0X300A061B, "CS", "PrimaryDoseValueIndicator"),
    (0X300A061C, "SQ", "DoseValuesSequence"),
    (0X300A061D, "CS", "DoseValuePurpose"),
    (0X300A061E, "FD", "ReferenceDosePointCoordinates"),
    (0X300A061F, "SQ", "RadiationDoseValuesParametersSequence"),
    (0X300A0620, "SQ", "MetersetToDoseMappingSequence"),
    (0X300A0621, "SQ", "ExpectedInVivoMeasurementValuesSequence"),
    (0X300A0622, "US", "ExpectedInVivoMeasurementValueIndex"),
    (0X300A0623, "LO", "RadiationDoseInVivoMeasurementLabel"),
    (0X300A0624, "FD", "RadiationDoseCentralAxisDisplacement"),
    (0X300A0625, "FD", "RadiationDoseValue"),
    (0X300A0626, "FD", "RadiationDoseSourceToSkinDistance"),
    (0X300A0627, "FD", "RadiationDoseMeasurementPointCoordinates"),
    (0X300A0628, "FD", "RadiationDoseSourceToExternalContourDistance"),
    (0X300A0629, "SQ", "RTToleranceSetSequence"),
    (0X300A062A, "LO", "RTToleranceSetLabel"),
    (0X300A062B, "SQ", "AttributeToleranceValuesSequence"),
    (0X300A062C, "FD", "ToleranceValue"),
    (0X300A062D, "SQ", "PatientSupportPositionToleranceSequence"),
    (0X300A062E, "FD", "TreatmentTimeLimit"),
    (0X300A062F, "SQ", "CArmPhotonElectronControlPointSequence"),
    (0X300A0630, "SQ", "ReferencedRTRadiationSequence"),
    (0X300A0631, "SQ", "ReferencedRTInstanceSequence"),
    (0X300A0632, "SQ", "ReferencedRTPatientSetupSequence"),
    (0X300A0634, "FD", "SourceToPatientSurfaceDistance"),
    (0X300A0635, "SQ", "TreatmentMachineSpecialModeCodeSequence"),
    (0X300A0636, "US", "IntendedNumberOfFractions"),
    (0X300A0637, "CS", "RTRadiationSetIntent"),
    (0X300A0638, "CS", "RTRadiationPhysicalAndGeometricContentDetailFlag"),
    (0X300A0639, "CS", "RTRecordFlag"),
    (0X300A063A, "SQ", "TreatmentDeviceIdentificationSequence"),
    (0X300A063B, "SQ", "ReferencedRTPhysicianIntentSequence"),
    (0X300A063C, "FD", "CumulativeMeterset"),
    (0X300A063D, "FD", "DeliveryRate"),
    (0X300A063E, "SQ", "DeliveryRateUnitSequence"),
    (0X300A063F, "SQ", "TreatmentPositionSequence"),
    (0X300A0640, "FD", "RadiationSourceAxisDistance"),
    (0X300A0641, "US", "NumberOfRTBeamLimitingDevices"),
    (0X300A0642, "FD", "RTBeamLimitingDeviceProximalDistance"),
    (0X300A0643, "FD", "RTBeamLimitingDeviceDistalDistance"),
    (0X300A0644, "SQ", "ParallelRTBeamDelimiterDeviceOrientationLabelCodeSequence"),
    (0X300A0645, "FD", "BeamModifierOrientationAngle"),
    (0X300A0646, "SQ", "FixedRTBeamDelimiterDeviceSequence"),
    (0X300A0647, "SQ", "ParallelRTBeamDelimiterDeviceSequence"),
    (0X300A0648, "US", "NumberOfParallelRTBeamDelimiters"),
    (0X300A0649, "FD", "ParallelRTBeamDelimiterBoundaries"),
    (0X300A064A, "FD", "ParallelRTBeamDelimiterPositions"),
    (0X300A064B, "FD", "RTBeamLimitingDeviceOffset"),
    (0X300A064C, "SQ", "RTBeamDelimiterGeometrySequence"),
    (0X300A064D, "SQ", "RTBeamLimitingDeviceDefinitionSequence"),
    (0X300A064E, "CS", "ParallelRTBeamDelimiterOpeningMode"),
    (0X300A064F, "CS", "ParallelRTBeamDelimiterLeafMountingSide"),
    (0X300A0650, "UI", "PatientSetupUID"),
    (0X300A0651, "SQ", "WedgeDefinitionSequence"),
    (0X300A0652, "FD", "RadiationBeamWedgeAngle"),
    (0X300A0653, "FD", "RadiationBeamWedgeThinEdgeDistance"),
    (0X300A0654, "FD", "RadiationBeamEffectiveWedgeAngle"),
    (0X300A0655, "US", "NumberOfWedgePositions"),
    (0X300A0656, "SQ", "RTBeamLimitingDeviceOpeningSequence"),
    (0X300A0657, "US", "NumberOfRTBeamLimitingDeviceOpenings"),
    (0X300A0658, "SQ", "RadiationDosimeterUnitSequence"),
    (0X300A0659, "SQ", "RTDeviceDistanceReferenceLocationCodeSequence"),
    (0X300A065A, "SQ", "RadiationDeviceConfigurationAndCommissioningKeySequence"),
    (0X300A065B, "SQ", "PatientSupportPositionParameterSequence"),
    (0X300A065C, "CS", "PatientSupportPositionSpecificationMethod"),
    (0X300A065D, "SQ", "PatientSupportPositionDeviceParameterSequence"),
    (0X300A065E, "US", "DeviceOrderIndex"),
    (0X300A065F, "US", "PatientSupportPositionParameterOrderIndex"),
    (0X300A0660, "SQ", "PatientSupportPositionDeviceToleranceSequence"),
    (0X300A0661, "US", "PatientSupportPositionToleranceOrderIndex"),
    (0X300A0662, "SQ", "CompensatorDefinitionSequence"),
    (0X300A0663, "CS", "CompensatorMapOrientation"),
    (0X300A0664, "OF", "CompensatorProximalThicknessMap"),
    (0X300A0665, "OF", "CompensatorDistalThicknessMap"),
    (0X300A0666, "FD", "CompensatorBasePlaneOffset"),
    (0X300A0667, "SQ", "CompensatorShapeFabricationCodeSequence"),
    (0X300A0668, "SQ", "CompensatorShapeSequence"),
    (0X300A0669, "FD", "RadiationBeamCompensatorMillingToolDiameter"),
    (0X300A066A, "SQ", "BlockDefinitionSequence"),
    (0X300A066B, "OF", "BlockEdgeData"),
    (0X300A066C, "CS", "BlockOrientation"),
    (0X300A066D, "FD", "RadiationBeamBlockThickness"),
    (0X300A066E, "FD", "RadiationBeamBlockSlabThickness"),
    (0X300A066F, "SQ", "BlockEdgeDataSequence"),
    (0X300A0670, "US", "NumberOfRTAccessoryHolders"),
    (0X300A0671, "SQ", "GeneralAccessoryDefinitionSequence"),
    (0X300A0672, "US", "NumberOfGeneralAccessories"),
    (0X300A0673, "SQ", "BolusDefinitionSequence"),
    (0X300A0674, "US", "NumberOfBoluses"),
    (0X300A0675, "UI", "EquipmentFrameOfReferenceUID"),
    (0X300A0676, "ST", "EquipmentFrameOfReferenceDescription"),
    (0X300A0677, "SQ", "EquipmentReferencePointCoordinatesSequence"),
    (0X300A0678, "SQ", "EquipmentReferencePointCodeSequence"),
    (0X300A0679, "FD", "RTBeamLimitingDeviceAngle"),
    (0X300A067A, "FD", "SourceRollAngle"),
    (0X300A067B, "SQ", "RadiationGenerationModeSequence"),
    (0X300A067C, "SH", "RadiationGenerationModeLabel"),
    (0X300A067D, "ST", "RadiationGenerationModeDescription"),
    (0X300A067E, "SQ", "RadiationGenerationModeMachineCodeSequence"),
    (0X300A067F, "SQ", "RadiationTypeCodeSequence"),
    (0X300A0680, "DS", "NominalEnergy"),
    (0X300A0681, "DS", "MinimumNominalEnergy"),
    (0X300A0682, "DS", "MaximumNominalEnergy"),
    (0X300A0683, "SQ", "RadiationFluenceModifierCodeSequence"),
    (0X300A0684, "SQ", "EnergyUnitCodeSequence"),
    (0X300A0685, "US", "NumberOfRadiationGenerationModes"),
    (0X300A0686, "SQ", "PatientSupportDevicesSequence"),
    (0X300A0687, "US", "NumberOfPatientSupportDevices"),
    (0X300A0688, "FD", "RTBeamModifierDefinitionDistance"),
    (0X300A0689, "SQ", "BeamAreaLimitSequence"),
    (0X300A068A, "SQ", "ReferencedRTPrescriptionSequence"),
    (0X300A0700, "UI", "TreatmentSessionUID"),
    (0X300A0701, "CS", "RTRadiationUsage"),
    (0X300A0702, "SQ", "ReferencedRTRadiationSetSequence"),
    (0X300A0703, "SQ", "ReferencedRTRadiationRecordSequence"),
    (0X300A0704, "US", "RTRadiationSetDeliveryNumber"),
    (0X300A0705, "US", "ClinicalFractionNumber"),
    (0X300A0706, "CS", "RTTreatmentFractionCompletionStatus"),
    (0X300A0707, "CS", "RTRadiationSetUsage"),
    (0X300A0708, "CS", "TreatmentDeliveryContinuationFlag"),
    (0X300A0709, "CS", "TreatmentRecordContentOrigin"),
    (0X300A0714, "CS", "RTTreatmentTerminationStatus"),
    (0X300A0715, "SQ", "RTTreatmentTerminationReasonCodeSequence"),
    (0X300A0716, "SQ", "MachineSpecificTreatmentTerminationCodeSequence"),
    (0X300A0722, "SQ", "RTRadiationSalvageRecordControlPointSequence"),
    (0X300A0723, "CS", "StartingMetersetValueKnownFlag"),
    (0X300A0730, "ST", "TreatmentTerminationDescription"),
    (0X300A0731, "SQ", "TreatmentToleranceViolationSequence"),
    (0X300A0732, "CS", "TreatmentToleranceViolationCategory"),
    (0X300A0733, "SQ", "TreatmentToleranceViolationAttributeSequence"),
    (0X300A0734, "ST", "TreatmentToleranceViolationDescription"),
    (0X300A0735, "ST", "TreatmentToleranceViolationIdentification"),
    (0X300A0736, "DT", "TreatmentToleranceViolationDateTime"),
    (0X300A073A, "DT", "RecordedRTControlPointDateTime"),
    (0X300A073B, "US", "ReferencedRadiationRTControlPointIndex"),
    (0X300A073E, "SQ", "AlternateValueSequence"),
    (0X300A073F, "SQ", "ConfirmationSequence"),
    (0X300A0740, "SQ", "InterlockSequence"),
    (0X300A0741, "DT", "InterlockDateTime"),
    (0X300A0742, "ST", "InterlockDescription"),
    (0X300A0743, "SQ", "InterlockOriginatingDeviceSequence"),
    (0X300A0744, "SQ", "InterlockCodeSequence"),
    (0X300A0745, "SQ", "InterlockResolutionCodeSequence"),
    (0X300A0746, "SQ", "InterlockResolutionUserSequence"),
    (0X300A0760, "DT", "OverrideDateTime"),
    (0X300A0761, "SQ", "TreatmentToleranceViolationTypeCodeSequence"),
    (0X300A0762, "SQ", "TreatmentToleranceViolationCauseCodeSequence"),
    (0X300A0772, "SQ", "MeasuredMetersetToDoseMappingSequence"),
    (0X300A0773, "US", "ReferencedExpectedInVivoMeasurementValueIndex"),
    (0X300A0774, "SQ", "DoseMeasurementDeviceCodeSequence"),
    (0X300A0780, "SQ", "AdditionalParameterRecordingInstanceSequence"),
    (0X300A0782, "US", ""),
    (0X300A0783, "ST", "InterlockOriginDescription"),
    (0X300A0784, "SQ", "RTPatientPositionScopeSequence"),
    (0X300A0785, "UI", "ReferencedTreatmentPositionGroupUID"),
    (0X300A0786, "US", "RadiationOrderIndex"),
    (0X300A0787, "SQ", "OmittedRadiationSequence"),
    (0X300A0788, "SQ", "ReasonforOmissionCodeSequence"),
    (0X300A0789, "SQ", "RTDeliveryStartPatientPositionSequence"),
    (0X300A078A, "SQ", "RTTreatmentPreparationPatientPositionSequence"),
    (0X300A078B, "SQ", "ReferencedRTTreatmentPreparationSequence"),
    (0X300A078C, "SQ", "ReferencedPatientSetupPhotoSequence"),
    (0X300A078D, "SQ", "PatientTreatmentPreparationMethodCodeSequence"),
    (0X300A078E, "LT", "PatientTreatmentPreparationProcedureParameterDescription"),
    (0X300A078F, "SQ", "PatientTreatmentPreparationDeviceSequence"),
    (0X300A0790, "SQ", "PatientTreatmentPreparationProcedureSequence"),
    (0X300A0791, "SQ", "PatientTreatmentPreparationProcedureCodeSequence"),
    (0X300A0792, "LT", "PatientTreatmentPreparationMethodDescription"),
    (0X300A0793, "SQ", "PatientTreatmentPreparationProcedureParameterSequence"),
    (0X300A0794, "LT", "PatientSetupPhotoDescription"),
    (0X300A0795, "US", "PatientTreatmentPreparationProcedureIndex"),
    (0X300A0796, "US", "ReferencedPatientSetupProcedureIndex"),
    (0X300A0797, "SQ", "RTRadiationTaskSequence"),
    (0X300A0798, "SQ", "RTPatientPositionDisplacementSequence"),
    (0X300A0799, "SQ", "RTPatientPositionSequence"),
    (0X300A079A, "LO", "DisplacementReferenceLabel"),
    (0X300A079B, "FD", "DisplacementMatrix"),
    (0X300A079C, "SQ", "PatientSupportDisplacementSequence"),
    (0X300A079D, "SQ", "DisplacementReferenceLocationCodeSequence"),
    (0X300A079E, "CS", "RTRadiationSetDeliveryUsage"),
    (0X300C0002, "SQ", "ReferencedRTPlanSequence"),
    (0X300C0004, "SQ", "ReferencedBeamSequence"),
    (0X300C0006, "IS", "ReferencedBeamNumber"),
    (0X300C0007, "IS", "ReferencedReferenceImageNumber"),
    (0X300C0008, "DS", "StartCumulativeMetersetWeight"),
    (0X300C0009, "DS", "EndCumulativeMetersetWeight"),
    (0X300C000A, "SQ", "ReferencedBrachyApplicationSetupSequence"),
    (0X300C000C, "IS", "ReferencedBrachyApplicationSetupNumber"),
    (0X300C000E, "IS", "ReferencedSourceNumber"),
    (0X300C0020, "SQ", "ReferencedFractionGroupSequence"),
    (0X300C0022, "IS", "ReferencedFractionGroupNumber"),
    (0X300C0040, "SQ", "ReferencedVerificationImageSequence"),
    (0X300C0042, "SQ", "ReferencedReferenceImageSequence"),
    (0X300C0050, "SQ", "ReferencedDoseReferenceSequence"),
    (0X300C0051, "IS", "ReferencedDoseReferenceNumber"),
    (0X300C0055, "SQ", "BrachyReferencedDoseReferenceSequence"),
    (0X300C0060, "SQ", "ReferencedStructureSetSequence"),
    (0X300C006A, "IS", "ReferencedPatientSetupNumber"),
    (0X300C0080, "SQ", "ReferencedDoseSequence"),
    (0X300C00A0, "IS", "ReferencedToleranceTableNumber"),
    (0X300C00B0, "SQ", "ReferencedBolusSequence"),
    (0X300C00C0, "IS", "ReferencedWedgeNumber"),
    (0X300C00D0, "IS", "ReferencedCompensatorNumber"),
    (0X300C00E0, "IS", "ReferencedBlockNumber"),
    (0X300C00F0, "IS", "ReferencedControlPointIndex"),
    (0X300C00F2, "SQ", "ReferencedControlPointSequence"),
    (0X300C00F4, "IS", "ReferencedStartControlPointIndex"),
    (0X300C00F6, "IS", "ReferencedStopControlPointIndex"),
    (0X300C0100, "IS", "ReferencedRangeShifterNumber"),
    (0X300C0102, "IS", "ReferencedLateralSpreadingDeviceNumber"),
    (0X300C0104, "IS", "ReferencedRangeModulatorNumber"),
    (0X300C0111, "SQ", "OmittedBeamTaskSequence"),
    (0X300C0112, "CS", "ReasonForOmission"),
    (0X300C0113, "LO", "ReasonForOmissionDescription"),
    (0X300E0002, "CS", "ApprovalStatus"),
    (0X300E0004, "DA", "ReviewDate"),
    (0X300E0005, "TM", "ReviewTime"),
    (0X300E0008, "PN", "ReviewerName"),
    (0X30100001, "SQ", "RadiobiologicalDoseEffectSequence"),
    (0X30100002, "CS", "RadiobiologicalDoseEffectFlag"),
    (0X30100003, "SQ", "EffectiveDoseCalculationMethodCategoryCodeSequence"),
    (0X30100004, "SQ", "EffectiveDoseCalculationMethodCodeSequence"),
    (0X30100005, "LO", "EffectiveDoseCalculationMethodDescription"),
    (0X30100006, "UI", "ConceptualVolumeUID"),
    (0X30100007, "SQ", "OriginatingSOPInstanceReferenceSequence"),
    (0X30100008, "SQ", "ConceptualVolumeConstituentSequence"),
    (0X30100009, "SQ", "EquivalentConceptualVolumeInstanceReferenceSequence"),
    (0X3010000A, "SQ", "EquivalentConceptualVolumesSequence"),
    (0X3010000B, "UI", "ReferencedConceptualVolumeUID"),
    (0X3010000C, "UT", "ConceptualVolumeCombinationExpression"),
    (0X3010000D, "US", "ConceptualVolumeConstituentIndex"),
    (0X3010000E, "CS", "ConceptualVolumeCombinationFlag"),
    (0X3010000F, "ST", "ConceptualVolumeCombinationDescription"),
    (0X30100010, "CS", "ConceptualVolumeSegmentationDefinedFlag"),
    (0X30100011, "SQ", "ConceptualVolumeSegmentationReferenceSequence"),
    (0X30100012, "SQ", "ConceptualVolumeConstituentSegmentationReferenceSequence"),
    (0X30100013, "UI", "ConstituentConceptualVolumeUID"),
    (0X30100014, "SQ", "DerivationConceptualVolumeSequence"),
    (0X30100015, "UI", "SourceConceptualVolumeUID"),
    (0X30100016, "SQ", "ConceptualVolumeDerivationAlgorithmSequence"),
    (0X30100017, "ST", "ConceptualVolumeDescription"),
    (0X30100018, "SQ", "SourceConceptualVolumeSequence"),
    (0X30100019, "SQ", "AuthorIdentificationSequence"),
    (0X3010001A, "LO", "ManufacturerModelVersion"),
    (0X3010001B, "UC", "DeviceAlternateIdentifier"),
    (0X3010001C, "CS", "DeviceAlternateIdentifierType"),
    (0X3010001D, "LT", "DeviceAlternateIdentifierFormat"),
    (0X3010001E, "LO", "SegmentationCreationTemplateLabel"),
    (0X3010001F, "UI", "SegmentationTemplateUID"),
    (0X30100020, "US", "ReferencedSegmentReferenceIndex"),
    (0X30100021, "SQ", "SegmentReferenceSequence"),
    (0X30100022, "US", "SegmentReferenceIndex"),
    (0X30100023, "SQ", "DirectSegmentReferenceSequence"),
    (0X30100024, "SQ", "CombinationSegmentReferenceSequence"),
    (0X30100025, "SQ", "ConceptualVolumeSequence"),
    (0X30100026, "SQ", "SegmentedRTAccessoryDeviceSequence"),
    (0X30100027, "SQ", "SegmentCharacteristicsSequence"),
    (0X30100028, "SQ", "RelatedSegmentCharacteristicsSequence"),
    (0X30100029, "US", "SegmentCharacteristicsPrecedence"),
    (0X3010002A, "SQ", "RTSegmentAnnotationSequence"),
    (0X3010002B, "SQ", "SegmentAnnotationCategoryCodeSequence"),
    (0X3010002C, "SQ", "SegmentAnnotationTypeCodeSequence"),
    (0X3010002D, "LO", "DeviceLabel"),
    (0X3010002E, "SQ", "DeviceTypeCodeSequence"),
    (0X3010002F, "SQ", "SegmentAnnotationTypeModifierCodeSequence"),
    (0X30100030, "SQ", "PatientEquipmentRelationshipCodeSequence"),
    (0X30100031, "UI", "ReferencedFiducialsUID"),
    (0X30100032, "SQ", "PatientTreatmentOrientationSequence"),
    (0X30100033, "SH", "UserContentLabel"),
    (0X30100034, "LO", "UserContentLongLabel"),
    (0X30100035, "SH", "EntityLabel"),
    (0X30100036, "LO", "EntityName"),
    (0X30100037, "ST", "EntityDescription"),
    (0X30100038, "LO", "EntityLongLabel"),
    (0X30100039, "US", "DeviceIndex"),
    (0X3010003A, "US", "RTTreatmentPhaseIndex"),
    (0X3010003B, "UI", "RTTreatmentPhaseUID"),
    (0X3010003C, "US", "RTPrescriptionIndex"),
    (0X3010003D, "US", "RTSegmentAnnotationIndex"),
    (0X3010003E, "US", "BasisRTTreatmentPhaseIndex"),
    (0X3010003F, "US", "RelatedRTTreatmentPhaseIndex"),
    (0X30100040, "US", "ReferencedRTTreatmentPhaseIndex"),
    (0X30100041, "US", "ReferencedRTPrescriptionIndex"),
    (0X30100042, "US", "ReferencedParentRTPrescriptionIndex"),
    (0X30100043, "ST", "ManufacturerDeviceIdentifier"),
    (0X30100044, "SQ", "InstanceLevelReferencedPerformedProcedureStepSequence"),
    (0X30100045, "CS", "RTTreatmentPhaseIntentPresenceFlag"),
    (0X30100046, "CS", "RadiotherapyTreatmentType"),
    (0X30100047, "CS", "TeletherapyRadiationType"),
    (0X30100048, "CS", "BrachytherapySourceType"),
    (0X30100049, "SQ", "ReferencedRTTreatmentPhaseSequence"),
    (0X3010004A, "SQ", "ReferencedDirectSegmentInstanceSequence"),
    (0X3010004B, "SQ", "IntendedRTTreatmentPhaseSequence"),
    (0X3010004C, "DA", "IntendedPhaseStartDate"),
    (0X3010004D, "DA", "IntendedPhaseEndDate"),
    (0X3010004E, "SQ", "RTTreatmentPhaseIntervalSequence"),
    (0X3010004F, "CS", "TemporalRelationshipIntervalAnchor"),
    (0X30100050, "FD", "MinimumNumberOfIntervalDays"),
    (0X30100051, "FD", "MaximumNumberOfIntervalDays"),
    (0X30100052, "UI", "PertinentSOPClassesInStudy"),
    (0X30100053, "UI", "PertinentSOPClassesInSeries"),
    (0X30100054, "LO", "RTPrescriptionLabel"),
    (0X30100055, "SQ", "RTPhysicianIntentPredecessorSequence"),
    (0X30100056, "LO", "RTTreatmentApproachLabel"),
    (0X30100057, "SQ", "RTPhysicianIntentSequence"),
    (0X30100058, "US", "RTPhysicianIntentIndex"),
    (0X30100059, "CS", "RTTreatmentIntentType"),
    (0X3010005A, "UT", "RTPhysicianIntentNarrative"),
    (0X3010005B, "SQ", "RTProtocolCodeSequence"),
    (0X3010005C, "ST", "ReasonForSuperseding"),
    (0X3010005D, "SQ", "RTDiagnosisCodeSequence"),
    (0X3010005E, "US", "ReferencedRTPhysicianIntentIndex"),
    (0X3010005F, "SQ", "RTPhysicianIntentInputInstanceSequence"),
    (0X30100060, "SQ", "RTAnatomicPrescriptionSequence"),
    (0X30100061, "UT", "PriorTreatmentDoseDescription"),
    (0X30100062, "SQ", "PriorTreatmentReferenceSequence"),
    (0X30100063, "CS", "DosimetricObjectiveEvaluationScope"),
    (0X30100064, "SQ", "TherapeuticRoleCategoryCodeSequence"),
    (0X30100065, "SQ", "TherapeuticRoleTypeCodeSequence"),
    (0X30100066, "US", "ConceptualVolumeOptimizationPrecedence"),
    (0X30100067, "SQ", "ConceptualVolumeCategoryCodeSequence"),
    (0X30100068, "CS", "ConceptualVolumeBlockingConstraint"),
    (0X30100069, "SQ", "ConceptualVolumeTypeCodeSequence"),
    (0X3010006A, "SQ", "ConceptualVolumeTypeModifierCodeSequence"),
    (0X3010006B, "SQ", "RTPrescriptionSequence"),
    (0X3010006C, "SQ", "DosimetricObjectiveSequence"),
    (0X3010006D, "SQ", "DosimetricObjectiveTypeCodeSequence"),
    (0X3010006E, "UI", "DosimetricObjectiveUID"),
    (0X3010006F, "UI", "ReferencedDosimetricObjectiveUID"),
    (0X30100070, "SQ", "DosimetricObjectiveParameterSequence"),
    (0X30100071, "SQ", "ReferencedDosimetricObjectivesSequence"),
    (0X30100073, "CS", "AbsoluteDosimetricObjectiveFlag"),
    (0X30100074, "FD", "DosimetricObjectiveWeight"),
    (0X30100075, "CS", "DosimetricObjectivePurpose"),
    (0X30100076, "SQ", "PlanningInputInformationSequence"),
    (0X30100077, "LO", "TreatmentSite"),
    (0X30100078, "SQ", "TreatmentSiteCodeSequence"),
    (0X30100079, "SQ", "FractionPatternSequence"),
    (0X3010007A, "UT", "TreatmentTechniqueNotes"),
    (0X3010007B, "UT", "PrescriptionNotes"),
    (0X3010007C, "IS", "NumberOfIntervalFractions"),
    (0X3010007D, "US", "NumberOfFractions"),
    (0X3010007E, "US", "IntendedDeliveryDuration"),
    (0X3010007F, "UT", "FractionationNotes"),
    (0X30100080, "SQ", "RTTreatmentTechniqueCodeSequence"),
    (0X30100081, "SQ", "PrescriptionNotesSequence"),
    (0X30100082, "SQ", "FractionBasedRelationshipSequence"),
    (0X30100083, "CS", "FractionBasedRelationshipIntervalAnchor"),
    (0X30100084, "FD", "MinimumHoursBetweenFractions"),
    (0X30100085, "TM", "IntendedFractionStartTime"),
    (0X30100086, "LT", "IntendedStartDayOfWeek"),
    (0X30100087, "SQ", "WeekdayFractionPatternSequence"),
    (0X30100088, "SQ", "DeliveryTimeStructureCodeSequence"),
    (0X30100089, "SQ", "TreatmentSiteModifierCodeSequence"),
    (0X30100090, "CS", "RoboticBaseLocationIndicator"),
    (0X30100091, "SQ", "RoboticPathNodeSetCodeSequence"),
    (0X30100092, "UL", "RoboticNodeIdentifier"),
    (0X30100093, "FD", "RTTreatmentSourceCoordinates"),
    (0X30100094, "FD", "RadiationSourceCoordinateSystemYawAngle"),
    (0X30100095, "FD", "RadiationSourceCoordinateSystemRollAngle"),
    (0X30100096, "FD", "RadiationSourceCoordinateSystemPitchAngle"),
    (0X30100097, "SQ", "RoboticPathControlPointSequence"),
    (0X30100098, "SQ", "TomotherapeuticControlPointSequence"),
    (0X30100099, "FD", "TomotherapeuticLeafOpenDurations"),
    (0X3010009A, "FD", "TomotherapeuticLeafInitialClosedDurations"),
    (0X40000010, "LT", "Arbitrary"),
    (0X40004000, "LT", "TextComments"),
    (0X40080040, "SH", "ResultsID"),
    (0X40080042, "LO", "ResultsIDIssuer"),
    (0X40080050, "SQ", "ReferencedInterpretationSequence"),
    (0X400800FF, "CS", "ReportProductionStatusTrial"),
    (0X40080100, "DA", "InterpretationRecordedDate"),
    (0X40080101, "TM", "InterpretationRecordedTime"),
    (0X40080102, "PN", "InterpretationRecorder"),
    (0X40080103, "LO", "ReferenceToRecordedSound"),
    (0X40080108, "DA", "InterpretationTranscriptionDate"),
    (0X40080109, "TM", "InterpretationTranscriptionTime"),
    (0X4008010A, "PN", "InterpretationTranscriber"),
    (0X4008010B, "ST", "InterpretationText"),
    (0X4008010C, "PN", "InterpretationAuthor"),
    (0X40080111, "SQ", "InterpretationApproverSequence"),
    (0X40080112, "DA", "InterpretationApprovalDate"),
    (0X40080113, "TM", "InterpretationApprovalTime"),
    (0X40080114, "PN", "PhysicianApprovingInterpretation"),
    (0X40080115, "LT", "InterpretationDiagnosisDescription"),
    (0X40080117, "SQ", "InterpretationDiagnosisCodeSequence"),
    (0X40080118, "SQ", "ResultsDistributionListSequence"),
    (0X40080119, "PN", "DistributionName"),
    (0X4008011A, "LO", "DistributionAddress"),
    (0X40080200, "SH", "InterpretationID"),
    (0X40080202, "LO", "InterpretationIDIssuer"),
    (0X40080210, "CS", "InterpretationTypeID"),
    (0X40080212, "CS", "InterpretationStatusID"),
    (0X40080300, "ST", "Impressions"),
    (0X40084000, "ST", "ResultsComments"),
    (0X40100001, "CS", "LowEnergyDetectors"),
    (0X40100002, "CS", "HighEnergyDetectors"),
    (0X40100004, "SQ", "DetectorGeometrySequence"),
    (0X40101001, "SQ", "ThreatROIVoxelSequence"),
    (0X40101004, "FL", "ThreatROIBase"),
    (0X40101005, "FL", "ThreatROIExtents"),
    (0X40101006, "OB", "ThreatROIBitmap"),
    (0X40101007, "SH", "RouteSegmentID"),
    (0X40101008, "CS", "GantryType"),
    (0X40101009, "CS", "OOIOwnerType"),
    (0X4010100A, "SQ", "RouteSegmentSequence"),
    (0X40101010, "US", "PotentialThreatObjectID"),
    (0X40101011, "SQ", "ThreatSequence"),
    (0X40101012, "CS", "ThreatCategory"),
    (0X40101013, "LT", "ThreatCategoryDescription"),
    (0X40101014, "CS", "ATDAbilityAssessment"),
    (0X40101015, "CS", "ATDAssessmentFlag"),
    (0X40101016, "FL", "ATDAssessmentProbability"),
    (0X40101017, "FL", "Mass"),
    (0X40101018, "FL", "Density"),
    (0X40101019, "FL", "ZEffective"),
    (0X4010101A, "SH", "BoardingPassID"),
    (0X4010101B, "FL", "CenterOfMass"),
    (0X4010101C, "FL", "CenterOfPTO"),
    (0X4010101D, "FL", "BoundingPolygon"),
    (0X4010101E, "SH", "RouteSegmentStartLocationID"),
    (0X4010101F, "SH", "RouteSegmentEndLocationID"),
    (0X40101020, "CS", "RouteSegmentLocationIDType"),
    (0X40101021, "CS", "AbortReason"),
    (0X40101023, "FL", "VolumeOfPTO"),
    (0X40101024, "CS", "AbortFlag"),
    (0X40101025, "DT", "RouteSegmentStartTime"),
    (0X40101026, "DT", "RouteSegmentEndTime"),
    (0X40101027, "CS", "TDRType"),
    (0X40101028, "CS", "InternationalRouteSegment"),
    (0X40101029, "LO", "ThreatDetectionAlgorithmAndVersion"),
    (0X4010102A, "SH", "AssignedLocation"),
    (0X4010102B, "DT", "AlarmDecisionTime"),
    (0X40101031, "CS", "AlarmDecision"),
    (0X40101033, "US", "NumberOfTotalObjects"),
    (0X40101034, "US", "NumberOfAlarmObjects"),
    (0X40101037, "SQ", "PTORepresentationSequence"),
    (0X40101038, "SQ", "ATDAssessmentSequence"),
    (0X40101039, "CS", "TIPType"),
    (0X4010103A, "CS", "DICOSVersion"),
    (0X40101041, "DT", "OOIOwnerCreationTime"),
    (0X40101042, "CS", "OOIType"),
    (0X40101043, "FL", "OOISize"),
    (0X40101044, "CS", "AcquisitionStatus"),
    (0X40101045, "SQ", "BasisMaterialsCodeSequence"),
    (0X40101046, "CS", "PhantomType"),
    (0X40101047, "SQ", "OOIOwnerSequence"),
    (0X40101048, "CS", "ScanType"),
    (0X40101051, "LO", "ItineraryID"),
    (0X40101052, "SH", "ItineraryIDType"),
    (0X40101053, "LO", "ItineraryIDAssigningAuthority"),
    (0X40101054, "SH", "RouteID"),
    (0X40101055, "SH", "RouteIDAssigningAuthority"),
    (0X40101056, "CS", "InboundArrivalType"),
    (0X40101058, "SH", "CarrierID"),
    (0X40101059, "CS", "CarrierIDAssigningAuthority"),
    (0X40101060, "FL", "SourceOrientation"),
    (0X40101061, "FL", "SourcePosition"),
    (0X40101062, "FL", "BeltHeight"),
    (0X40101064, "SQ", "AlgorithmRoutingCodeSequence"),
    (0X40101067, "CS", "TransportClassification"),
    (0X40101068, "LT", "OOITypeDescriptor"),
    (0X40101069, "FL", "TotalProcessingTime"),
    (0X4010106C, "OB", "DetectorCalibrationData"),
    (0X4010106D, "CS", "AdditionalScreeningPerformed"),
    (0X4010106E, "CS", "AdditionalInspectionSelectionCriteria"),
    (0X4010106F, "SQ", "AdditionalInspectionMethodSequence"),
    (0X40101070, "CS", "AITDeviceType"),
    (0X40101071, "SQ", "QRMeasurementsSequence"),
    (0X40101072, "SQ", "TargetMaterialSequence"),
    (0X40101073, "FD", "SNRThreshold"),
    (0X40101075, "DS", "ImageScaleRepresentation"),
    (0X40101076, "SQ", "ReferencedPTOSequence"),
    (0X40101077, "SQ", "ReferencedTDRInstanceSequence"),
    (0X40101078, "ST", "PTOLocationDescription"),
    (0X40101079, "SQ", "AnomalyLocatorIndicatorSequence"),
    (0X4010107A, "FL", "AnomalyLocatorIndicator"),
    (0X4010107B, "SQ", "PTORegionSequence"),
    (0X4010107C, "CS", "InspectionSelectionCriteria"),
    (0X4010107D, "SQ", "SecondaryInspectionMethodSequence"),
    (0X4010107E, "DS", "PRCSToRCSOrientation"),
    (0X4FFE0001, "SQ", "MACParametersSequence"),
    (0X52009229, "SQ", "SharedFunctionalGroupsSequence"),
    (0X52009230, "SQ", "PerFrameFunctionalGroupsSequence"),
    (0X54000100, "SQ", "WaveformSequence"),
    (0X54000110, "OW", "ChannelMinimumValue"),
    (0X54000112, "OW", "ChannelMaximumValue"),
    (0X54001004, "US", "WaveformBitsAllocated"),
    (0X54001006, "CS", "WaveformSampleInterpretation"),
    (0X5400100A, "OW", "WaveformPaddingValue"),
    (0X54001010, "OW", "WaveformData"),
    (0X56000010, "OF", "FirstOrderPhaseCorrectionAngle"),
    (0X56000020, "OF", "SpectroscopyData"),
    (0X7FE00001, "OV", "ExtendedOffsetTable"),
    (0X7FE00002, "OV", "ExtendedOffsetTableLengths"),
    (0X7FE00008, "OF", "FloatPixelData"),
    (0X7FE00009, "OD", "DoubleFloatPixelData"),
    (0X7FE00010, "OW", "PixelData"),
    (0X7FE00020, "OW", "CoefficientsSDVN"),
    (0X7FE00030, "OW", "CoefficientsSDHN"),
    (0X7FE00040, "OW", "CoefficientsSDDN"),
    (0XFFFAFFFA, "SQ", "DigitalSignaturesSequence"),
    (0XFFFCFFFC, "OB", "DataSetTrailingPadding"),
    (0XFFFEE000, "error", "Item"),
    (0XFFFEE00D, "error", "ItemDelimitationItem"),
    (0XFFFEE0DD, "error", "SequenceDelimitationItem"),
];


